/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.28 from the
 * contents of MPFR.xs. Do not edit this file, edit MPFR.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "MPFR.xs"

#ifdef  __MINGW32__
#ifndef __USE_MINGW_ANSI_STDIO
#define __USE_MINGW_ANSI_STDIO 1
#endif
#endif

#define PERL_NO_GET_CONTEXT 1

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"


#include <stdio.h>

#if defined MATH_MPFR_NEED_LONG_LONG_INT
#ifndef _MSC_VER
#include <inttypes.h>
#endif
#endif


#include <gmp.h>
#include <mpfr.h>
#include <float.h>

#ifdef MPFR_WANT_FLOAT128
#include <quadmath.h>
#if defined(NV_IS_FLOAT128) && defined(MPFR_VERSION) && MPFR_VERSION >= MPFR_VERSION_NUM(3,2,0)
#define CAN_PASS_FLOAT128
#endif
#if defined(__MINGW32__) && !defined(__MINGW64__)
typedef __float128 float128 __attribute__ ((aligned(32)));
#elif defined(__MINGW64__)
typedef __float128 float128 __attribute__ ((aligned(8)));
#else
typedef __float128 float128;
#endif
#endif

#if LDBL_MANT_DIG == 106
#define REQUIRED_LDBL_MANT_DIG 2098
#else
#define REQUIRED_LDBL_MANT_DIG LDBL_MANT_DIG
#endif

#if defined(MPFR_VERSION_MAJOR) && MPFR_VERSION_MAJOR >= 3
#define MAXIMUM_ALLOWABLE_BASE 62
#else
#define MAXIMUM_ALLOWABLE_BASE 36
#endif

#if MPFR_VERSION_MAJOR < 3
#define CHECK_ROUNDING_VALUE \
 if((mp_rnd_t)SvUV(round) > 3) \
  croak("Illegal rounding value supplied for this version (%s) of the mpfr library", MPFR_VERSION_STRING);
#else
#define CHECK_ROUNDING_VALUE
#endif

#define NEG_ZERO_BUG 196866 /* A bug affecting mpfr_fits_u*_p functions         */
                            /* Fixed in mpfr after MPFR_VERSION 196866 (3.1.2)  */
                            /* For earlier versions of mpfr, we fix this bug in */
                            /* our own code                                     */

#define LNGAMMA_BUG 196867  /* lngamma(-0) set to NaN instead of +Inf           */
                            /* Fixed in mpfr after MPFR_VERSION 196867 (3.1.3)  */
                            /* For earlier versions of mpfr, we fix this bug in */
                            /* our own code                                     */

/* Squash some annoying compiler warnings (Microsoft compilers only). */

#ifdef _MSC_VER
#pragma warning(disable:4700 4715 4716)
#endif

#ifdef OLDPERL
#define SvUOK SvIsUV
#endif

#ifndef Newx
#  define Newx(v,n,t) New(0,v,n,t)
#endif

#ifndef Newxz
#  define Newxz(v,n,t) Newz(0,v,n,t)
#endif

/* May one day be removed from mpfr.h */
#ifndef mp_rnd_t
# define mp_rnd_t  mpfr_rnd_t
#endif
#ifndef mp_prec_t
# define mp_prec_t mpfr_prec_t
#endif

#ifndef __gmpfr_default_rounding_mode
#define __gmpfr_default_rounding_mode mpfr_get_default_rounding_mode()
#endif

#if !defined(__GNU_MP_VERSION) || __GNU_MP_VERSION < 5
#define mp_bitcnt_t unsigned long int
#endif

int nnum = 0; /* flag that is incremented whenever a string containing
                 non-numeric characters is treated as a number */

/* Has inttypes.h been included ? */
int _has_inttypes(void) {
#ifdef _MSC_VER
return 0;
#else
#if defined MATH_MPFR_NEED_LONG_LONG_INT
return 1;
#else
return 0;
#endif
#endif
}

int NNW_val(pTHX) {
  /* return the numeric value of $Math::MPFR::NNW */
  return SvIV(get_sv("Math::MPFR::NNW", 0));
}

void Rmpfr_set_default_rounding_mode(pTHX_ SV * round) {
     CHECK_ROUNDING_VALUE
     mpfr_set_default_rounding_mode((mp_rnd_t)SvUV(round));
}

unsigned long Rmpfr_get_default_rounding_mode(void) {
     return __gmpfr_default_rounding_mode;
}

SV * Rmpfr_prec_round(pTHX_ mpfr_t * p, SV * prec, SV * round) {
     return newSViv(mpfr_prec_round(*p, (mpfr_prec_t)SvIV(prec), (mp_rnd_t)SvUV(round)));
}

void DESTROY(pTHX_ mpfr_t * p) {
     mpfr_clear(*p);
     Safefree(p);
}

void Rmpfr_clear(pTHX_ mpfr_t * p) {
     mpfr_clear(*p);
     Safefree(p);
}

void Rmpfr_clear_mpfr(mpfr_t * p) {
     mpfr_clear(*p);
}

void Rmpfr_clear_ptr(pTHX_ mpfr_t * p) {
     Safefree(p);
}

void Rmpfr_clears(pTHX_ SV * p, ...) {
     dXSARGS;
     unsigned long i;
     for(i = 0; i < items; i++) {
        mpfr_clear(*(INT2PTR(mpfr_t *, SvIV(SvRV(ST(i))))));
        Safefree(INT2PTR(mpfr_t *, SvIV(SvRV(ST(i)))));
     }
     XSRETURN(0);
}

SV * Rmpfr_init(pTHX) {
     mpfr_t * mpfr_t_obj;
     SV * obj_ref, * obj;

     Newx(mpfr_t_obj, 1, mpfr_t);
     if(mpfr_t_obj == NULL) croak("Failed to allocate memory in Rmpfr_init function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::MPFR");
     mpfr_init(*mpfr_t_obj);

     sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
     SvREADONLY_on(obj);
     return obj_ref;
}

SV * Rmpfr_init2(pTHX_ SV * prec) {
     mpfr_t * mpfr_t_obj;
     SV * obj_ref, * obj;

     Newx(mpfr_t_obj, 1, mpfr_t);
     if(mpfr_t_obj == NULL) croak("Failed to allocate memory in Rmpfr_init2 function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::MPFR");
     mpfr_init2 (*mpfr_t_obj, (mpfr_prec_t)SvIV(prec));

     sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
     SvREADONLY_on(obj);
     return obj_ref;
}

SV * Rmpfr_init_nobless(pTHX) {
     mpfr_t * mpfr_t_obj;
     SV * obj_ref, * obj;

     Newx(mpfr_t_obj, 1, mpfr_t);
     if(mpfr_t_obj == NULL) croak("Failed to allocate memory in Rmpfr_init_nobless function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, NULL);
     mpfr_init(*mpfr_t_obj);

     sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
     SvREADONLY_on(obj);
     return obj_ref;
}

SV * Rmpfr_init2_nobless(pTHX_ SV * prec) {
     mpfr_t * mpfr_t_obj;
     SV * obj_ref, * obj;

     Newx(mpfr_t_obj, 1, mpfr_t);
     if(mpfr_t_obj == NULL) croak("Failed to allocate memory in Rmpfr_init2_nobless function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, NULL);
     mpfr_init2 (*mpfr_t_obj, (mpfr_prec_t)SvIV(prec));

     sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
     SvREADONLY_on(obj);
     return obj_ref;
}

void Rmpfr_init_set(pTHX_ mpfr_t * q, SV * round) {
     dXSARGS;
     mpfr_t * mpfr_t_obj;
     SV * obj_ref, * obj;
     int ret;

     CHECK_ROUNDING_VALUE

     /* sp = mark; *//* not needed */

     Newx(mpfr_t_obj, 1, mpfr_t);
     if(mpfr_t_obj == NULL) croak("Failed to allocate memory in Rmpfr_init_set function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::MPFR");
     ret = mpfr_init_set(*mpfr_t_obj, *q, (mp_rnd_t)SvUV(round));

     sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
     SvREADONLY_on(obj);
     ST(0) = sv_2mortal(obj_ref);
     ST(1) = sv_2mortal(newSViv(ret));
     /* PUTBACK; *//* not needed */
     XSRETURN(2);
}

void Rmpfr_init_set_ui(pTHX_ SV * q, SV * round) {
     dXSARGS;
     mpfr_t * mpfr_t_obj;
     SV * obj_ref, * obj;
     int ret;

     CHECK_ROUNDING_VALUE

     /* sp = mark; *//* not needed */

     Newx(mpfr_t_obj, 1, mpfr_t);
     if(mpfr_t_obj == NULL) croak("Failed to allocate memory in Rmpfr_init_set_ui function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::MPFR");
     ret = mpfr_init_set_ui(*mpfr_t_obj, (unsigned long)SvUV(q), (mp_rnd_t)SvUV(round));

     sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
     SvREADONLY_on(obj);
     ST(0) = sv_2mortal(obj_ref);
     ST(1) = sv_2mortal(newSViv(ret));
     /* PUTBACK; *//* not needed */
     XSRETURN(2);
}

void Rmpfr_init_set_si(pTHX_ SV * q, SV * round) {
     dXSARGS;
     mpfr_t * mpfr_t_obj;
     SV * obj_ref, * obj;
     int ret;

     CHECK_ROUNDING_VALUE

     /* sp = mark; *//* not needed */

     Newx(mpfr_t_obj, 1, mpfr_t);
     if(mpfr_t_obj == NULL) croak("Failed to allocate memory in Rmpfr_init_set_si function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::MPFR");
     ret = mpfr_init_set_si(*mpfr_t_obj, (long)SvIV(q), (mp_rnd_t)SvUV(round));

     sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
     SvREADONLY_on(obj);
     ST(0) = sv_2mortal(obj_ref);
     ST(1) = sv_2mortal(newSViv(ret));
     /* PUTBACK; *//* not needed */
     XSRETURN(2);
}

void Rmpfr_init_set_d(pTHX_ SV * q, SV * round) {
     dXSARGS;
     mpfr_t * mpfr_t_obj;
     SV * obj_ref, * obj;
     int ret;

     CHECK_ROUNDING_VALUE

     /* sp =  mark; *//* not needed */

     Newx(mpfr_t_obj, 1, mpfr_t);
     if(mpfr_t_obj == NULL) croak("Failed to allocate memory in Rmpfr_init_set_d function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::MPFR");
     ret = mpfr_init_set_d(*mpfr_t_obj, (double)SvNV(q), (mp_rnd_t)SvUV(round));

     sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
     SvREADONLY_on(obj);
     ST(0) = sv_2mortal(obj_ref);
     ST(1) = sv_2mortal(newSViv(ret));
     /* PUTBACK; *//* not needed */
     XSRETURN(2);
}

void Rmpfr_init_set_ld(pTHX_ SV * q, SV * round) {
#ifdef USE_LONG_DOUBLE
#ifndef _MSC_VER
     dXSARGS;
     mpfr_t * mpfr_t_obj;
     SV * obj_ref, * obj;
     int ret;

     CHECK_ROUNDING_VALUE

     /* sp = mark; *//* not needed */

     Newx(mpfr_t_obj, 1, mpfr_t);
     if(mpfr_t_obj == NULL) croak("Failed to allocate memory in Rmpfr_init_set_d function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::MPFR");
     ret = mpfr_init_set_ld(*mpfr_t_obj, (long double)SvNV(q), (mp_rnd_t)SvUV(round));
     sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
     SvREADONLY_on(obj);
     ST(0) = sv_2mortal(obj_ref);
     ST(1) = sv_2mortal(newSViv(ret));
     /* PUTBACK; *//* not needed */
     XSRETURN(2);
#else
     croak("Rmpfr_init_set_ld not implemented on this build of perl - use Rmpfr_init_set_d instead");
#endif
#else
     croak("Rmpfr_init_set_ld not implemented on this build of perl");
#endif
}

void Rmpfr_init_set_f(pTHX_ mpf_t * q, SV * round) {
     dXSARGS;
     mpfr_t * mpfr_t_obj;
     SV * obj_ref, * obj;
     int ret;

     CHECK_ROUNDING_VALUE

     /* sp = mark; *//* not needed */

     Newx(mpfr_t_obj, 1, mpfr_t);
     if(mpfr_t_obj == NULL) croak("Failed to allocate memory in Rmpfr_init_set_f function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::MPFR");
     ret = mpfr_init_set_f(*mpfr_t_obj, *q, (mp_rnd_t)SvUV(round));

     sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
     SvREADONLY_on(obj);
     ST(0) = sv_2mortal(obj_ref);
     ST(1) = sv_2mortal(newSViv(ret));
     /* PUTBACK; *//* not needed */
     XSRETURN(2);
}

void Rmpfr_init_set_z(pTHX_ mpz_t * q, SV * round) {
     dXSARGS;
     mpfr_t * mpfr_t_obj;
     SV * obj_ref, * obj;
     int ret;

     CHECK_ROUNDING_VALUE

     /* sp = mark; *//* not needed */

     Newx(mpfr_t_obj, 1, mpfr_t);
     if(mpfr_t_obj == NULL) croak("Failed to allocate memory in Rmpfr_init_set_z function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::MPFR");
     ret = mpfr_init_set_z(*mpfr_t_obj, *q, (mp_rnd_t)SvUV(round));

     sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
     SvREADONLY_on(obj);
     ST(0) = sv_2mortal(obj_ref);
     ST(1) = sv_2mortal(newSViv(ret));
     /* PUTBACK; *//* not needed */
     XSRETURN(2);
}

void Rmpfr_init_set_q(pTHX_ mpq_t * q, SV * round) {
     dXSARGS;
     mpfr_t * mpfr_t_obj;
     SV * obj_ref, * obj;
     int ret;

     CHECK_ROUNDING_VALUE

     /* sp = mark; *//* not needed */

     Newx(mpfr_t_obj, 1, mpfr_t);
     if(mpfr_t_obj == NULL) croak("Failed to allocate memory in Rmpfr_init_set_q function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::MPFR");
     ret = mpfr_init_set_q(*mpfr_t_obj, *q, (mp_rnd_t)SvUV(round));

     sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
     SvREADONLY_on(obj);
     ST(0) = sv_2mortal(obj_ref);
     ST(1) = sv_2mortal(newSViv(ret));
     /* PUTBACK; *//* not needed */
     XSRETURN(2);
}

void Rmpfr_init_set_str(pTHX_ SV * q, SV * base, SV * round) {
     dXSARGS;
     mpfr_t * mpfr_t_obj;
     SV * obj_ref, * obj;
     int ret = (int)SvIV(base);

     CHECK_ROUNDING_VALUE

     /* sp = mark; *//* not needed */

     if(ret < 0 || ret > MAXIMUM_ALLOWABLE_BASE || ret == 1)
        croak("2nd argument supplied to Rmpfr_init_set str is out of allowable range");

     Newx(mpfr_t_obj, 1, mpfr_t);
     if(mpfr_t_obj == NULL) croak("Failed to allocate memory in Rmpfr_init_set_str function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::MPFR");
     sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
     SvREADONLY_on(obj);
     ret = mpfr_init_set_str(*mpfr_t_obj, SvPV_nolen(q), ret, (mp_rnd_t)SvUV(round));
     if(ret) {
       nnum++;
       if(SvIV(get_sv("Math::MPFR::NNW", 0)))
         warn("1st arg given to Rmpfr_init_set_str contains non-numeric characters");
     }

     ST(0) = sv_2mortal(obj_ref);
     ST(1) = sv_2mortal(newSViv(ret));
     /* PUTBACK; *//* not needed */
     XSRETURN(2);
}

void Rmpfr_init_set_nobless(pTHX_ mpfr_t * q, SV * round) {
     dXSARGS;
     mpfr_t * mpfr_t_obj;
     SV * obj_ref, * obj;
     int ret;

     CHECK_ROUNDING_VALUE

     /* sp = mark; *//* not needed */

     Newx(mpfr_t_obj, 1, mpfr_t);
     if(mpfr_t_obj == NULL) croak("Failed to allocate memory in Rmpfr_init_set_nobless function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, NULL);
     ret = mpfr_init_set(*mpfr_t_obj, *q, (mp_rnd_t)SvUV(round));

     sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
     SvREADONLY_on(obj);
     ST(0) = sv_2mortal(obj_ref);
     ST(1) = sv_2mortal(newSViv(ret));
     /* PUTBACK; *//* not needed */
     XSRETURN(2);
}

void Rmpfr_init_set_ui_nobless(pTHX_ SV * q, SV * round) {
     dXSARGS;
     mpfr_t * mpfr_t_obj;
     SV * obj_ref, * obj;
     int ret;

     CHECK_ROUNDING_VALUE

     /* sp  = mark; *//* not needed */

     Newx(mpfr_t_obj, 1, mpfr_t);
     if(mpfr_t_obj == NULL) croak("Failed to allocate memory in Rmpfr_init_set_ui_nobless function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, NULL);
     ret = mpfr_init_set_ui(*mpfr_t_obj, (unsigned long)SvUV(q), (mp_rnd_t)SvUV(round));

     sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
     SvREADONLY_on(obj);
     ST(0) = sv_2mortal(obj_ref);
     ST(1) = sv_2mortal(newSViv(ret));
     /* PUTBACK; *//* not needed */
     XSRETURN(2);
}

void Rmpfr_init_set_si_nobless(pTHX_ SV * q, SV * round) {
     dXSARGS;
     mpfr_t * mpfr_t_obj;
     SV * obj_ref, * obj;
     int ret;

     CHECK_ROUNDING_VALUE

     /* sp = mark; *//* not needed */

     Newx(mpfr_t_obj, 1, mpfr_t);
     if(mpfr_t_obj == NULL) croak("Failed to allocate memory in Rmpfr_init_set_si_nobless function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, NULL);
     ret = mpfr_init_set_si(*mpfr_t_obj, (long)SvIV(q), (mp_rnd_t)SvUV(round));

     sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
     SvREADONLY_on(obj);
     ST(0) = sv_2mortal(obj_ref);
     ST(1) = sv_2mortal(newSViv(ret));
     /* PUTBACK; *//* not needed */
     XSRETURN(2);
}

void Rmpfr_init_set_d_nobless(pTHX_ SV * q, SV * round) {
     dXSARGS;
     mpfr_t * mpfr_t_obj;
     SV * obj_ref, * obj;
     int ret;

     CHECK_ROUNDING_VALUE

     /* sp = mark; *//* not needed */

     Newx(mpfr_t_obj, 1, mpfr_t);
     if(mpfr_t_obj == NULL) croak("Failed to allocate memory in Rmpfr_init_set_d_nobless function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, NULL);
     ret = mpfr_init_set_d(*mpfr_t_obj, (double)SvNV(q), (mp_rnd_t)SvUV(round));

     sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
     SvREADONLY_on(obj);
     ST(0) = sv_2mortal(obj_ref);
     ST(1) = sv_2mortal(newSViv(ret));
     /* PUTBACK; *//* not needed */
     XSRETURN(2);
}

void Rmpfr_init_set_ld_nobless(pTHX_ SV * q, SV * round) {
#ifdef USE_LONG_DOUBLE
#ifndef _MSC_VER
     dXSARGS;
     mpfr_t * mpfr_t_obj;
     SV * obj_ref, * obj;
     int ret;

     CHECK_ROUNDING_VALUE

     /* sp = mark; *//* not needed */

     Newx(mpfr_t_obj, 1, mpfr_t);
     if(mpfr_t_obj == NULL) croak("Failed to allocate memory in Rmpfr_init_set_d_nobless function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, NULL);
     ret = mpfr_init_set_ld(*mpfr_t_obj, (long double)SvNV(q), (mp_rnd_t)SvUV(round));
     sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
     SvREADONLY_on(obj);
     ST(0) = sv_2mortal(obj_ref);
     ST(1) = sv_2mortal(newSViv(ret));
     /* PUTBACK; *//* not needed */
     XSRETURN(2);
#else
     croak("Rmpfr_init_set_ld_nobless not implemented on this build of perl - use Rmpfr_init_set_d_nobless instead");
#endif
#else
     croak("Rmpfr_init_set_ld_nobless not implemented on this build of perl");
#endif
}

void Rmpfr_init_set_f_nobless(pTHX_ mpf_t * q, SV * round) {
     dXSARGS;
     mpfr_t * mpfr_t_obj;
     SV * obj_ref, * obj;
     int ret;

     CHECK_ROUNDING_VALUE

     /* sp = mark; *//* not needed */

     Newx(mpfr_t_obj, 1, mpfr_t);
     if(mpfr_t_obj == NULL) croak("Failed to allocate memory in Rmpfr_init_set_f_nobless function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, NULL);
     ret = mpfr_init_set_f(*mpfr_t_obj, *q, (mp_rnd_t)SvUV(round));

     sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
     SvREADONLY_on(obj);
     ST(0) = sv_2mortal(obj_ref);
     ST(1)  = sv_2mortal(newSViv(ret));
     /* PUTBACK; *//* not needed */
     XSRETURN(2);
}

void Rmpfr_init_set_z_nobless(pTHX_ mpz_t * q, SV * round) {
     dXSARGS;
     mpfr_t * mpfr_t_obj;
     SV * obj_ref, * obj;
     int ret;

     CHECK_ROUNDING_VALUE

     /* sp  = mark; *//* not needed */

     Newx(mpfr_t_obj, 1, mpfr_t);
     if(mpfr_t_obj == NULL) croak("Failed to allocate memory in Rmpfr_init_set_z_nobless function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, NULL);
     ret = mpfr_init_set_z(*mpfr_t_obj, *q, (mp_rnd_t)SvUV(round));

     sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
     SvREADONLY_on(obj);
     ST(0) = sv_2mortal(obj_ref);
     ST(1) = sv_2mortal(newSViv(ret));
     /* PUTBACK; *//* not needed */
     XSRETURN(2);
}

void Rmpfr_init_set_q_nobless(pTHX_ mpq_t * q, SV * round) {
     dXSARGS;
     mpfr_t * mpfr_t_obj;
     SV * obj_ref, * obj;
     int ret;

     CHECK_ROUNDING_VALUE

     /* sp = mark; *//* not needed */

     Newx(mpfr_t_obj, 1, mpfr_t);
     if(mpfr_t_obj == NULL) croak("Failed to allocate memory in Rmpfr_init_set_q_nobless function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, NULL);
     ret = mpfr_init_set_q(*mpfr_t_obj, *q, (mp_rnd_t)SvUV(round));

     sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
     SvREADONLY_on(obj);
     ST(0) = sv_2mortal(obj_ref);
     ST(1) = sv_2mortal(newSViv(ret));
     /* PUTBACK; *//* not needed */
     XSRETURN(2);
}

void Rmpfr_init_set_str_nobless(pTHX_ SV * q, SV * base, SV * round) {
     dXSARGS;
     mpfr_t * mpfr_t_obj;
     SV * obj_ref, * obj;
     int ret = (int)SvIV(base);

     CHECK_ROUNDING_VALUE

     if(ret < 0 || ret > MAXIMUM_ALLOWABLE_BASE || ret == 1)
        croak("2nd argument supplied to Rmpfr_init_set_str_nobless is out of allowable range");

     /* sp = mark; *//* not needed */

     Newx(mpfr_t_obj, 1, mpfr_t);
     if(mpfr_t_obj == NULL) croak("Failed to allocate memory in Rmpfr_init_set_str_nobless function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, NULL);
     sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
     SvREADONLY_on(obj);
     ret = mpfr_init_set_str(*mpfr_t_obj, SvPV_nolen(q), ret, (mp_rnd_t)SvUV(round));
     if(ret) {
       nnum++;
       if(SvIV(get_sv("Math::MPFR::NNW", 0)))
         warn("1st arg given to Rmpfr_init_set_str_nobless contains non-numeric characters");
     }

     ST(0) = sv_2mortal(obj_ref);
     ST(1) = sv_2mortal(newSViv(ret));
     /* PUTBACK; *//* not needed */
     XSRETURN(2);
}

void Rmpfr_deref2(pTHX_ mpfr_t * p, SV * base, SV * n_digits, SV * round) {
     dXSARGS;
     char * out;
     mp_exp_t ptr;
     unsigned long b = (unsigned long)SvUV(base);

     CHECK_ROUNDING_VALUE

     if(b < 2 || b > MAXIMUM_ALLOWABLE_BASE)
        croak("Second argument supplied to Rmpfr_get_str is not in acceptable range");

     out = mpfr_get_str(0, &ptr, b, (unsigned long)SvUV(n_digits), *p, (mp_rnd_t)SvUV(round));

     if(out == NULL) croak("An error occurred in mpfr_get_str\n");

     /* sp  = mark; *//* not needed */
     ST(0) = sv_2mortal(newSVpv(out, 0));
     mpfr_free_str(out);
     ST(1) = sv_2mortal(newSViv(ptr));
     /* PUTBACK; *//* not needed */
     XSRETURN(2);
}

void Rmpfr_set_default_prec(pTHX_ SV * prec) {
     mpfr_set_default_prec((mpfr_prec_t)SvIV(prec));
}

SV * Rmpfr_get_default_prec(pTHX) {
     return newSViv(mpfr_get_default_prec());
}

SV * Rmpfr_min_prec(pTHX_ mpfr_t * x) {
#if MPFR_VERSION_MAJOR >= 3
     return newSViv((mpfr_prec_t)mpfr_min_prec(*x));
#else
     croak("Rmpfr_min_prec function not implemented for mpfr versions prior to version 3");
#endif
}

void Rmpfr_set_prec(pTHX_ mpfr_t * p, SV * prec) {
     mpfr_set_prec(*p, (mpfr_prec_t)SvIV(prec));
}

void Rmpfr_set_prec_raw(pTHX_ mpfr_t * p, SV * prec) {
     mpfr_set_prec_raw(*p, (mpfr_prec_t)SvIV(prec));
}

SV * Rmpfr_get_prec(pTHX_ mpfr_t * p) {
     return newSViv(mpfr_get_prec(*p));
}

SV * Rmpfr_set(pTHX_ mpfr_t * p, mpfr_t * q, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_set(*p, *q, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_set_ui(pTHX_ mpfr_t * p, SV * q, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_set_ui(*p, (unsigned long)SvUV(q), (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_set_si(pTHX_ mpfr_t * p, SV * q, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_set_si(*p, (long)SvIV(q), (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_set_uj(pTHX_ mpfr_t * p, SV * q, SV * round) {
     CHECK_ROUNDING_VALUE
#ifdef MATH_MPFR_NEED_LONG_LONG_INT
#ifndef _MSC_VER
     return newSViv(mpfr_set_uj(*p, SvUV(q), (mp_rnd_t)SvUV(round)));
#else
     croak("Rmpfr_set_uj not implemented on this build of perl - use Rmpfr_set_str instead");
#endif
#else
     croak("Rmpfr_set_uj not implemented on this build of perl");
#endif
}

SV * Rmpfr_set_sj(pTHX_ mpfr_t * p, SV * q, SV * round) {
     CHECK_ROUNDING_VALUE
#ifdef MATH_MPFR_NEED_LONG_LONG_INT
#ifndef _MSC_VER
     return newSViv(mpfr_set_sj(*p, SvIV(q), (mp_rnd_t)SvUV(round)));
#else
     croak("Rmpfr_set_sj not implemented on this build of perl - use Rmpfr_set_str instead");
#endif
#else
     croak("Rmpfr_set_sj not implemented on this build of perl");
#endif
}

SV * Rmpfr_set_NV(pTHX_ mpfr_t * p, SV * q, SV * round) {
     CHECK_ROUNDING_VALUE
#if defined(USE_LONG_DOUBLE) && !defined(_MSC_VER) && !defined(CAN_PASS_FLOAT128)
     return newSViv(mpfr_set_ld(*p, (long double)SvNV(q), (mp_rnd_t)SvUV(round)));
#elif defined(CAN_PASS_FLOAT128)
     return newSViv(mpfr_set_float128(*p, (float128)SvNV(q), (mp_rnd_t)SvUV(round)));
#else
     return newSViv(mpfr_set_d (*p, (double)SvNV(q), (mp_rnd_t)SvUV(round)));
#endif
}

SV * Rmpfr_set_ld(pTHX_ mpfr_t * p, SV * q, SV * round) {
     CHECK_ROUNDING_VALUE
#ifdef USE_LONG_DOUBLE
#ifndef _MSC_VER
     return newSViv(mpfr_set_ld(*p, (long double)SvNV(q), (mp_rnd_t)SvUV(round)));
#else
     croak("Rmpfr_set_ld not implemented on this build of perl - use Rmpfr_set_d instead");
#endif
#else
     croak("Rmpfr_set_ld not implemented on this build of perl");
#endif
}

SV * Rmpfr_set_d(pTHX_ mpfr_t * p, SV * q, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_set_d(*p, (double)SvNV(q), (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_set_z(pTHX_ mpfr_t * p, mpz_t * q, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_set_z(*p, *q, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_set_q(pTHX_ mpfr_t * p, mpq_t * q, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_set_q(*p, *q, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_set_f(pTHX_ mpfr_t * p, mpf_t * q, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_set_f(*p, *q, (mp_rnd_t)SvUV(round)));
}

int Rmpfr_set_str(pTHX_ mpfr_t * p, SV * num, SV * base, SV * round) {
    int ret, b = (int)SvIV(base);
     CHECK_ROUNDING_VALUE
     if(b < 0 || b > MAXIMUM_ALLOWABLE_BASE || b == 1)
        croak("3rd argument supplied to Rmpfr_set_str is out of allowable range");
     ret = mpfr_set_str(*p, SvPV_nolen(num), b, (mp_rnd_t)SvUV(round));
     if(ret) {
       nnum++;
       if(SvIV(get_sv("Math::MPFR::NNW", 0)))
         warn("1st arg given to Rmpfr_init_set_str contains non-numeric characters");
     }
     return ret;
}

/*
Removed in Math-MPFR-3.30. Should have been removed much earlier
void Rmpfr_set_str_binary(pTHX_ mpfr_t * p, SV * str) {
     mpfr_set_str_binary(*p, SvPV_nolen(str));
}
*/

void Rmpfr_set_inf(mpfr_t * p, int sign) {
     mpfr_set_inf(*p, sign);
}

void Rmpfr_set_nan(mpfr_t * p) {
     mpfr_set_nan(*p);
}

void Rmpfr_swap(mpfr_t *p, mpfr_t * q) {
     mpfr_swap(*p, *q);
}

SV * Rmpfr_get_d(pTHX_ mpfr_t * p, SV * round){
     CHECK_ROUNDING_VALUE
     return newSVnv(mpfr_get_d(*p, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_get_d_2exp(pTHX_ SV * exp, mpfr_t * p, SV * round){
     long _exp;
     double ret;
     CHECK_ROUNDING_VALUE
     ret = mpfr_get_d_2exp(&_exp, *p, (mp_rnd_t)SvUV(round));
     sv_setiv(exp, _exp);
     return newSVnv(ret);
}

SV * Rmpfr_get_ld_2exp(pTHX_ SV * exp, mpfr_t * p, SV * round){
#ifdef USE_LONG_DOUBLE
#ifndef _MSC_VER
     long _exp;
     long double ret;
     CHECK_ROUNDING_VALUE
     ret = mpfr_get_ld_2exp(&_exp, *p, (mp_rnd_t)SvUV(round));
     sv_setiv(exp, _exp);
     return newSVnv(ret);
#else
     croak("Rmpfr_get_ld_2exp not implemented on this build of perl - use Rmpfr_get_d_2exp instead");
#endif
#else
     croak("Rmpfr_get_ld_2exp not implemented on this build of perl");
#endif
}

SV * Rmpfr_get_ld(pTHX_ mpfr_t * p, SV * round){
     CHECK_ROUNDING_VALUE
#ifdef USE_LONG_DOUBLE
#ifndef _MSC_VER
     return newSVnv(mpfr_get_ld(*p, (mp_rnd_t)SvUV(round)));
#else
     croak("Rmpfr_get_ld not implemented on this build of perl - use Rmpfr_get_d instead");
#endif
#else
     croak("Rmpfr_get_ld not implemented on this build of perl");
#endif
}

double Rmpfr_get_d1(mpfr_t * p) {
     return mpfr_get_d1(*p);
}

/* Alias for the perl function Rmpfr_get_z_exp
*  (which will perhaps one day be removed).
*  The mpfr headers define 'mpfr_get_z_exp' to
*  'mpfr_get_z_2exp' when that function is
*  available.
*/
SV * Rmpfr_get_z_2exp(pTHX_ mpz_t * z, mpfr_t * p){
     return newSViv(mpfr_get_z_exp(*z, *p));
}

SV * Rmpfr_add(pTHX_ mpfr_t * a, mpfr_t * b, mpfr_t * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_add(*a, *b, *c, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_add_ui(pTHX_ mpfr_t * a, mpfr_t * b, SV * c, SV * round){
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_add_ui(*a, *b, (unsigned long)SvUV(c), (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_add_d(pTHX_ mpfr_t * a, mpfr_t * b, SV * c, SV * round){
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_add_d(*a, *b, (double)SvNV(c), (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_add_si(pTHX_ mpfr_t * a, mpfr_t * b, SV * c, SV * round){
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_add_si(*a, *b, (int)SvIV(c), (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_add_z(pTHX_ mpfr_t * a, mpfr_t * b, mpz_t * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_add_z(*a, *b, *c, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_add_q(pTHX_ mpfr_t * a, mpfr_t * b, mpq_t * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_add_q(*a, *b, *c, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_sub(pTHX_ mpfr_t * a, mpfr_t * b, mpfr_t * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_sub(*a, *b, *c, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_sub_ui(pTHX_ mpfr_t * a, mpfr_t * b, SV * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_sub_ui(*a, *b, (unsigned long)SvUV(c), (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_sub_d(pTHX_ mpfr_t * a, mpfr_t * b, SV * c, SV * round){
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_sub_d(*a, *b, (double)SvNV(c), (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_sub_z(pTHX_ mpfr_t * a, mpfr_t * b, mpz_t * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_sub_z(*a, *b, *c, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_sub_q(pTHX_ mpfr_t * a, mpfr_t * b, mpq_t * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_sub_q(*a, *b, *c, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_ui_sub(pTHX_ mpfr_t * a, SV * b, mpfr_t * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_ui_sub(*a, (unsigned long)SvUV(b), *c, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_d_sub(pTHX_ mpfr_t * a, SV * b, mpfr_t * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_d_sub(*a, (double)SvNV(b), *c, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_mul(pTHX_ mpfr_t * a, mpfr_t * b, mpfr_t * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_mul(*a, *b, *c, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_mul_ui(pTHX_ mpfr_t * a, mpfr_t * b, SV * c, SV * round){
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_mul_ui(*a, *b, (unsigned long)SvUV(c), (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_mul_d(pTHX_ mpfr_t * a, mpfr_t * b, SV * c, SV * round){
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_mul_d(*a, *b, (double)SvNV(c), (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_mul_z(pTHX_ mpfr_t * a, mpfr_t * b, mpz_t * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_mul_z(*a, *b, *c, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_mul_q(pTHX_ mpfr_t * a, mpfr_t * b, mpq_t * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_mul_q(*a, *b, *c, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_dim(pTHX_ mpfr_t * rop, mpfr_t * op1, mpfr_t * op2, SV * round) {
     CHECK_ROUNDING_VALUE
         int ret = mpfr_dim( *rop, *op1, *op2, (mp_rnd_t)SvUV(round));
         return newSViv(ret);
}

SV * Rmpfr_div(pTHX_ mpfr_t * a, mpfr_t * b, mpfr_t * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_div(*a, *b, *c, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_div_ui(pTHX_ mpfr_t * a, mpfr_t * b, SV * c, SV * round){
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_div_ui(*a, *b, (unsigned long)SvUV(c), (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_div_d(pTHX_ mpfr_t * a, mpfr_t * b, SV * c, SV * round){
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_div_d(*a, *b, (double)SvNV(c), (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_div_z(pTHX_ mpfr_t * a, mpfr_t * b, mpz_t * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_div_z(*a, *b, *c, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_div_q(pTHX_ mpfr_t * a, mpfr_t * b, mpq_t * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_div_q(*a, *b, *c, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_ui_div(pTHX_ mpfr_t * a, SV * b, mpfr_t * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_ui_div(*a, (unsigned long)SvUV(b), *c, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_d_div(pTHX_ mpfr_t * a, SV * b, mpfr_t * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_d_div(*a, (double)SvNV(b), *c, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_sqrt(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_sqrt(*a, *b, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_rec_sqrt(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_rec_sqrt(*a, *b, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_cbrt(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_cbrt(*a, *b, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_sqrt_ui(pTHX_ mpfr_t * a, SV * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_sqrt_ui(*a, (unsigned long)SvUV(b), (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_pow_ui(pTHX_ mpfr_t * a, mpfr_t * b, SV * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_pow_ui(*a, *b, (unsigned long)SvUV(c), (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_ui_pow_ui(pTHX_ mpfr_t * a, SV * b, SV * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_ui_pow_ui(*a, (unsigned long)SvUV(b), (unsigned long)SvUV(c), (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_ui_pow(pTHX_ mpfr_t * a, SV * b, mpfr_t * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_ui_pow(*a, (unsigned long)SvUV(b), *c, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_pow_si(pTHX_ mpfr_t * a, mpfr_t * b, SV * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_pow_si(*a, *b, (long)SvIV(c), (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_pow(pTHX_ mpfr_t * a, mpfr_t * b, mpfr_t * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_pow(*a, *b, *c, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_neg(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_neg(*a, *b, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_abs(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_abs(*a, *b, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_mul_2exp(pTHX_ mpfr_t * a, mpfr_t * b, SV * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_mul_2exp(*a, *b, (unsigned long)SvUV(c), (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_mul_2ui(pTHX_ mpfr_t * a, mpfr_t * b, SV * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_mul_2ui(*a, *b, (unsigned long)SvUV(c), (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_mul_2si(pTHX_ mpfr_t * a, mpfr_t * b, SV * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_mul_2si(*a, *b, (long)SvIV(c), (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_div_2exp(pTHX_ mpfr_t * a, mpfr_t * b, SV * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_div_2exp(*a, *b, (unsigned long)SvUV(c), (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_div_2ui(pTHX_ mpfr_t * a, mpfr_t * b, SV * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_div_2ui(*a, *b, (unsigned long)SvUV(c), (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_div_2si(pTHX_ mpfr_t * a, mpfr_t * b, SV * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_div_2si(*a, *b, (long)SvIV(c), (mp_rnd_t)SvUV(round)));
}

int Rmpfr_cmp(mpfr_t * a, mpfr_t * b) {
     return mpfr_cmp(*a, *b);
}

int Rmpfr_cmpabs(mpfr_t * a, mpfr_t * b) {
     return mpfr_cmpabs(*a, *b);
}

int Rmpfr_cmp_ui(mpfr_t * a, unsigned long b) {
     return mpfr_cmp_ui(*a, b);
}

int Rmpfr_cmp_d(mpfr_t * a, double b) {
     return mpfr_cmp_d(*a, b);
}

int Rmpfr_cmp_ld(pTHX_ mpfr_t * a, SV * b) {
#ifdef USE_LONG_DOUBLE
#ifndef _MSC_VER
     return mpfr_cmp_ld(*a, (long double)SvNV(b));
#else
     croak("Rmpfr_cmp_ld not implemented on this build of perl - use Rmpfr_cmp_d instead");
#endif
#else
     croak("Rmpfr_cmp_ld not implemented on this build of perl");
#endif
}

int Rmpfr_cmp_si(mpfr_t * a, long b) {
     return mpfr_cmp_si(*a, b);
}

int Rmpfr_cmp_ui_2exp(pTHX_ mpfr_t * a, SV * b, SV * c) {
     return mpfr_cmp_ui_2exp(*a, (unsigned long)SvUV(b), (mp_exp_t)SvIV(c));
}

int Rmpfr_cmp_si_2exp(pTHX_ mpfr_t * a, SV * b, SV * c) {
     return mpfr_cmp_si_2exp(*a, (long)SvIV(b), (mp_exp_t)SvIV(c));
}

int Rmpfr_eq(mpfr_t * a, mpfr_t * b, unsigned long c) {
     return mpfr_eq(*a, *b, c);
}

int Rmpfr_nan_p(mpfr_t * p) {
     return mpfr_nan_p(*p);
}

int Rmpfr_inf_p(mpfr_t * p) {
     return mpfr_inf_p(*p);
}

int Rmpfr_number_p(mpfr_t * p) {
     return mpfr_number_p(*p);
}

void Rmpfr_reldiff(pTHX_ mpfr_t * a, mpfr_t * b, mpfr_t * c, SV * round) {
     CHECK_ROUNDING_VALUE
     mpfr_reldiff(*a, *b, *c, (mp_rnd_t)SvUV(round));
}

int Rmpfr_sgn(mpfr_t * p) {
     return mpfr_sgn(*p);
}

int Rmpfr_greater_p(mpfr_t * a, mpfr_t * b) {
     return mpfr_greater_p(*a, *b);
}

int Rmpfr_greaterequal_p(mpfr_t * a, mpfr_t * b) {
     return mpfr_greaterequal_p(*a, *b);
}

int Rmpfr_less_p(mpfr_t * a, mpfr_t * b) {
     return mpfr_less_p(*a, *b);
}

int Rmpfr_lessequal_p(mpfr_t * a, mpfr_t * b) {
     return mpfr_lessequal_p(*a, *b);
}

int Rmpfr_lessgreater_p(mpfr_t * a, mpfr_t * b) {
     return mpfr_lessgreater_p(*a, *b);
}

int Rmpfr_equal_p(mpfr_t * a, mpfr_t * b) {
     return mpfr_equal_p(*a, *b);
}

int Rmpfr_unordered_p(mpfr_t * a, mpfr_t * b) {
     return mpfr_unordered_p(*a, *b);
}

SV * Rmpfr_sin_cos(pTHX_ mpfr_t * a, mpfr_t * b, mpfr_t * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_sin_cos(*a, *b, *c, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_sinh_cosh(pTHX_ mpfr_t * a, mpfr_t * b, mpfr_t * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_sinh_cosh(*a, *b, *c, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_sin(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_sin(*a, *b, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_cos(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_cos(*a, *b, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_tan(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_tan(*a, *b, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_asin(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_asin(*a, *b, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_acos(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_acos(*a, *b, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_atan(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_atan(*a, *b, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_sinh(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_sinh(*a, *b, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_cosh(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_cosh(*a, *b, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_tanh(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_tanh(*a, *b, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_asinh(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_asinh(*a, *b, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_acosh(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_acosh(*a, *b, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_atanh(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_atanh(*a, *b, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_fac_ui(pTHX_ mpfr_t * a, SV * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_fac_ui(*a, (unsigned long)SvUV(b), (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_log1p(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_log1p(*a, *b, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_expm1(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_expm1(*a, *b, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_log2(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_log2(*a, *b, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_log10(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_log10(*a, *b, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_fma(pTHX_ mpfr_t * a, mpfr_t * b, mpfr_t * c, mpfr_t * d, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_fma(*a, *b, *c, *d, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_fms(pTHX_ mpfr_t * a, mpfr_t * b, mpfr_t * c, mpfr_t * d, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_fms(*a, *b, *c, *d, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_agm(pTHX_ mpfr_t * a, mpfr_t * b, mpfr_t * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_agm(*a, *b, *c, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_hypot(pTHX_ mpfr_t * a, mpfr_t * b, mpfr_t * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_hypot(*a, *b, *c, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_const_log2(pTHX_ mpfr_t * p, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_const_log2(*p, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_const_pi(pTHX_ mpfr_t * p, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_const_pi(*p, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_const_euler(pTHX_ mpfr_t * p, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_const_euler(*p, (mp_rnd_t)SvUV(round)));
}

/*
Removed in Math-MPFR-3.30. Should have been removed much earlier
void Rmpfr_print_binary(mpfr_t * p) {
     mpfr_print_binary(*p);
}
*/

SV * Rmpfr_rint(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_rint(*a, *b, (mp_rnd_t)SvUV(round)));
}

int Rmpfr_ceil(mpfr_t * a, mpfr_t * b) {
     return mpfr_ceil(*a, *b);
}

int Rmpfr_floor(mpfr_t * a, mpfr_t * b) {
     return mpfr_floor(*a, *b);
}

int Rmpfr_round(mpfr_t * a, mpfr_t * b) {
     return mpfr_round(*a, *b);
}

int Rmpfr_trunc(mpfr_t * a, mpfr_t * b) {
     return mpfr_trunc(*a, *b);
}

/* NO LONGER SUPPORTED
SV * Rmpfr_add_one_ulp(mpfr_t * p, SV * round) {
     return newSViv(mpfr_add_one_ulp(*p, (mp_rnd_t)SvUV(round)));
} */

/* NO LONGER SUPPORTED
SV * Rmpfr_sub_one_ulp(mpfr_t * p, SV * round) {
     return newSViv(mpfr_sub_one_ulp(*p, (mp_rnd_t)SvUV(round)));
} */

SV * Rmpfr_can_round(pTHX_ mpfr_t * p, SV * err, SV * round1, SV * round2, SV * prec) {
#if MPFR_VERSION_MAJOR < 3
    if((mp_rnd_t)SvUV(round1) > 3 || (mp_rnd_t)SvUV(round2) > 3)
      croak("Illegal rounding value supplied for this version (%s) of the mpfr library", MPFR_VERSION_STRING);
#endif
     return newSViv(mpfr_can_round(*p, (mp_exp_t)SvIV(err), SvUV(round1), SvUV(round2), (mpfr_prec_t)SvIV(prec)));
}

SV * Rmpfr_print_rnd_mode(pTHX_ SV * rnd) {
     const char * x = mpfr_print_rnd_mode((mpfr_rnd_t)SvIV(rnd));
     if(x == NULL) return &PL_sv_undef;
     return newSVpv(x, 0);
}

SV * Rmpfr_get_emin(pTHX) {
     return newSViv(mpfr_get_emin());
}

SV * Rmpfr_get_emax(pTHX) {
     return newSViv(mpfr_get_emax());
}

int Rmpfr_set_emin(pTHX_ SV * e) {
     return mpfr_set_emin((mp_exp_t)SvIV(e));
}

int Rmpfr_set_emax(pTHX_ SV * e) {
     return mpfr_set_emax((mp_exp_t)SvIV(e));
}

SV * Rmpfr_check_range(pTHX_ mpfr_t * p, SV * t, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_check_range(*p, (int)SvIV(t), (mp_rnd_t)SvUV(round)));
}

void Rmpfr_clear_underflow(void) {
     mpfr_clear_underflow();
}

void Rmpfr_clear_overflow(void) {
     mpfr_clear_overflow();
}

void Rmpfr_clear_nanflag(void) {
     mpfr_clear_nanflag();
}

void Rmpfr_clear_inexflag(void) {
     mpfr_clear_inexflag();
}

void Rmpfr_clear_flags(void) {
     mpfr_clear_flags();
}

int Rmpfr_underflow_p(void) {
     return mpfr_underflow_p();
}

int Rmpfr_overflow_p(void) {
     return mpfr_overflow_p();
}

int Rmpfr_nanflag_p(void) {
     return mpfr_nanflag_p();
}

int Rmpfr_inexflag_p(void) {
     return mpfr_inexflag_p();
}

SV * Rmpfr_log(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_log(*a, *b, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_exp(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_exp(*a, *b, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_exp2(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_exp2(*a, *b, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_exp10(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_exp10(*a, *b, (mp_rnd_t)SvUV(round)));
}

void Rmpfr_urandomb(pTHX_ SV * x, ...) {
     dXSARGS;
     unsigned long i, t;

     t = items;
     --t;

     for(i = 0; i < t; ++i) {
        mpfr_urandomb(*(INT2PTR(mpfr_t *, SvIV(SvRV(ST(i))))), *(INT2PTR(gmp_randstate_t *, SvIV(SvRV(ST(t))))));
        }
     XSRETURN(0);
}

void Rmpfr_random2(pTHX_ mpfr_t * p, SV * s, SV * exp) {
#if MPFR_VERSION_MAJOR > 2
     croak("Rmpfr_random2 no longer implemented. Use Rmpfr_urandom or Rmpfr_urandomb");
#else
     mpfr_random2(*p, (int)SvIV(s), (mp_exp_t)SvIV(exp));
#endif
}

SV * _TRmpfr_out_str(pTHX_ FILE * stream, SV * base, SV * dig, mpfr_t * p, SV * round) {
     size_t ret;
     if(SvIV(base) < 2 || SvIV(base) > MAXIMUM_ALLOWABLE_BASE)
        croak("2nd argument supplied to TRmpfr_out_str is out of allowable range (must be between 2 and %d inclusive)",
        MAXIMUM_ALLOWABLE_BASE);
     ret = mpfr_out_str(stream, (int)SvIV(base), (size_t)SvUV(dig), *p, (mp_rnd_t)SvUV(round));
     fflush(stream);
     return newSVuv(ret);
}

SV * _Rmpfr_out_str(pTHX_ mpfr_t * p, SV * base, SV * dig, SV * round) {
     size_t ret;
     CHECK_ROUNDING_VALUE
     if(SvIV(base) < 2 || SvIV(base) > MAXIMUM_ALLOWABLE_BASE)
        croak("2nd argument supplied to Rmpfr_out_str is out of allowable range (must be between 2 and %d inclusive)",
        MAXIMUM_ALLOWABLE_BASE);
     ret = mpfr_out_str(NULL, (int)SvIV(base), (size_t)SvUV(dig), *p, (mp_rnd_t)SvUV(round));
     fflush(stdout);
     return newSVuv(ret);
}

SV * _TRmpfr_out_strS(pTHX_ FILE * stream, SV * base, SV * dig, mpfr_t * p, SV * round, SV * suff) {
     size_t ret;
     CHECK_ROUNDING_VALUE
     if(SvIV(base) < 2 || SvIV(base) > MAXIMUM_ALLOWABLE_BASE)
       croak("2nd argument supplied to TRmpfr_out_str is out of allowable range (must be between 2 and %d inclusive)",
       MAXIMUM_ALLOWABLE_BASE);
     ret = mpfr_out_str(stream, (int)SvIV(base), (size_t)SvUV(dig), *p, (mp_rnd_t)SvUV(round));
     fflush(stream);
     fprintf(stream, "%s", SvPV_nolen(suff));
     fflush(stream);
     return newSVuv(ret);
}

SV * _TRmpfr_out_strP(pTHX_ SV * pre, FILE * stream, SV * base, SV * dig, mpfr_t * p, SV * round) {
     size_t ret;
     CHECK_ROUNDING_VALUE
     if(SvIV(base) < 2 || SvIV(base) > MAXIMUM_ALLOWABLE_BASE)
        croak("3rd argument supplied to TRmpfr_out_str is out of allowable range (must be between 2 and %d inclusive)",
        MAXIMUM_ALLOWABLE_BASE);
     fprintf(stream, "%s", SvPV_nolen(pre));
     fflush(stream);
     ret = mpfr_out_str(stream, (int)SvIV(base), (size_t)SvUV(dig), *p, (mp_rnd_t)SvUV(round));
     fflush(stream);
     return newSVuv(ret);
}

SV * _TRmpfr_out_strPS(pTHX_ SV * pre, FILE * stream, SV * base, SV * dig, mpfr_t * p, SV * round, SV * suff) {
     size_t ret;
     CHECK_ROUNDING_VALUE
     if(SvIV(base) < 2 || SvIV(base) > MAXIMUM_ALLOWABLE_BASE)
        croak("3rd argument supplied to TRmpfr_out_str is out of allowable range (must be between 2 and %d inclusive)",
        MAXIMUM_ALLOWABLE_BASE);
     fprintf(stream, "%s", SvPV_nolen(pre));
     fflush(stream);
     ret = mpfr_out_str(stream, (int)SvIV(base), (size_t)SvUV(dig), *p, (mp_rnd_t)SvUV(round));
     fflush(stream);
     fprintf(stream, "%s", SvPV_nolen(suff));
     fflush(stream);
     return newSVuv(ret);
}

SV * _Rmpfr_out_strS(pTHX_ mpfr_t * p, SV * base, SV * dig, SV * round, SV * suff) {
     size_t ret;
     CHECK_ROUNDING_VALUE
     if(SvIV(base) < 2 || SvIV(base) > MAXIMUM_ALLOWABLE_BASE)
       croak("2nd argument supplied to Rmpfr_out_str is out of allowable range (must be between 2 and %d inclusive)",
       MAXIMUM_ALLOWABLE_BASE);
     ret = mpfr_out_str(NULL, (int)SvIV(base), (size_t)SvUV(dig), *p, (mp_rnd_t)SvUV(round));
     printf("%s", SvPV_nolen(suff));
     fflush(stdout);
     return newSVuv(ret);
}

SV * _Rmpfr_out_strP(pTHX_ SV * pre, mpfr_t * p, SV * base, SV * dig, SV * round) {
     size_t ret;
     CHECK_ROUNDING_VALUE
     if(SvIV(base) < 2 || SvIV(base) > MAXIMUM_ALLOWABLE_BASE)
        croak("3rd argument supplied to Rmpfr_out_str is out of allowable range (must be between 2 and %d inclusive)",
        MAXIMUM_ALLOWABLE_BASE);
     printf("%s", SvPV_nolen(pre));
     ret = mpfr_out_str(NULL, (int)SvIV(base), (size_t)SvUV(dig), *p, (mp_rnd_t)SvUV(round));
     fflush(stdout);
     return newSVuv(ret);
}

SV * _Rmpfr_out_strPS(pTHX_ SV * pre, mpfr_t * p, SV * base, SV * dig, SV * round, SV * suff) {
     size_t ret;
     CHECK_ROUNDING_VALUE
     if(SvIV(base) < 2 || SvIV(base) > MAXIMUM_ALLOWABLE_BASE)
       croak("3rd argument supplied to Rmpfr_out_str is out of allowable range (must be between 2 and %d inclusive)",
       MAXIMUM_ALLOWABLE_BASE);
     printf("%s", SvPV_nolen(pre));
     ret = mpfr_out_str(NULL, (int)SvIV(base), (size_t)SvUV(dig), *p, (mp_rnd_t)SvUV(round));
     printf("%s", SvPV_nolen(suff));
     fflush(stdout);
     return newSVuv(ret);
}

SV * TRmpfr_inp_str(pTHX_ mpfr_t * p, FILE * stream, SV * base, SV * round) {
     size_t ret;
     CHECK_ROUNDING_VALUE
     if(SvIV(base) < 2 || SvIV(base) > MAXIMUM_ALLOWABLE_BASE)
        croak("3rd argument supplied to TRmpfr_inp_str is out of allowable range (must be between 2 and %d inclusive)",
        MAXIMUM_ALLOWABLE_BASE);
     ret = mpfr_inp_str(*p, stream, (int)SvIV(base), (mp_rnd_t)SvUV(round));
     if(!ret) {
       nnum++;
       if(SvIV(get_sv("Math::MPFR::NNW", 0)))
         warn("input to TRmpfr_inp_str contains non-numeric characters");
     }
     /* fflush(stream); */
     return newSVuv(ret);
}

SV * Rmpfr_inp_str(pTHX_ mpfr_t * p, SV * base, SV * round) {
     size_t ret;
     CHECK_ROUNDING_VALUE
     if(SvIV(base) < 2 || SvIV(base) > MAXIMUM_ALLOWABLE_BASE)
        croak("2nd argument supplied to Rmpfr_inp_str is out of allowable range (must be between 2 and %d inclusive)",
        MAXIMUM_ALLOWABLE_BASE);
     ret = mpfr_inp_str(*p, NULL, (int)SvIV(base), (mp_rnd_t)SvUV(round));
     if(!ret) {
       nnum++;
       if(SvIV(get_sv("Math::MPFR::NNW", 0)))
         warn("input to Rmpfr_inp_str contains non-numeric characters");
     }
     /* fflush(stdin); */
     return newSVuv(ret);
}

SV * Rmpfr_gamma(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_gamma(*a, *b, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_zeta(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_zeta(*a, *b, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_zeta_ui(pTHX_ mpfr_t * a, SV * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_zeta_ui(*a, (unsigned long)SvUV(b), (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_erf(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_erf(*a, *b, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_frac(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_frac(*a, *b, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_remainder(pTHX_ mpfr_t * a, mpfr_t * b, mpfr_t * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_remainder(*a, *b, *c, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_modf(pTHX_ mpfr_t * a, mpfr_t * b, mpfr_t * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_modf(*a, *b, *c, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_fmod(pTHX_ mpfr_t * a, mpfr_t * b, mpfr_t * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_fmod(*a, *b, *c, (mp_rnd_t)SvUV(round)));
}

void Rmpfr_remquo(pTHX_ mpfr_t * a, mpfr_t * b, mpfr_t * c, SV * round) {
     dXSARGS;
     long ret, q;
     CHECK_ROUNDING_VALUE
     ret = mpfr_remquo(*a, &q, *b, *c, (mp_rnd_t)SvUV(round));
     ST(0) = sv_2mortal(newSViv(q));
     ST(1) = sv_2mortal(newSViv(ret));
     XSRETURN(2);
}

int Rmpfr_integer_p(mpfr_t * p) {
     return mpfr_integer_p(*p);
}

void Rmpfr_nexttoward(mpfr_t * a, mpfr_t * b) {
     mpfr_nexttoward(*a, *b);
}

void Rmpfr_nextabove(mpfr_t * p) {
     mpfr_nextabove(*p);
}

void Rmpfr_nextbelow(mpfr_t * p) {
     mpfr_nextbelow(*p);
}

SV * Rmpfr_min(pTHX_ mpfr_t * a, mpfr_t * b, mpfr_t * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_min(*a, *b, *c, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_max(pTHX_ mpfr_t * a, mpfr_t * b, mpfr_t * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_max(*a, *b, *c, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_get_exp(pTHX_ mpfr_t * p) {
     return newSViv(mpfr_get_exp(*p));
}

SV * Rmpfr_set_exp(pTHX_ mpfr_t * p, SV * exp) {
     return newSViv(mpfr_set_exp(*p, (mp_exp_t)SvIV(exp)));
}

int Rmpfr_signbit(mpfr_t * op) {
     return mpfr_signbit(*op);
}

SV * Rmpfr_setsign(pTHX_ mpfr_t * rop, mpfr_t * op, SV * sign, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_setsign(*rop, *op, SvIV(sign), (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_copysign(pTHX_ mpfr_t * rop, mpfr_t * op1, mpfr_t * op2, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_copysign(*rop, *op1, *op2, (mp_rnd_t)SvUV(round)));
}

SV * get_refcnt(pTHX_ SV * s) {
     return newSVuv(SvREFCNT(s));
}

SV * get_package_name(pTHX_ SV * x) {
     if(sv_isobject(x)) return newSVpv(HvNAME(SvSTASH(SvRV(x))), 0);
     return newSViv(0);
}

void Rmpfr_dump(mpfr_t * a) { /* Once took a 'round' argument */
     mpfr_dump(*a);
}

SV * gmp_v(pTHX) {
#if __GNU_MP_VERSION >= 4
     return newSVpv(gmp_version, 0);
#else
     warn("From Math::MPFR::gmp_v(aTHX): 'gmp_version' is not implemented - returning '0'");
     return newSVpv("0", 0);
#endif
}

/* NEW in MPFR-2.1.0 */

SV * Rmpfr_set_ui_2exp(pTHX_ mpfr_t * a, SV * b, SV * c, SV * round) {
     return newSViv(mpfr_set_ui_2exp(*a, (unsigned long)SvUV(b), (mp_exp_t)SvIV(c), (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_set_si_2exp(pTHX_ mpfr_t * a, SV * b, SV * c, SV * round) {
     return newSViv(mpfr_set_si_2exp(*a, (long)SvIV(b), (mp_exp_t)SvIV(c), (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_set_uj_2exp(pTHX_ mpfr_t * a, SV * b, SV * c, SV * round) {
     CHECK_ROUNDING_VALUE
#ifdef MATH_MPFR_NEED_LONG_LONG_INT
#ifndef _MSC_VER
     return newSViv(mpfr_set_uj_2exp(*a, SvUV(b), SvIV(c), (mp_rnd_t)SvUV(round)));
#else
     croak ("Rmpfr_set_uj_2exp not implemented on this build of perl");
#endif
#else
     croak ("Rmpfr_set_uj_2exp not implemented on this build of perl");
#endif
}

SV * Rmpfr_set_sj_2exp(pTHX_ mpfr_t * a, SV * b, SV * c, SV * round) {
     CHECK_ROUNDING_VALUE
#ifdef MATH_MPFR_NEED_LONG_LONG_INT
#ifndef _MSC_VER
     return newSViv(mpfr_set_sj_2exp(*a, SvIV(b), SvIV(c), (mp_rnd_t)SvUV(round)));
#else
     croak ("Rmpfr_set_sj_2exp not implemented on this build of perl");
#endif
#else
     croak ("Rmpfr_set_sj_2exp not implemented on this build of perl");
#endif
}

SV * Rmpfr_get_z(pTHX_ mpz_t * a, mpfr_t * b, SV * round) {
#if MPFR_VERSION_MAJOR < 3
     CHECK_ROUNDING_VALUE
     mpfr_get_z(*a, *b, (mp_rnd_t)SvUV(round));
     return &PL_sv_undef;
#else
     return newSViv(mpfr_get_z(*a, *b, (mp_rnd_t)SvUV(round)));
#endif
}

SV * Rmpfr_si_sub(pTHX_ mpfr_t * a, SV * b, mpfr_t * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_si_sub(*a, (long)SvIV(b), *c, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_sub_si(pTHX_ mpfr_t * a, mpfr_t * b, SV * c, SV * round){
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_sub_si(*a, *b, (long)SvIV(c), (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_mul_si(pTHX_ mpfr_t * a, mpfr_t * b, SV * c, SV * round){
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_mul_si(*a, *b, (long)SvIV(c), (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_si_div(pTHX_ mpfr_t * a, SV * b, mpfr_t * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_si_div(*a, (long)SvIV(b), *c, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_div_si(pTHX_ mpfr_t * a, mpfr_t * b, SV * c, SV * round){
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_div_si(*a, *b, (long)SvIV(c), (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_sqr(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_sqr(*a, *b, (mp_rnd_t)SvUV(round)));
}

int Rmpfr_cmp_z(mpfr_t * a, mpz_t * b) {
     return mpfr_cmp_z(*a, *b);
}

int Rmpfr_cmp_q(mpfr_t * a, mpq_t * b) {
     return mpfr_cmp_q(*a, *b);
}

int Rmpfr_cmp_f(mpfr_t * a, mpf_t * b) {
     return mpfr_cmp_f(*a, *b);
}

int Rmpfr_zero_p(mpfr_t * a) {
     return mpfr_zero_p(*a);
}

void Rmpfr_free_cache(void) {
     mpfr_free_cache();
}

SV * Rmpfr_get_version(pTHX) {
     return newSVpv(mpfr_get_version(), 0);
}

SV * Rmpfr_get_patches(pTHX) {
     return newSVpv(mpfr_get_patches(), 0);
}

SV * Rmpfr_get_emin_min(pTHX) {
     return newSViv(mpfr_get_emin_min());
}

SV * Rmpfr_get_emin_max(pTHX) {
     return newSViv(mpfr_get_emin_max());
}

SV * Rmpfr_get_emax_min(pTHX) {
     return newSViv(mpfr_get_emax_min());
}

SV * Rmpfr_get_emax_max(pTHX) {
     return newSViv(mpfr_get_emax_max());
}

void Rmpfr_clear_erangeflag(void) {
     mpfr_clear_erangeflag();
}

int Rmpfr_erangeflag_p(void) {
     return mpfr_erangeflag_p();
}

SV * Rmpfr_rint_round(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_rint_round(*a, *b, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_rint_trunc(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_rint_trunc(*a, *b, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_rint_ceil(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_rint_ceil(*a, *b, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_rint_floor(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_rint_floor(*a, *b, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_get_ui(pTHX_ mpfr_t * a, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSVuv(mpfr_get_ui(*a, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_get_si(pTHX_ mpfr_t * a, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_get_si(*a, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_get_uj(pTHX_ mpfr_t * a, SV * round) {
     CHECK_ROUNDING_VALUE
#ifdef MATH_MPFR_NEED_LONG_LONG_INT
     return newSVuv(mpfr_get_uj(*a, (mp_rnd_t)SvUV(round)));
#else
     croak ("Rmpfr_get_uj not implemented on this build of perl");
#endif
}

SV * Rmpfr_get_sj(pTHX_ mpfr_t * a, SV * round) {
     CHECK_ROUNDING_VALUE
#ifdef MATH_MPFR_NEED_LONG_LONG_INT
     return newSViv(mpfr_get_sj(*a, (mp_rnd_t)SvUV(round)));
#else
     croak ("Rmpfr_get_sj not implemented on this build of perl");
#endif
}

SV * Rmpfr_get_IV(pTHX_ mpfr_t * x, SV * round) {
     CHECK_ROUNDING_VALUE
     if(sizeof(IV) == sizeof(long)) return newSViv(mpfr_get_si(*x, (mp_rnd_t)SvUV(round)));
#if defined MATH_MPFR_NEED_LONG_LONG_INT
#ifndef _MSC_VER
     if(sizeof(IV) == sizeof(intmax_t)) return newSViv(mpfr_get_sj(*x, (mp_rnd_t)SvUV(round)));
#else
     if(sizeof(IV) == sizeof(signed __int64)) return newSViv(mpfr_get_sj(*x, (mp_rnd_t)SvUV(round)));
#endif
#endif
     croak("Rmpfr_get_IV not implemented on this build of perl");
}

SV * Rmpfr_get_UV(pTHX_ mpfr_t * x, SV * round) {
     CHECK_ROUNDING_VALUE
     if(sizeof(UV) == sizeof(unsigned long)) return newSVuv(mpfr_get_ui(*x, (mp_rnd_t)SvUV(round)));
#if defined MATH_MPFR_NEED_LONG_LONG_INT
#ifndef _MSC_VER
     if(sizeof(UV) == sizeof(uintmax_t)) return newSVuv(mpfr_get_uj(*x, (mp_rnd_t)SvUV(round)));
#else
     if(sizeof(UV) == sizeof(unsigned __int64)) return newSVuv(mpfr_get_uj(*x, (mp_rnd_t)SvUV(round)));
#endif
#endif
     croak("Rmpfr_get_UV not implemented on this build of perl");
}

SV * Rmpfr_get_NV(pTHX_ mpfr_t * x, SV * round) {
     CHECK_ROUNDING_VALUE
#if defined(CAN_PASS_FLOAT128)
  return newSVnv(mpfr_get_float128(*x, (mp_rnd_t)SvUV(round)));
#elif defined(USE_LONG_DOUBLE)
  return newSVnv(mpfr_get_ld(*x, (mp_rnd_t)SvUV(round)));
#else
  return newSVnv(mpfr_get_d(*x, (mp_rnd_t)SvUV(round)));
#endif

}

SV * Rmpfr_fits_ulong_p(pTHX_ mpfr_t * a, SV * round) {
     CHECK_ROUNDING_VALUE
#if defined(MPFR_VERSION) && MPFR_VERSION > NEG_ZERO_BUG
     return newSVuv(mpfr_fits_ulong_p(*a, (mp_rnd_t)SvUV(round)));
#else
     if((mp_rnd_t)SvUV(round) < 3) {
       if((mp_rnd_t)SvUV(round) == 0) {
         if((mpfr_cmp_d(*a, -0.5) >= 0) && (mpfr_cmp_d(*a, 0.0) <= 0)) return newSVuv(1);
       }
       else {
         if((mpfr_cmp_d(*a, -1.0) > 0) && (mpfr_cmp_d(*a, 0.0) <= 0)) return newSVuv(1);
       }
     }
     return newSVuv(mpfr_fits_ulong_p(*a, (mp_rnd_t)SvUV(round)));
#endif
}

SV * Rmpfr_fits_slong_p(pTHX_ mpfr_t * a, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSVuv(mpfr_fits_slong_p(*a, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_fits_ushort_p(pTHX_ mpfr_t * a, SV * round) {
     CHECK_ROUNDING_VALUE
#if defined(MPFR_VERSION) && MPFR_VERSION > NEG_ZERO_BUG
     return newSVuv(mpfr_fits_ushort_p(*a, (mp_rnd_t)SvUV(round)));
#else
     if((mp_rnd_t)SvUV(round) < 3) {
       if((mp_rnd_t)SvUV(round) == 0) {
         if((mpfr_cmp_d(*a, -0.5) >= 0) && (mpfr_cmp_d(*a, 0.0) <= 0)) return newSVuv(1);
       }
       else {
         if((mpfr_cmp_d(*a, -1.0) > 0) && (mpfr_cmp_d(*a, 0.0) <= 0)) return newSVuv(1);
       }
     }
     return newSVuv(mpfr_fits_ushort_p(*a, (mp_rnd_t)SvUV(round)));
#endif
}

SV * Rmpfr_fits_sshort_p(pTHX_ mpfr_t * a, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSVuv(mpfr_fits_sshort_p(*a, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_fits_uint_p(pTHX_ mpfr_t * a, SV * round) {
     CHECK_ROUNDING_VALUE
#if defined(MPFR_VERSION) && MPFR_VERSION > NEG_ZERO_BUG
     return newSVuv(mpfr_fits_uint_p(*a, (mp_rnd_t)SvUV(round)));
#else
     if((mp_rnd_t)SvUV(round) < 3) {
       if((mp_rnd_t)SvUV(round) == 0) {
         if((mpfr_cmp_d(*a, -0.5) >= 0) && (mpfr_cmp_d(*a, 0.0) <= 0)) return newSVuv(1);
       }
       else {
         if((mpfr_cmp_d(*a, -1.0) > 0) && (mpfr_cmp_d(*a, 0.0) <= 0)) return newSVuv(1);
       }
     }
     return newSVuv(mpfr_fits_uint_p(*a, (mp_rnd_t)SvUV(round)));
#endif
}

SV * Rmpfr_fits_sint_p(pTHX_ mpfr_t * a, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSVuv(mpfr_fits_sint_p(*a, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_fits_uintmax_p(pTHX_ mpfr_t * a, SV * round) {
     CHECK_ROUNDING_VALUE
#if defined(MPFR_VERSION) && MPFR_VERSION > NEG_ZERO_BUG
     return newSVuv(mpfr_fits_uintmax_p(*a, (mp_rnd_t)SvUV(round)));
#else
     if(mpfr_zero_p(*a)) return newSVuv(1);
     if((mp_rnd_t)SvUV(round) < 3) {
       if((mp_rnd_t)SvUV(round) == 0) {
         if((mpfr_cmp_d(*a, -0.5) >= 0) && (mpfr_cmp_d(*a, 0.0) <= 0)) return newSVuv(1);
       }
       else {
         if((mpfr_cmp_d(*a, -1.0) > 0) && (mpfr_cmp_d(*a, 0.0) <= 0)) return newSVuv(1);
       }
     }
     return newSVuv(mpfr_fits_uintmax_p(*a, (mp_rnd_t)SvUV(round)));
#endif
}

SV * Rmpfr_fits_intmax_p(pTHX_ mpfr_t * a, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSVuv(mpfr_fits_intmax_p(*a, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_fits_IV_p(pTHX_ mpfr_t * x, SV * round) {
     unsigned long ret = 0, bits = sizeof(IV) * 8;
     mpfr_t high, low, copy;

     CHECK_ROUNDING_VALUE

     if(sizeof(IV) == sizeof(long)) {
       if(mpfr_fits_slong_p(*x, (mp_rnd_t)SvUV(round))) return newSVuv(1);
       return newSVuv(0);
     }

     if(sizeof(IV) == sizeof(int)) {
       if(mpfr_fits_sint_p(*x, (mp_rnd_t)SvUV(round))) return newSVuv(1);
       return newSVuv(0);
     }

#if defined MATH_MPFR_NEED_LONG_LONG_INT
#ifndef _MSC_VER
     if(sizeof(IV) == sizeof(intmax_t)) {
       if(mpfr_fits_intmax_p(*x, (mp_rnd_t)SvUV(round))) return newSVuv(1);
       return newSVuv(0);
     }
#else
     if(sizeof(IV) == sizeof(signed __int64)) {
       if(mpfr_fits_intmax_p(*x, (mp_rnd_t)SvUV(round))) return newSVuv(1);
       return newSVuv(0);
     }
#endif
#endif

     mpfr_init2(high, bits);
     mpfr_init2(low, bits);
     mpfr_init2(copy, bits - 1);

     mpfr_set_ui(high, 1, GMP_RNDN);
     mpfr_mul_2exp(high, high, bits - 1, GMP_RNDN);
     mpfr_sub_ui(high, high, 1, GMP_RNDN);

     mpfr_setsign(low, high, 1, GMP_RNDN);
     mpfr_sub_ui(low, low, 1, GMP_RNDN);
     mpfr_set(copy, *x, (mp_rnd_t)SvUV(round));

     if(mpfr_lessequal_p(copy, high) && mpfr_greaterequal_p(copy, low)) ret = 1;

     mpfr_clear(high);
     mpfr_clear(low);
     mpfr_clear(copy);

     return newSVuv(ret);
}

SV * Rmpfr_fits_UV_p(pTHX_ mpfr_t * x, SV * round) {
     unsigned long ret = 0, bits = sizeof(UV) * 8;
     mpfr_t high, copy;

     CHECK_ROUNDING_VALUE

     if(sizeof(UV) == sizeof(unsigned long)) {
#if defined(MPFR_VERSION) && MPFR_VERSION > NEG_ZERO_BUG
       return newSVuv(mpfr_fits_ulong_p(*x, (mp_rnd_t)SvUV(round)));
#else /* MPFR_VERSION unsatisfied */
       if((mp_rnd_t)SvUV(round) < 3) {
         if((mp_rnd_t)SvUV(round) == 0) {
           if((mpfr_cmp_d(*x, -0.5) >= 0) && (mpfr_cmp_d(*x, 0.0) <= 0)) return newSVuv(1);
         }
         else {
           if((mpfr_cmp_d(*x, -1.0) > 0) && (mpfr_cmp_d(*x, 0.0) <= 0)) return newSVuv(1);
         }
       }
       return newSVuv(mpfr_fits_ulong_p(*x, (mp_rnd_t)SvUV(round)));
#endif /* MPFR_VERSION */
     }

     if(sizeof(UV) == sizeof(unsigned int)) {
#if defined(MPFR_VERSION) && MPFR_VERSION > NEG_ZERO_BUG
       return newSVuv(mpfr_fits_uint_p(*x, (mp_rnd_t)SvUV(round)));
#else /* MPFR_VERSION unsatisfied */
       if((mp_rnd_t)SvUV(round) < 3) {
         if((mp_rnd_t)SvUV(round) == 0) {
           if((mpfr_cmp_d(*x, -0.5) >= 0) && (mpfr_cmp_d(*x, 0.0) <= 0)) return newSVuv(1);
         }
         else {
           if((mpfr_cmp_d(*x, -1.0) > 0) && (mpfr_cmp_d(*x, 0.0) <= 0)) return newSVuv(1);
         }
       }
       return newSVuv(mpfr_fits_uint_p(*x, (mp_rnd_t)SvUV(round)));
#endif /* MPFR_VERSION */
     }

#if defined MATH_MPFR_NEED_LONG_LONG_INT
#ifndef _MSC_VER
     if(sizeof(UV) == sizeof(uintmax_t)) {
#if defined(MPFR_VERSION) && MPFR_VERSION > NEG_ZERO_BUG
       return newSVuv(mpfr_fits_uintmax_p(*x, (mp_rnd_t)SvUV(round)));
#else /* MPFR_VERSION unsatisfied */
       if((mp_rnd_t)SvUV(round) < 3) {
         if((mp_rnd_t)SvUV(round) == 0) {
           if((mpfr_cmp_d(*x, -0.5) >= 0) && (mpfr_cmp_d(*x, 0.0) <= 0)) return newSVuv(1);
         }
         else {
           if((mpfr_cmp_d(*x, -1.0) > 0) && (mpfr_cmp_d(*x, 0.0) <= 0)) return newSVuv(1);
         }
       }
       return newSVuv(mpfr_fits_uintmax_p(*x, (mp_rnd_t)SvUV(round)));
#endif /* MPFR_VERSION */
     }
#else /* _MSC_VER defined */
     if(sizeof(UV) == sizeof(unsigned __int64)) {
#if defined(MPFR_VERSION) && MPFR_VERSION > NEG_ZERO_BUG
       return newSVuv(mpfr_fits_uintmax_p(*x, (mp_rnd_t)SvUV(round)));
#else /* MPFR_VERSION unsatisfied */
       if((mp_rnd_t)SvUV(round) < 3) {
         if((mp_rnd_t)SvUV(round) == 0) {
           if((mpfr_cmp_d(*x, -0.5) >= 0) && (mpfr_cmp_d(*x, 0.0) <= 0)) return newSVuv(1);
         }
         else {
           if((mpfr_cmp_d(*x, -1.0) > 0) && (mpfr_cmp_d(*x, 0.0) <= 0)) return newSVuv(1);
         }
       }
       return newSVuv(mpfr_fits_uintmax_p(*x, (mp_rnd_t)SvUV(round)));
#endif /* MPFR_VERSION */
     }
#endif /* MSC_VER */
#endif /* MATH_MPFR_NEED_LONG_LONG_INT */

     mpfr_init2(high, bits + 1);
     mpfr_init2(copy, bits);

     mpfr_set_ui(high, 1, GMP_RNDN);
     mpfr_mul_2exp(high, high, bits, GMP_RNDN);
     mpfr_sub_ui(high, high, 1, GMP_RNDN);

     mpfr_set(copy, *x, (mp_rnd_t)SvUV(round));

     if(mpfr_lessequal_p(copy, high) && mpfr_cmp_ui(copy, 0) >= 0) ret = 1;

     mpfr_clear(high);
     mpfr_clear(copy);

     return newSVuv(ret);
}

SV * Rmpfr_strtofr(pTHX_ mpfr_t * a, SV * str, SV * base, SV * round) {
     int b = (int)SvIV(base);
     /* char ** endptr; */
#if MPFR_VERSION_MAJOR < 3
     CHECK_ROUNDING_VALUE
     if(b < 0 || b > MAXIMUM_ALLOWABLE_BASE || b == 1)
        croak("3rd argument supplied to Rmpfr_strtofr is out of allowable range");
#else
     if(b < 0 || b > 62 || b == 1) croak("3rd argument supplied to Rmpfr_strtofr is out of allowable range");
#endif
     return newSViv(mpfr_strtofr(*a, SvPV_nolen(str), NULL, b, (mp_rnd_t)SvUV(round)));
}

void Rmpfr_set_erangeflag(void) {
     mpfr_set_erangeflag();
}

void Rmpfr_set_underflow(void) {
     mpfr_set_underflow();
}

void Rmpfr_set_overflow(void) {
     mpfr_set_overflow();
}

void Rmpfr_set_nanflag(void) {
     mpfr_set_nanflag();
}

void Rmpfr_set_inexflag(void) {
     mpfr_set_inexflag();
}

SV * Rmpfr_erfc(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_erfc(*a, *b, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_j0(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_j0(*a, *b, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_j1(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_j1(*a, *b, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_jn(pTHX_ mpfr_t * a, SV * n, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_jn(*a, (long)SvIV(n), *b, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_y0(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_y0(*a, *b, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_y1(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_y1(*a, *b, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_yn(pTHX_ mpfr_t * a, SV * n, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_yn(*a, (long)SvIV(n), *b, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_atan2(pTHX_ mpfr_t * a, mpfr_t * b, mpfr_t * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_atan2(*a, *b, *c, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_pow_z(pTHX_ mpfr_t * a, mpfr_t * b, mpz_t * c,  SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_pow_z(*a, *b, *c, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_subnormalize(pTHX_ mpfr_t * a, SV * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_subnormalize(*a, (int)SvIV(b), (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_const_catalan(pTHX_ mpfr_t * a, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_const_catalan(*a, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_sec(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_sec(*a, *b, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_csc(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_csc(*a, *b, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_cot(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_cot(*a, *b, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_root(pTHX_ mpfr_t * a, mpfr_t * b, SV * c, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_root(*a, *b, (unsigned long)SvUV(c), (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_eint(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_eint(*a, *b, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_li2(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_li2(*a, *b, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_get_f(pTHX_ mpf_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_get_f(*a, *b, (mp_rnd_t)SvUV(round)));
}

/* No need for rounding as result will be exact */
void Rmpfr_get_q(mpq_t * a, mpfr_t * b) {
     mpf_t temp;

     if(!mpfr_number_p(*b)) {
       mpq_set_ui(*a, 0, 1);
       mpfr_set_erangeflag();
     }
     else {
       mpf_init2 (temp, (mp_bitcnt_t)mpfr_get_prec(*b));
       mpfr_get_f(temp, *b, GMP_RNDN);
       mpq_set_f (*a, temp);
       mpf_clear(temp);
     }
}

SV * Rmpfr_sech(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_sech(*a, *b, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_csch(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_csch(*a, *b, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_coth(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
     return newSViv(mpfr_coth(*a, *b, (mp_rnd_t)SvUV(round)));
}

SV * Rmpfr_lngamma(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     CHECK_ROUNDING_VALUE
#if !defined(MPFR_VERSION) || (defined(MPFR_VERSION) && MPFR_VERSION <= LNGAMMA_BUG)
     if(!mpfr_nan_p(*b) && mpfr_sgn(*b) <= 0) {
       mpfr_set_inf(*a, 1);
       return newSViv(0);
     }
#endif
     return newSViv(mpfr_lngamma(*a, *b, (mp_rnd_t)SvUV(round)));
}

void Rmpfr_lgamma(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
     dXSARGS;
     int ret, signp;
     CHECK_ROUNDING_VALUE
     ret = mpfr_lgamma(*a, &signp, *b, (mp_rnd_t)SvUV(round));
     ST(0) = sv_2mortal(newSViv(signp));
     ST(1) = sv_2mortal(newSViv(ret));
     XSRETURN(2);
}

SV * _MPFR_VERSION(pTHX) {
#if defined(MPFR_VERSION)
     return newSVuv(MPFR_VERSION);
#else
     return &PL_sv_undef;
#endif
}

SV * _MPFR_VERSION_MAJOR(pTHX) {
     return newSVuv(MPFR_VERSION_MAJOR);
}

SV * _MPFR_VERSION_MINOR(pTHX) {
     return newSVuv(MPFR_VERSION_MINOR);
}

SV * _MPFR_VERSION_PATCHLEVEL(pTHX) {
     return newSVuv(MPFR_VERSION_PATCHLEVEL);
}

SV * _MPFR_VERSION_STRING(pTHX) {
     return newSVpv(MPFR_VERSION_STRING, 0);
}

SV * RMPFR_VERSION_NUM(pTHX_ SV * a, SV * b, SV * c) {
     return newSVuv(MPFR_VERSION_NUM((unsigned long)SvUV(a), (unsigned long)SvUV(b), (unsigned long)SvUV(c)));
}

SV * Rmpfr_sum(pTHX_ mpfr_t * rop, SV * avref, SV * len, SV * round) {
     mpfr_ptr *p;
     SV ** elem;
     int ret, i;
     unsigned long s = (unsigned long)SvUV(len);

     if(s > av_len((AV*)SvRV(avref)) + 1)croak("2nd last arg (%d) needs to be between 0 and %d (inclusive)", s, av_len((AV*)SvRV(avref)) + 1);

     CHECK_ROUNDING_VALUE

     Newx(p, s, mpfr_ptr);
     if(p == NULL) croak("Unable to allocate memory in Rmpfr_sum");

     for(i = 0; i < s; ++i) {
        elem = av_fetch((AV*)SvRV(avref), i, 0);
        p[i] = (INT2PTR(mpfr_t *, SvIV(SvRV(*elem))))[0];
     }

     ret = mpfr_sum(*rop, p, s, (mp_rnd_t)SvUV(round));

     Safefree(p);
     return newSVuv(ret);
}

SV * overload_mul(pTHX_ SV * a, SV * b, SV * third) {
     mpfr_t * mpfr_t_obj, t;
     SV * obj_ref, * obj;
     int ret;

     Newx(mpfr_t_obj, 1, mpfr_t);
     if(mpfr_t_obj == NULL) croak("Failed to allocate memory in overload_mul function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::MPFR");
     mpfr_init(*mpfr_t_obj);
     sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
     SvREADONLY_on(obj);

#ifdef MATH_MPFR_NEED_LONG_LONG_INT
#ifndef _MSC_VER
     if(SvUOK(b)) {
       mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
       mpfr_set_uj(t, SvUV(b), __gmpfr_default_rounding_mode);
       mpfr_mul(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return obj_ref;
     }

     if(SvIOK(b)) {
       mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
       mpfr_set_sj(t, SvIV(b), __gmpfr_default_rounding_mode);
       mpfr_mul(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return obj_ref;
     }
#else
     if(SvIOK(b)) {
       ret = mpfr_set_str(*mpfr_t_obj, SvPV_nolen(b), 10, __gmpfr_default_rounding_mode);
       if(ret) {
         nnum++;
         if(SvIV(get_sv("Math::MPFR::NNW", 0)))
           warn("string used in overloaded multiplication (*) contains non-numeric characters");
       }
       mpfr_mul(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), *mpfr_t_obj, __gmpfr_default_rounding_mode);
       return obj_ref;
     }
#endif
#else
     if(SvUOK(b)) {
       mpfr_mul_ui(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), SvUV(b), __gmpfr_default_rounding_mode);
       return obj_ref;
     }

     if(SvIOK(b)) {
       mpfr_mul_si(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), SvIV(b), __gmpfr_default_rounding_mode);
       return obj_ref;
     }
#endif

     if(SvNOK(b)) {

#if defined(CAN_PASS_FLOAT128)

       mpfr_init2(t, FLT128_MANT_DIG);
       mpfr_set_float128(t, (float128)SvNV(b), __gmpfr_default_rounding_mode);
       mpfr_mul(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return obj_ref;
     }

#elif defined(USE_LONG_DOUBLE)

       mpfr_init2(t, REQUIRED_LDBL_MANT_DIG);
       mpfr_set_ld(t, (long double)SvNV(b), __gmpfr_default_rounding_mode);
       mpfr_mul(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return obj_ref;
     }

#else
       mpfr_mul_d(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), (double)SvNV(b), __gmpfr_default_rounding_mode);
       return obj_ref;
     }

#endif

     if(SvPOK(b)) {
       ret = mpfr_set_str(*mpfr_t_obj, SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);
       if(ret) {
         nnum++;
         if(SvIV(get_sv("Math::MPFR::NNW", 0)))
           warn("string used in overloaded multiplication (*) contains non-numeric characters");
       }
       mpfr_mul(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), *mpfr_t_obj, __gmpfr_default_rounding_mode);
       return obj_ref;
     }

     if(sv_isobject(b)) {
       const char* h = HvNAME(SvSTASH(SvRV(b)));

       if(strEQ(h, "Math::MPFR")) {
         mpfr_mul(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(b)))), __gmpfr_default_rounding_mode);
         return obj_ref;
       }
       if(strEQ(h, "Math::GMPz")) {

         mpfr_mul_z(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))),
                                 *(INT2PTR(mpz_t * , SvIV(SvRV(b)))),
                                 __gmpfr_default_rounding_mode);
         return obj_ref;
       }
       if(strEQ(h, "Math::GMPq")) {

         mpfr_mul_q(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))),
                                 *(INT2PTR(mpq_t * , SvIV(SvRV(b)))),
                                 __gmpfr_default_rounding_mode);
         return obj_ref;
       }
       if(strEQ(h, "Math::GMPf")) {
         mpfr_init2(t, (mpfr_prec_t)mpf_get_prec(*(INT2PTR(mpf_t *, SvIV(SvRV(b))))));
         mpfr_set_f(t, *(INT2PTR(mpf_t *, SvIV(SvRV(b)))), __gmpfr_default_rounding_mode);
         mpfr_mul(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), t, __gmpfr_default_rounding_mode);
         mpfr_clear(t);
         return obj_ref;
       }
     }

     croak("Invalid argument supplied to Math::MPFR::overload_mul");
}

SV * overload_add(pTHX_ SV * a, SV * b, SV * third) {
     mpfr_t * mpfr_t_obj, t;
     SV * obj_ref, * obj;
     int ret;

     Newx(mpfr_t_obj, 1, mpfr_t);
     if(mpfr_t_obj == NULL) croak("Failed to allocate memory in overload_add function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::MPFR");
     mpfr_init(*mpfr_t_obj);
     sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
     SvREADONLY_on(obj);

#ifdef MATH_MPFR_NEED_LONG_LONG_INT
#ifndef _MSC_VER
     if(SvUOK(b)) {
       mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
       mpfr_set_uj(t, SvUV(b), __gmpfr_default_rounding_mode);
       mpfr_add(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return obj_ref;
     }

     if(SvIOK(b)) {
       mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
       mpfr_set_sj(t, SvIV(b), __gmpfr_default_rounding_mode);
       mpfr_add(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return obj_ref;
     }
#else
     if(SvIOK(b)) {
       ret = mpfr_set_str(*mpfr_t_obj, SvPV_nolen(b), 10, __gmpfr_default_rounding_mode);
       if(ret) {
         nnum++;
         if(SvIV(get_sv("Math::MPFR::NNW", 0)))
           warn("string used in overloaded addition (+) contains non-numeric characters");
       }
       mpfr_add(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), *mpfr_t_obj, __gmpfr_default_rounding_mode);
       return obj_ref;
     }
#endif
#else
     if(SvUOK(b)) {
       mpfr_add_ui(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), SvUV(b), __gmpfr_default_rounding_mode);
       return obj_ref;
     }

     if(SvIOK(b)) {
       mpfr_add_si(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), SvIV(b), __gmpfr_default_rounding_mode);
       return obj_ref;
     }
#endif

     if(SvNOK(b)) {
#if defined(CAN_PASS_FLOAT128)

       mpfr_init2(t, FLT128_MANT_DIG);
       mpfr_set_float128(t, (float128)SvNV(b), __gmpfr_default_rounding_mode);
       mpfr_add(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return obj_ref;
     }

#elif defined(USE_LONG_DOUBLE)

       mpfr_init2(t, REQUIRED_LDBL_MANT_DIG);
       mpfr_set_ld(t, (long double)SvNV(b), __gmpfr_default_rounding_mode);
       mpfr_add(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return obj_ref;
     }

#else
       mpfr_add_d(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), (double)SvNV(b), __gmpfr_default_rounding_mode);
       return obj_ref;
     }

#endif

     if(SvPOK(b)) {
       ret = mpfr_set_str(*mpfr_t_obj, SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);
       if(ret) {
         nnum++;
         if(SvIV(get_sv("Math::MPFR::NNW", 0)))
           warn("string used in overloaded addition (+) contains non-numeric characters");
       }
       mpfr_add(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), *mpfr_t_obj, __gmpfr_default_rounding_mode);
       return obj_ref;
     }

     if(sv_isobject(b)) {
       const char* h = HvNAME(SvSTASH(SvRV(b)));

       if(strEQ(h, "Math::MPFR")) {
         mpfr_add(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))),
                               *(INT2PTR(mpfr_t *, SvIV(SvRV(b)))),
                               __gmpfr_default_rounding_mode);
         return obj_ref;
       }
       if(strEQ(h, "Math::GMPz")) {
         mpfr_add_z(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))),
                                 *(INT2PTR(mpz_t * , SvIV(SvRV(b)))),
                                 __gmpfr_default_rounding_mode);
         return obj_ref;
       }
       if(strEQ(h, "Math::GMPq")) {
         mpfr_add_q(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))),
                                 *(INT2PTR(mpq_t * , SvIV(SvRV(b)))),
                                 __gmpfr_default_rounding_mode);
         return obj_ref;
       }
       if(strEQ(h, "Math::GMPf")) {
         mpfr_init2(t, (mpfr_prec_t)mpf_get_prec(*(INT2PTR(mpf_t *, SvIV(SvRV(b))))));
         mpfr_set_f(t, *(INT2PTR(mpf_t *, SvIV(SvRV(b)))), __gmpfr_default_rounding_mode);
         mpfr_add(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), t, __gmpfr_default_rounding_mode);
         mpfr_clear(t);
         return obj_ref;
       }
     }

     croak("Invalid argument supplied to Math::MPFR::overload_add");
}

SV * overload_sub(pTHX_ SV * a, SV * b, SV * third) {
     mpfr_t * mpfr_t_obj, t;
     SV * obj_ref, * obj;
     int ret;

     Newx(mpfr_t_obj, 1, mpfr_t);
     if(mpfr_t_obj == NULL) croak("Failed to allocate memory in overload_sub function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::MPFR");
     mpfr_init(*mpfr_t_obj);
     sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
     SvREADONLY_on(obj);

#ifdef MATH_MPFR_NEED_LONG_LONG_INT
#ifndef _MSC_VER
     if(SvUOK(b)) {
       mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
       mpfr_set_uj(t, SvUV(b), __gmpfr_default_rounding_mode);
       if(third == &PL_sv_yes) mpfr_sub(*mpfr_t_obj, t, *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), __gmpfr_default_rounding_mode);
       else mpfr_sub(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return obj_ref;
     }

     if(SvIOK(b)) {
       mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
       mpfr_set_sj(t, SvIV(b), __gmpfr_default_rounding_mode);
       if(third == &PL_sv_yes) mpfr_sub(*mpfr_t_obj, t, *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), __gmpfr_default_rounding_mode);
       else mpfr_sub(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return obj_ref;
     }
#else
     if(SvIOK(b)) {
       ret = mpfr_set_str(*mpfr_t_obj, SvPV_nolen(b), 10, __gmpfr_default_rounding_mode);
       if(ret) {
         nnum++;
         if(SvIV(get_sv("Math::MPFR::NNW", 0)))
           warn("string used in overloaded subtraction (-) contains non-numeric characters");
       }
       if(third == &PL_sv_yes) mpfr_sub(*mpfr_t_obj, *mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), __gmpfr_default_rounding_mode);
       else mpfr_sub(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), *mpfr_t_obj, __gmpfr_default_rounding_mode);
       return obj_ref;
     }
#endif
#else
     if(SvUOK(b)) {
       if(third == &PL_sv_yes) mpfr_ui_sub(*mpfr_t_obj, SvUV(b), *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), __gmpfr_default_rounding_mode);
       else mpfr_sub_ui(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), SvUV(b), __gmpfr_default_rounding_mode);
       return obj_ref;
     }

     if(SvIOK(b)) {
       if(third == &PL_sv_yes) mpfr_si_sub(*mpfr_t_obj, SvIV(b), *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), __gmpfr_default_rounding_mode);
       else mpfr_sub_si(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), SvIV(b), __gmpfr_default_rounding_mode);
       return obj_ref;
     }
#endif

     if(SvNOK(b)) {
#if defined(CAN_PASS_FLOAT128)

       mpfr_init2(t, FLT128_MANT_DIG);
       mpfr_set_float128(t, (float128)SvNV(b), __gmpfr_default_rounding_mode);
       if(third == &PL_sv_yes) mpfr_sub(*mpfr_t_obj, t, *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), __gmpfr_default_rounding_mode);
       else mpfr_sub(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return obj_ref;
     }
#elif defined(USE_LONG_DOUBLE)

       mpfr_init2(t, REQUIRED_LDBL_MANT_DIG);
       mpfr_set_ld(t, (long double)SvNV(b), __gmpfr_default_rounding_mode);
       if(third == &PL_sv_yes) mpfr_sub(*mpfr_t_obj, t, *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), __gmpfr_default_rounding_mode);
       else mpfr_sub(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return obj_ref;
     }

#else

       if(third == &PL_sv_yes) mpfr_d_sub(*mpfr_t_obj, SvNV(b), *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), __gmpfr_default_rounding_mode);
       else mpfr_sub_d(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), SvNV(b), __gmpfr_default_rounding_mode);
       return obj_ref;
     }

#endif


     if(SvPOK(b)) {
       ret = mpfr_set_str(*mpfr_t_obj, SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);
       if(ret) {
         nnum++;
         if(SvIV(get_sv("Math::MPFR::NNW", 0)))
           warn("2string used in overloaded subtraction (-) contains non-numeric characters");
       }
       if(third == &PL_sv_yes) mpfr_sub(*mpfr_t_obj, *mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), __gmpfr_default_rounding_mode);
       else mpfr_sub(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), *mpfr_t_obj, __gmpfr_default_rounding_mode);
       return obj_ref;
     }

     if(sv_isobject(b)) {
       const char* h = HvNAME(SvSTASH(SvRV(b)));

       if(strEQ(h, "Math::MPFR")) {
         mpfr_sub(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(b)))), __gmpfr_default_rounding_mode);
         return obj_ref;
       }
       if(strEQ(h, "Math::GMPz")) {
         mpfr_sub_z(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))),
                                      *(INT2PTR(mpz_t * , SvIV(SvRV(b)))),
                                      __gmpfr_default_rounding_mode);
         if(third == &PL_sv_yes) mpfr_neg(*mpfr_t_obj, *mpfr_t_obj, GMP_RNDN);
         return obj_ref;
       }
       if(strEQ(h, "Math::GMPq")) {
         mpfr_sub_q(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))),
                                      *(INT2PTR(mpq_t * , SvIV(SvRV(b)))),
                                      __gmpfr_default_rounding_mode);
         if(third == &PL_sv_yes) mpfr_neg(*mpfr_t_obj, *mpfr_t_obj, GMP_RNDN);
         return obj_ref;
       }
       if(strEQ(h, "Math::GMPf")) {
         mpfr_init2(t, (mpfr_prec_t)mpf_get_prec(*(INT2PTR(mpf_t *, SvIV(SvRV(b))))));
         mpfr_set_f(t, *(INT2PTR(mpf_t *, SvIV(SvRV(b)))), __gmpfr_default_rounding_mode);
         if(third == &PL_sv_yes) mpfr_sub(*mpfr_t_obj, t, *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), __gmpfr_default_rounding_mode);
         else mpfr_sub(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), t, __gmpfr_default_rounding_mode);
         mpfr_clear(t);
         return obj_ref;
       }
     }

     croak("Invalid argument supplied to Math::MPFR::overload_sub function");
}

SV * overload_div(pTHX_ SV * a, SV * b, SV * third) {
     mpfr_t * mpfr_t_obj, t;
     SV * obj_ref, * obj;
     int ret;

     Newx(mpfr_t_obj, 1, mpfr_t);
     if(mpfr_t_obj == NULL) croak("Failed to allocate memory in overload_div function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::MPFR");
     mpfr_init(*mpfr_t_obj);
     sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
     SvREADONLY_on(obj);

#ifdef MATH_MPFR_NEED_LONG_LONG_INT
#ifndef _MSC_VER
     if(SvUOK(b)) {
       mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
       mpfr_set_uj(t, SvUV(b), __gmpfr_default_rounding_mode);
       if(third == &PL_sv_yes) mpfr_div(*mpfr_t_obj, t, *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), __gmpfr_default_rounding_mode);
       else mpfr_div(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return obj_ref;
     }

     if(SvIOK(b)) {
       mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
       mpfr_set_sj(t, SvIV(b), __gmpfr_default_rounding_mode);
       if(third == &PL_sv_yes) mpfr_div(*mpfr_t_obj, t, *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), __gmpfr_default_rounding_mode);
       else mpfr_div(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return obj_ref;
     }
#else
     if(SvIOK(b)) {
       ret = mpfr_set_str(*mpfr_t_obj, SvPV_nolen(b), 10, __gmpfr_default_rounding_mode);
       if(ret) {
         nnum++;
         if(SvIV(get_sv("Math::MPFR::NNW", 0)))
           warn("string used in overloaded division (/) contains non-numeric characters");
       }
       if(third == &PL_sv_yes) mpfr_div(*mpfr_t_obj, *mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), __gmpfr_default_rounding_mode);
       else mpfr_div(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), *mpfr_t_obj, __gmpfr_default_rounding_mode);
       return obj_ref;
     }
#endif
#else
     if(SvUOK(b)) {
       if(third == &PL_sv_yes) mpfr_ui_div(*mpfr_t_obj, SvUV(b), *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), __gmpfr_default_rounding_mode);
       else mpfr_div_ui(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), SvUV(b), __gmpfr_default_rounding_mode);
       return obj_ref;
     }

     if(SvIOK(b)) {
       if(third == &PL_sv_yes) mpfr_si_div(*mpfr_t_obj, SvIV(b), *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), __gmpfr_default_rounding_mode);
       else mpfr_div_si(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), SvIV(b), __gmpfr_default_rounding_mode);
       return obj_ref;
     }
#endif

     if(SvNOK(b)) {
#if defined(CAN_PASS_FLOAT128)

       mpfr_init2(t, FLT128_MANT_DIG);
       mpfr_set_float128(t, (float128)SvNV(b), __gmpfr_default_rounding_mode);
       if(third == &PL_sv_yes) mpfr_div(*mpfr_t_obj, t, *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), __gmpfr_default_rounding_mode);
       else mpfr_div(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), t, __gmpfr_default_rounding_mode);
       return obj_ref;
       mpfr_clear(t);
     }

#elif defined(USE_LONG_DOUBLE)

       mpfr_init2(t, REQUIRED_LDBL_MANT_DIG);
       mpfr_set_ld(t, (long double)SvNV(b), __gmpfr_default_rounding_mode);
       if(third == &PL_sv_yes) mpfr_div(*mpfr_t_obj, t, *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), __gmpfr_default_rounding_mode);
       else mpfr_div(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return obj_ref;
     }

#else

       if(third == &PL_sv_yes) mpfr_d_div(*mpfr_t_obj, SvNV(b), *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), __gmpfr_default_rounding_mode);
       else mpfr_div_d(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), SvNV(b), __gmpfr_default_rounding_mode);
       return obj_ref;
     }

#endif

     if(SvPOK(b)) {
       ret = mpfr_set_str(*mpfr_t_obj, SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);
       if(ret) {
         nnum++;
         if(SvIV(get_sv("Math::MPFR::NNW", 0)))
           warn("string used in overloaded division (/) contains non-numeric characters");
       }
       if(third == &PL_sv_yes) mpfr_div(*mpfr_t_obj, *mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), __gmpfr_default_rounding_mode);
       else mpfr_div(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), *mpfr_t_obj, __gmpfr_default_rounding_mode);
       return obj_ref;
     }

     if(sv_isobject(b)) {
       const char* h = HvNAME(SvSTASH(SvRV(b)));

       if(strEQ(h, "Math::MPFR")) {
         mpfr_div(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(b)))), __gmpfr_default_rounding_mode);
         return obj_ref;
       }
       if(strEQ(h, "Math::GMPz")) {
         mpfr_div_z(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))),
                                      *(INT2PTR(mpz_t * , SvIV(SvRV(b)))),
                                      __gmpfr_default_rounding_mode);
         /* *mpfr_t_obj gets rounded a second time if third == &PL_sv_yes */
         if(third == &PL_sv_yes) mpfr_ui_div(*mpfr_t_obj, 1, *mpfr_t_obj, __gmpfr_default_rounding_mode);
         return obj_ref;
       }
       if(strEQ(h, "Math::GMPq")) {
         mpfr_div_q(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))),
                                      *(INT2PTR(mpq_t * , SvIV(SvRV(b)))),
                                      __gmpfr_default_rounding_mode);
         /* *mpfr_t_obj gets rounded a second time if third == &PL_sv_yes */
         if(third == &PL_sv_yes) mpfr_ui_div(*mpfr_t_obj, 1, *mpfr_t_obj, __gmpfr_default_rounding_mode);
         return obj_ref;
       }
       if(strEQ(h, "Math::GMPf")) {
         mpfr_init2(t, (mpfr_prec_t)mpf_get_prec(*(INT2PTR(mpf_t *, SvIV(SvRV(b))))));
         mpfr_set_f(t, *(INT2PTR(mpf_t *, SvIV(SvRV(b)))), __gmpfr_default_rounding_mode);
         if(third == &PL_sv_yes) mpfr_div(*mpfr_t_obj, t, *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), __gmpfr_default_rounding_mode);
         else mpfr_div(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), t, __gmpfr_default_rounding_mode);
         mpfr_clear(t);
         return obj_ref;
       }
     }

     croak("Invalid argument supplied to Math::MPFR::overload_div function");
}

SV * overload_copy(pTHX_ mpfr_t * p, SV * second, SV * third) {
     mpfr_t * mpfr_t_obj;
     SV * obj_ref, * obj;

     Newx(mpfr_t_obj, 1, mpfr_t);
     if(mpfr_t_obj == NULL) croak("Failed to allocate memory in overload_copy function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::MPFR");

     mpfr_init2(*mpfr_t_obj, mpfr_get_prec(*p));
     mpfr_set(*mpfr_t_obj, *p, __gmpfr_default_rounding_mode);
     sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
     SvREADONLY_on(obj);
     return obj_ref;
}

SV * overload_abs(pTHX_ mpfr_t * p, SV * second, SV * third) {
     mpfr_t * mpfr_t_obj;
     SV * obj_ref, * obj;

     Newx(mpfr_t_obj, 1, mpfr_t);
     if(mpfr_t_obj == NULL) croak("Failed to allocate memory in overload_abs function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::MPFR");
     mpfr_init(*mpfr_t_obj);

     mpfr_abs(*mpfr_t_obj, *p, __gmpfr_default_rounding_mode);
     sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
     SvREADONLY_on(obj);
     return obj_ref;
}

SV * overload_gt(pTHX_ mpfr_t * a, SV * b, SV * third) {
     mpfr_t t;
     int ret;

     if(mpfr_nan_p(*a)){
       mpfr_set_erangeflag();
       return newSVuv(0);
     }

#ifdef MATH_MPFR_NEED_LONG_LONG_INT
#ifndef _MSC_VER
     if(SvUOK(b)) {
       mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
       mpfr_set_uj(t, SvUV(b), __gmpfr_default_rounding_mode);
       ret = mpfr_cmp(*a, t);
       mpfr_clear(t);
       if(third == &PL_sv_yes) ret *= -1;
       if(ret > 0) return newSViv(1);
       return newSViv(0);
       }

     if(SvIOK(b)) {
       mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
       mpfr_set_sj(t, SvIV(b), __gmpfr_default_rounding_mode);
       ret = mpfr_cmp(*a, t);
       mpfr_clear(t);
       if(third == &PL_sv_yes) ret *= -1;
       if(ret > 0) return newSViv(1);
       return newSViv(0);
       }
#else
     if(SvIOK(b)) {
       ret = mpfr_init_set_str(t, SvPV_nolen(b), 10, __gmpfr_default_rounding_mode);
       if(ret) {
         nnum++;
         if(SvIV(get_sv("Math::MPFR::NNW", 0)))
           warn("string used in overloaded comparison (>) contains non-numeric characters");
       }
       ret = mpfr_cmp(*a, t);
       mpfr_clear(t);
       if(third == &PL_sv_yes) ret *= -1;
       if(ret > 0) return newSViv(1);
       return newSViv(0);
       }
#endif
#else
     if(SvUOK(b)) {
       ret = mpfr_cmp_ui(*a, SvUV(b));
       if(third == &PL_sv_yes) ret *= -1;
       if(ret > 0) return newSViv(1);
       return newSViv(0);
       }

     if(SvIOK(b)) {
       ret = mpfr_cmp_si(*a, SvIV(b));
       if(third == &PL_sv_yes) ret *= -1;
       if(ret > 0) return newSViv(1);
       return newSViv(0);
       }
#endif

     if(SvNOK(b)) {

       if(SvNV(b) != SvNV(b)) { /* it's a NaN */
         mpfr_set_erangeflag();
         return newSVuv(0);
       }

#if defined(CAN_PASS_FLOAT128)
       mpfr_init2(t, FLT128_MANT_DIG);
       mpfr_set_float128(t, (float128)SvNV(b), __gmpfr_default_rounding_mode);
       ret = mpfr_cmp(*a, t);
       mpfr_clear(t);
#elif defined(USE_LONG_DOUBLE)
       ret = mpfr_cmp_ld(*a, (long double)SvNV(b));
#else
       ret = mpfr_cmp_d(*a, (double)SvNV(b));
#endif
       if(third == &PL_sv_yes) ret *= -1;
       if(ret > 0) return newSViv(1);
       return newSViv(0);
       }

     if(SvPOK(b)) {
       ret = mpfr_init_set_str(t, SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);
       if(ret) {
         nnum++;
         if(SvIV(get_sv("Math::MPFR::NNW", 0)))
           warn("string used in overloaded comparison (>) contains non-numeric characters");
       }
       ret = mpfr_cmp(*a, t);
       mpfr_clear(t);
       if(third == &PL_sv_yes) ret *= -1;
       if(ret > 0) return newSViv(1);
       return newSViv(0);
       }

     if(sv_isobject(b)) {
       const char* h = HvNAME(SvSTASH(SvRV(b)));

       if(strEQ(h, "Math::MPFR")) {
          return newSVuv(mpfr_greater_p(*a, *(INT2PTR(mpfr_t *, SvIV(SvRV(b))))));
       }
     }

     croak("Invalid argument supplied to Math::MPFR::overload_gt");
}

SV * overload_gte(pTHX_ mpfr_t * a, SV * b, SV * third) {
     mpfr_t t;
     int ret;

     if(mpfr_nan_p(*a)){
       mpfr_set_erangeflag();
       return newSVuv(0);
     }

#ifdef MATH_MPFR_NEED_LONG_LONG_INT
#ifndef _MSC_VER
     if(SvUOK(b)) {
       mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
       mpfr_set_uj(t, SvUV(b), __gmpfr_default_rounding_mode);
       ret = mpfr_cmp(*a, t);
       mpfr_clear(t);
       if(third == &PL_sv_yes) ret *= -1;
       if(ret >= 0) return newSViv(1);
       return newSViv(0);
       }

     if(SvIOK(b)) {
       mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
       mpfr_set_sj(t, SvIV(b), __gmpfr_default_rounding_mode);
       ret = mpfr_cmp(*a, t);
       mpfr_clear(t);
       if(third == &PL_sv_yes) ret *= -1;
       if(ret >= 0) return newSViv(1);
       return newSViv(0);
       }
#else
     if(SvIOK(b)) {
       ret = mpfr_init_set_str(t, SvPV_nolen(b), 10, __gmpfr_default_rounding_mode);
       if(ret) {
         nnum++;
         if(SvIV(get_sv("Math::MPFR::NNW", 0)))
           warn("string used in overloaded comparison (>=) contains non-numeric characters");
       }
       ret = mpfr_cmp(*a, t);
       mpfr_clear(t);
       if(third == &PL_sv_yes) ret *= -1;
       if(ret >= 0) return newSViv(1);
       return newSViv(0);
       }
#endif
#else
     if(SvUOK(b)) {
       ret = mpfr_cmp_ui(*a, SvUV(b));
       if(third == &PL_sv_yes) ret *= -1;
       if(ret >= 0) return newSViv(1);
       return newSViv(0);
       }

     if(SvIOK(b)) {
       ret = mpfr_cmp_si(*a, SvIV(b));
       if(third == &PL_sv_yes) ret *= -1;
       if(ret >= 0) return newSViv(1);
       return newSViv(0);
       }
#endif

     if(SvNOK(b)) {

       if(SvNV(b) != SvNV(b)) { /* it's a NaN */
         mpfr_set_erangeflag();
         return newSVuv(0);
       }

#if defined(CAN_PASS_FLOAT128)
       mpfr_init2(t, FLT128_MANT_DIG);
       mpfr_set_float128(t, (float128)SvNV(b), __gmpfr_default_rounding_mode);
       ret = mpfr_cmp(*a, t);
       mpfr_clear(t);
#elif defined(USE_LONG_DOUBLE)
       ret = mpfr_cmp_ld(*a, (long double)SvNV(b));
#else
       ret = mpfr_cmp_d(*a, (double)SvNV(b));
#endif

       if(third == &PL_sv_yes) ret *= -1;
       if(ret >= 0) return newSViv(1);
       return newSViv(0);
       }

     if(SvPOK(b)) {
       ret = mpfr_init_set_str(t, SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);
       if(ret) {
         nnum++;
         if(SvIV(get_sv("Math::MPFR::NNW", 0)))
           warn("string used in overloaded comparison (>=) contains non-numeric characters");
       }
       ret = mpfr_cmp(*a, t);
       mpfr_clear(t);
       if(third == &PL_sv_yes) ret *= -1;
       if(ret >= 0) return newSViv(1);
       return newSViv(0);
       }

     if(sv_isobject(b)) {
       const char* h = HvNAME(SvSTASH(SvRV(b)));

       if(strEQ(h, "Math::MPFR")) {
         return newSVuv(mpfr_greaterequal_p(*a, *(INT2PTR(mpfr_t *, SvIV(SvRV(b))))));
         }
       }

     croak("Invalid argument supplied to Math::MPFR::overload_gte");
}

SV * overload_lt(pTHX_ mpfr_t * a, SV * b, SV * third) {
     mpfr_t t;
     int ret;

     if(mpfr_nan_p(*a)){
       mpfr_set_erangeflag();
       return newSVuv(0);
     }

#ifdef MATH_MPFR_NEED_LONG_LONG_INT
#ifndef _MSC_VER
     if(SvUOK(b)) {
       mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
       mpfr_set_uj(t, SvUV(b), __gmpfr_default_rounding_mode);
       ret = mpfr_cmp(*a, t);
       mpfr_clear(t);
       if(third == &PL_sv_yes) ret *= -1;
       if(ret < 0) return newSViv(1);
       return newSViv(0);
     }

     if(SvIOK(b)) {
       mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
       mpfr_set_sj(t, SvIV(b), __gmpfr_default_rounding_mode);
       ret = mpfr_cmp(*a, t);
       mpfr_clear(t);
       if(third == &PL_sv_yes) ret *= -1;
       if(ret < 0) return newSViv(1);
       return newSViv(0);
     }
#else
     if(SvIOK(b)) {
       ret = mpfr_init_set_str(t, SvPV_nolen(b), 10, __gmpfr_default_rounding_mode);
       if(ret) {
         nnum++;
         if(SvIV(get_sv("Math::MPFR::NNW", 0)))
           warn("string used in overloaded comparison (<) contains non-numeric characters");
       }
       ret = mpfr_cmp(*a, t);
       mpfr_clear(t);
       if(third == &PL_sv_yes) ret *= -1;
       if(ret < 0) return newSViv(1);
       return newSViv(0);
     }
#endif
#else
     if(SvUOK(b)) {
       ret = mpfr_cmp_ui(*a, SvUV(b));
       if(third == &PL_sv_yes) ret *= -1;
       if(ret < 0) return newSViv(1);
       return newSViv(0);
     }

     if(SvIOK(b)) {
       ret = mpfr_cmp_si(*a, SvIV(b));
       if(third == &PL_sv_yes) ret *= -1;
       if(ret < 0) return newSViv(1);
       return newSViv(0);
     }
#endif

     if(SvNOK(b)) {

       if(SvNV(b) != SvNV(b)) { /* it's a NaN */
         mpfr_set_erangeflag();
         return newSVuv(0);
       }

#if defined(CAN_PASS_FLOAT128)
       mpfr_init2(t, FLT128_MANT_DIG);
       mpfr_set_float128(t, (float128)SvNV(b), __gmpfr_default_rounding_mode);
       ret = mpfr_cmp(*a, t);
       mpfr_clear(t);
#elif defined(USE_LONG_DOUBLE)
       ret = mpfr_cmp_ld(*a, (long double)SvNV(b));
#else
       ret = mpfr_cmp_d(*a, (double)SvNV(b));
#endif

       if(third == &PL_sv_yes) ret *= -1;
       if(ret < 0) return newSViv(1);
       return newSViv(0);
     }

     if(SvPOK(b)) {
       ret = mpfr_init_set_str(t, SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);
       if(ret) {
         nnum++;
         if(SvIV(get_sv("Math::MPFR::NNW", 0)))
           warn("string used in overloaded comparison (<) contains non-numeric characters");
       }
       ret = mpfr_cmp(*a, t);
       mpfr_clear(t);
       if(third == &PL_sv_yes) ret *= -1;
       if(ret < 0) return newSViv(1);
       return newSViv(0);
     }

     if(sv_isobject(b)) {
       const char* h = HvNAME(SvSTASH(SvRV(b)));

       if(strEQ(h, "Math::MPFR")) {
         return newSVuv(mpfr_less_p(*a, *(INT2PTR(mpfr_t *, SvIV(SvRV(b))))));
       }
     }

     croak("Invalid argument supplied to Math::MPFR::overload_lt");
}

SV * overload_lte(pTHX_ mpfr_t * a, SV * b, SV * third) {
     mpfr_t t;
     int ret;

     if(mpfr_nan_p(*a)){
       mpfr_set_erangeflag();
       return newSVuv(0);
     }

#ifdef MATH_MPFR_NEED_LONG_LONG_INT
#ifndef _MSC_VER
     if(SvUOK(b)) {
       mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
       mpfr_set_uj(t, SvUV(b), __gmpfr_default_rounding_mode);
       ret = mpfr_cmp(*a, t);
       mpfr_clear(t);
       if(third == &PL_sv_yes) ret *= -1;
       if(ret <= 0) return newSViv(1);
       return newSViv(0);
       }

     if(SvIOK(b)) {
       mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
       mpfr_set_sj(t, SvIV(b), __gmpfr_default_rounding_mode);
       ret = mpfr_cmp(*a, t);
       mpfr_clear(t);
       if(third == &PL_sv_yes) ret *= -1;
       if(ret <= 0) return newSViv(1);
       return newSViv(0);
       }
#else
     if(SvIOK(b)) {
       ret = mpfr_init_set_str(t, SvPV_nolen(b), 10, __gmpfr_default_rounding_mode);
       if(ret) {
         nnum++;
         if(SvIV(get_sv("Math::MPFR::NNW", 0)))
           warn("string used in overloaded comparison (<=) contains non-numeric characters");
       }
       ret = mpfr_cmp(*a, t);
       mpfr_clear(t);
       if(third == &PL_sv_yes) ret *= -1;
       if(ret <= 0) return newSViv(1);
       return newSViv(0);
       }
#endif
#else
     if(SvUOK(b)) {
       ret = mpfr_cmp_ui(*a, SvUV(b));
       if(third == &PL_sv_yes) ret *= -1;
       if(ret <= 0) return newSViv(1);
       return newSViv(0);
       }

     if(SvIOK(b)) {
       ret = mpfr_cmp_si(*a, SvIV(b));
       if(third == &PL_sv_yes) ret *= -1;
       if(ret <= 0) return newSViv(1);
       return newSViv(0);
       }
#endif

     if(SvNOK(b)) {

       if(SvNV(b) != SvNV(b)) { /* it's a NaN */
         mpfr_set_erangeflag();
         return newSVuv(0);
       }

#if defined(CAN_PASS_FLOAT128)
       mpfr_init2(t, FLT128_MANT_DIG);
       mpfr_set_float128(t, (float128)SvNV(b), __gmpfr_default_rounding_mode);
       ret = mpfr_cmp(*a, t);
       mpfr_clear(t);
#elif defined(USE_LONG_DOUBLE)
       ret = mpfr_cmp_ld(*a, (long double)SvNV(b));
#else
       ret = mpfr_cmp_d(*a, (double)SvNV(b));
#endif

       if(third == &PL_sv_yes) ret *= -1;
       if(ret <= 0) return newSViv(1);
       return newSViv(0);
     }

     if(SvPOK(b)) {
       ret = mpfr_init_set_str(t, SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);
       if(ret) {
         nnum++;
         if(SvIV(get_sv("Math::MPFR::NNW", 0)))
           warn("string used in overloaded comparison (<=) contains non-numeric characters");
       }
       ret = mpfr_cmp(*a, t);
       mpfr_clear(t);
       if(third == &PL_sv_yes) ret *= -1;
       if(ret <= 0) return newSViv(1);
       return newSViv(0);
     }

     if(sv_isobject(b)) {
       const char* h = HvNAME(SvSTASH(SvRV(b)));

       if(strEQ(h, "Math::MPFR"))
         return newSVuv(mpfr_lessequal_p(*a, *(INT2PTR(mpfr_t *, SvIV(SvRV(b))))));
     }

     croak("Invalid argument supplied to Math::MPFR::overload_lte");
}

SV * overload_spaceship(pTHX_ mpfr_t * a, SV * b, SV * third) {
     mpfr_t t;
     int ret;

     if(mpfr_nan_p(*a)) {
       mpfr_set_erangeflag();
       return &PL_sv_undef;
     }

#ifdef MATH_MPFR_NEED_LONG_LONG_INT
#ifndef _MSC_VER
     if(SvUOK(b)) {
       mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
       mpfr_set_uj(t, SvUV(b), __gmpfr_default_rounding_mode);
       ret = mpfr_cmp(*a, t);
       mpfr_clear(t);
       if(third == &PL_sv_yes) ret *= -1;
       if(ret < 0) return newSViv(-1);
       if(ret > 0) return newSViv(1);
       return newSViv(0);
       }

     if(SvIOK(b)) {
       mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
       mpfr_set_sj(t, SvIV(b), __gmpfr_default_rounding_mode);
       ret = mpfr_cmp(*a, t);
       mpfr_clear(t);
       if(third == &PL_sv_yes) ret *= -1;
       if(ret < 0) return newSViv(-1);
       if(ret > 0) return newSViv(1);
       return newSViv(0);
       }
#else
     if(SvIOK(b)) {
       ret = mpfr_init_set_str(t, SvPV_nolen(b), 10, __gmpfr_default_rounding_mode);
       if(ret) {
         nnum++;
         if(SvIV(get_sv("Math::MPFR::NNW", 0)))
           warn("string used in overloaded comparison (<=>) contains non-numeric characters");
       }
       ret = mpfr_cmp(*a, t);
       mpfr_clear(t);
       if(third == &PL_sv_yes) ret *= -1;
       if(ret < 0) return newSViv(-1);
       if(ret > 0) return newSViv(1);
       return newSViv(0);
       }
#endif
#else
     if(SvUOK(b)) {
       ret = mpfr_cmp_ui(*a, SvUV(b));
       if(third == &PL_sv_yes) ret *= -1;
       if(ret < 0) return newSViv(-1);
       if(ret > 0) return newSViv(1);
       return newSViv(0);
       }

     if(SvIOK(b)) {
       ret = mpfr_cmp_si(*a, SvIV(b));
       if(third == &PL_sv_yes) ret *= -1;
       if(ret < 0) return newSViv(-1);
       if(ret > 0) return newSViv(1);
       return newSViv(0);
       }
#endif

     if(SvNOK(b)) {

       if(SvNV(b) != SvNV(b)) { /* it's a NaN */
       mpfr_set_erangeflag();
       return &PL_sv_undef;
     }

#if defined(CAN_PASS_FLOAT128)
       mpfr_init2(t, FLT128_MANT_DIG);
       mpfr_set_float128(t, (float128)SvNV(b), __gmpfr_default_rounding_mode);
       ret = mpfr_cmp(*a, t);
       mpfr_clear(t);
#elif defined(USE_LONG_DOUBLE)
       ret = mpfr_cmp_ld(*a, (long double)SvNV(b));
#else
       ret = mpfr_cmp_d(*a, (double)SvNV(b));
#endif

       if(third == &PL_sv_yes) ret *= -1;
       if(ret < 0) return newSViv(-1);
       if(ret > 0) return newSViv(1);
       return newSViv(0);
     }

     if(SvPOK(b)) {
       ret = mpfr_init_set_str(t, SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);
       if(ret) {
         nnum++;
         if(SvIV(get_sv("Math::MPFR::NNW", 0)))
           warn("string used in overloaded comparison (<=>) contains non-numeric characters");
       }
       ret = mpfr_cmp(*a, t);
       mpfr_clear(t);
       if(third == &PL_sv_yes) ret *= -1;
       if(ret < 0) return newSViv(-1);
       if(ret > 0) return newSViv(1);
       return newSViv(0);
     }

     if(sv_isobject(b)) {
       const char* h = HvNAME(SvSTASH(SvRV(b)));

       if(strEQ(h, "Math::MPFR")) {
         return newSViv(mpfr_cmp(*a, *(INT2PTR(mpfr_t *, SvIV(SvRV(b))))));
       }
     }

     croak("Invalid argument supplied to Math::MPFR::overload_spaceship");
}

SV * overload_equiv(pTHX_ mpfr_t * a, SV * b, SV * third) {
     mpfr_t t;
     int ret;

     if(mpfr_nan_p(*a)){
       mpfr_set_erangeflag();
       return newSVuv(0);
     }

#ifdef MATH_MPFR_NEED_LONG_LONG_INT
#ifndef _MSC_VER
     if(SvUOK(b)) {
       mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
       mpfr_set_uj(t, SvUV(b), __gmpfr_default_rounding_mode);
       ret = mpfr_cmp(*a, t);
       mpfr_clear(t);
       if(ret == 0) return newSViv(1);
       return newSViv(0);
     }

     if(SvIOK(b)) {
       mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
       mpfr_set_sj(t, SvIV(b), __gmpfr_default_rounding_mode);
       ret = mpfr_cmp(*a, t);
       mpfr_clear(t);
       if(ret == 0) return newSViv(1);
       return newSViv(0);
     }
#else
     if(SvIOK(b)) {
       ret =  mpfr_init_set_str(t, (char *)SvPV_nolen(b), 10, __gmpfr_default_rounding_mode);
       if(ret) {
         nnum++;
         if(SvIV(get_sv("Math::MPFR::NNW", 0)))
           warn("string used in overloaded comparison (==) contains non-numeric characters");
       }
       ret = mpfr_cmp(*a, t);
       mpfr_clear(t);
       if(ret == 0) return newSViv(1);
       return newSViv(0);
     }
#endif
#else
     if(SvUOK(b)) {
       ret = mpfr_cmp_ui(*a, SvUV(b));
       if(ret == 0) return newSViv(1);
       return newSViv(0);
     }

     if(SvIOK(b)) {
       ret = mpfr_cmp_si(*a, SvIV(b));
       if(ret == 0) return newSViv(1);
       return newSViv(0);
     }
#endif

     if(SvNOK(b)) {

       if(SvNV(b) != SvNV(b)) { /* it's a NaN */
         mpfr_set_erangeflag();
         return newSVuv(0);
       }

#if defined(CAN_PASS_FLOAT128)
       mpfr_init2(t, FLT128_MANT_DIG);
       mpfr_set_float128(t, (float128)SvNV(b), __gmpfr_default_rounding_mode);
       ret = mpfr_cmp(*a, t);
       mpfr_clear(t);
#elif defined(USE_LONG_DOUBLE)
       ret = mpfr_cmp_ld(*a, (long double)SvNV(b));
#else
       ret = mpfr_cmp_d(*a, (double)SvNV(b));
#endif

       if(ret == 0) return newSViv(1);
       return newSViv(0);
     }

     if(SvPOK(b)) {
       ret = mpfr_init_set_str(t, (char *)SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);
       if(ret) {
         nnum++;
         if(SvIV(get_sv("Math::MPFR::NNW", 0)))
           warn("string used in overloaded comparison (==) contains non-numeric characters");
       }
       ret = mpfr_cmp(*a, t);
       mpfr_clear(t);
       if(ret == 0) return newSViv(1);
       return newSViv(0);
     }

     if(sv_isobject(b)) {
       const char* h = HvNAME(SvSTASH(SvRV(b)));

       if(strEQ(h, "Math::MPFR")) {
         return newSVuv(mpfr_equal_p(*a, *(INT2PTR(mpfr_t *, SvIV(SvRV(b))))));
       }
     }

     croak("Invalid argument supplied to Math::MPFR::overload_equiv");
}

SV * overload_not_equiv(pTHX_ mpfr_t * a, SV * b, SV * third) {
     mpfr_t t;
     int ret;

     if(mpfr_nan_p(*a)){
       mpfr_set_erangeflag();
       return newSVuv(1);
     }

#ifdef MATH_MPFR_NEED_LONG_LONG_INT
#ifndef _MSC_VER
     if(SvUOK(b)) {
       mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
       mpfr_set_uj(t, SvUV(b), __gmpfr_default_rounding_mode);
       ret = mpfr_cmp(*a, t);
       mpfr_clear(t);
       if(ret != 0) return newSViv(1);
       return newSViv(0);
     }

     if(SvIOK(b)) {
       mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
       mpfr_set_sj(t, SvIV(b), __gmpfr_default_rounding_mode);
       ret = mpfr_cmp(*a, t);
       mpfr_clear(t);
       if(ret != 0) return newSViv(1);
       return newSViv(0);
     }
#else
     if(SvIOK(b)) {
       ret = mpfr_init_set_str(t, (char *)SvPV_nolen(b), 10, __gmpfr_default_rounding_mode);
       if(ret) {
         nnum++;
         if(SvIV(get_sv("Math::MPFR::NNW", 0)))
           warn("string used in overloaded comparison (!=) contains non-numeric characters");
       }
       ret = mpfr_cmp(*a, t);
       mpfr_clear(t);
       if(ret != 0) return newSViv(1);
       return newSViv(0);
     }
#endif
#else
     if(SvUOK(b)) {
       ret = mpfr_cmp_ui(*a, SvUV(b));
       if(ret != 0) return newSViv(1);
       return newSViv(0);
     }

     if(SvIOK(b)) {
       ret = mpfr_cmp_si(*a, SvIV(b));
       if(ret != 0) return newSViv(1);
       return newSViv(0);
   }
#endif

     if(SvNOK(b)) {

       if(SvNV(b) != SvNV(b)) { /* it's a NaN */
         mpfr_set_erangeflag();
         return newSVuv(1);
       }

#if defined(CAN_PASS_FLOAT128)
       mpfr_init2(t, FLT128_MANT_DIG);
       mpfr_set_float128(t, (float128)SvNV(b), __gmpfr_default_rounding_mode);
       ret = mpfr_cmp(*a, t);
       mpfr_clear(t);
#elif defined(USE_LONG_DOUBLE)
       ret = mpfr_cmp_ld(*a, (long double)SvNV(b));
#else
       ret = mpfr_cmp_d(*a, (double)SvNV(b));
#endif

       if(ret != 0) return newSViv(1);
       return newSViv(0);
     }

     if(SvPOK(b)) {
       ret = mpfr_init_set_str(t, (char *)SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);
       if(ret) {
         nnum++;
         if(SvIV(get_sv("Math::MPFR::NNW", 0)))
           warn("string used in overloaded comparison (!=) contains non-numeric characters");
       }
       ret = mpfr_cmp(*a, t);
       mpfr_clear(t);
       if(ret != 0) return newSViv(1);
       return newSViv(0);
       }

     if(sv_isobject(b)) {
       const char* h = HvNAME(SvSTASH(SvRV(b)));

       if(strEQ(h, "Math::MPFR")) {
         if(mpfr_equal_p(*a, *(INT2PTR(mpfr_t *, SvIV(SvRV(b)))))) return newSViv(0);
         return newSViv(1);
       }
     }

     croak("Invalid argument supplied to Math::MPFR::overload_not_equiv");
}

SV * overload_true(pTHX_ mpfr_t *a, SV *second, SV * third) {
     if(mpfr_nan_p(*a)) return newSVuv(0);
     if(mpfr_cmp_ui(*a, 0)) return newSVuv(1);
     return newSVuv(0);
}

SV * overload_not(pTHX_ mpfr_t * a, SV * second, SV * third) {
     if(mpfr_nan_p(*a)) return newSViv(1);
     if(mpfr_cmp_ui(*a, 0)) return newSViv(0);
     return newSViv(1);
}

SV * overload_sqrt(pTHX_ mpfr_t * p, SV * second, SV * third) {
     mpfr_t * mpfr_t_obj;
     SV * obj_ref, * obj;

     Newx(mpfr_t_obj, 1, mpfr_t);
     if(mpfr_t_obj == NULL) croak("Failed to allocate memory in overload_sqrt function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::MPFR");
     mpfr_init(*mpfr_t_obj);

     /* No - this was wrong. If a negative value is supplied, a NaN should be returned instad */
     /* if(mpfr_cmp_ui(*p, 0) < 0) croak("Negative value supplied as argument to overload_sqrt"); */

     mpfr_sqrt(*mpfr_t_obj, *p, __gmpfr_default_rounding_mode);
     sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
     SvREADONLY_on(obj);
     return obj_ref;
}

SV * overload_pow(pTHX_ SV * p, SV * second, SV * third) {
     mpfr_t * mpfr_t_obj, t;
     SV * obj_ref, * obj;
     int ret;

     Newx(mpfr_t_obj, 1, mpfr_t);
     if(mpfr_t_obj == NULL) croak("Failed to allocate memory in overload_pow function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::MPFR");
     mpfr_init(*mpfr_t_obj);
     sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
     SvREADONLY_on(obj);

#ifdef MATH_MPFR_NEED_LONG_LONG_INT
#ifndef _MSC_VER
     if(SvUOK(second)) {
       mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
       mpfr_set_uj(t, SvUV(second), __gmpfr_default_rounding_mode);
       if(third == &PL_sv_yes) mpfr_pow(*mpfr_t_obj, t, *(INT2PTR(mpfr_t *, SvIV(SvRV(p)))), __gmpfr_default_rounding_mode);
       else mpfr_pow(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIV(SvRV(p)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return obj_ref;
     }

     if(SvIOK(second)) {
       mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
       mpfr_set_sj(t, SvIV(second), __gmpfr_default_rounding_mode);
       if(third == &PL_sv_yes) mpfr_pow(*mpfr_t_obj, t, *(INT2PTR(mpfr_t *, SvIV(SvRV(p)))), __gmpfr_default_rounding_mode);
       else mpfr_pow(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIV(SvRV(p)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return obj_ref;
     }
#else
     if(SvIOK(second)) {
       ret = mpfr_set_str(*mpfr_t_obj, SvPV_nolen(second), 10, __gmpfr_default_rounding_mode);
       if(ret) {
         nnum++;
         if(SvIV(get_sv("Math::MPFR::NNW", 0)))
           warn("string used in overloaded exponentiation (**) contains non-numeric characters");
       }
       if(third == &PL_sv_yes) mpfr_pow(*mpfr_t_obj, *mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIV(SvRV(p)))), __gmpfr_default_rounding_mode);
       else mpfr_pow(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIV(SvRV(p)))), *mpfr_t_obj, __gmpfr_default_rounding_mode);
       return obj_ref;
     }
#endif
#else
     if(SvUOK(second)) {
       if(third == &PL_sv_yes) mpfr_ui_pow(*mpfr_t_obj, SvUV(second), *(INT2PTR(mpfr_t *, SvIV(SvRV(p)))), __gmpfr_default_rounding_mode);
       else mpfr_pow_ui(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIV(SvRV(p)))), SvUV(second), __gmpfr_default_rounding_mode);
       return obj_ref;
     }

     if(SvIOK(second)) {
       /* Need to do it this way as there's no mpfr_si_pow function */
       if(SvIV(second) >= 0) {
         if(third == &PL_sv_yes) mpfr_ui_pow(*mpfr_t_obj, SvUV(second), *(INT2PTR(mpfr_t *, SvIV(SvRV(p)))), __gmpfr_default_rounding_mode);
         else mpfr_pow_ui(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIV(SvRV(p)))), SvUV(second), __gmpfr_default_rounding_mode);
         return obj_ref;
       }
       if(third != &PL_sv_yes) {
         mpfr_pow_si(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIV(SvRV(p)))), SvIV(second), __gmpfr_default_rounding_mode);
         return obj_ref;
       }
     }
#endif

     if(SvNOK(second)) {

#if defined(CAN_PASS_FLOAT128)

       mpfr_init2(t, FLT128_MANT_DIG);
       mpfr_set_float128(t, (float128)SvNV(second), __gmpfr_default_rounding_mode);

#elif defined(USE_LONG_DOUBLE)

       mpfr_init2(t, REQUIRED_LDBL_MANT_DIG);
       mpfr_set_ld(t, (long double)SvNV(second), __gmpfr_default_rounding_mode);

#else

       mpfr_init2(t, DBL_MANT_DIG);
       mpfr_set_d(t, (double)SvNV(second), __gmpfr_default_rounding_mode);

#endif

       if(third == &PL_sv_yes) mpfr_pow(*mpfr_t_obj, t, *(INT2PTR(mpfr_t *, SvIV(SvRV(p)))), __gmpfr_default_rounding_mode);
       else mpfr_pow(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIV(SvRV(p)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return obj_ref;
     }

     if(SvPOK(second)) {
       ret = mpfr_set_str(*mpfr_t_obj, SvPV_nolen(second), 0, __gmpfr_default_rounding_mode);
       if(ret) {
         nnum++;
         if(SvIV(get_sv("Math::MPFR::NNW", 0)))
           warn("string used in overloaded exponentaition (**) contains non-numeric characters");
       }
       if(third == &PL_sv_yes) mpfr_pow(*mpfr_t_obj, *mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIV(SvRV(p)))), __gmpfr_default_rounding_mode);
       else mpfr_pow(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIV(SvRV(p)))), *mpfr_t_obj, __gmpfr_default_rounding_mode);
       return obj_ref;
     }

     if(sv_isobject(second)) {
       const char* h = HvNAME(SvSTASH(SvRV(second)));

       if(strEQ(h, "Math::MPFR")) {
         mpfr_pow(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIV(SvRV(p)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(second)))), __gmpfr_default_rounding_mode);
         return obj_ref;
       }
       if(strEQ(h, "Math::GMPz")) {
         if(third == &PL_sv_yes) {
           mpfr_init2(t, (mpfr_prec_t)mpz_sizeinbase(*(INT2PTR(mpz_t *, SvIV(SvRV(second)))), 2));
           mpfr_set_z(t, *(INT2PTR(mpz_t *, SvIV(SvRV(second)))), __gmpfr_default_rounding_mode);
           mpfr_pow(*mpfr_t_obj, t, *(INT2PTR(mpfr_t *, SvIV(SvRV(p)))), __gmpfr_default_rounding_mode);
           mpfr_clear(t);
         }
         else mpfr_pow_z(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIV(SvRV(p     )))),
                                      *(INT2PTR(mpz_t * , SvIV(SvRV(second)))),
                                      __gmpfr_default_rounding_mode);
         return obj_ref;
       }
       if(strEQ(h, "Math::GMPq")) {
         mpfr_set_q(*mpfr_t_obj, *(INT2PTR(mpq_t *, SvIV(SvRV(second)))), __gmpfr_default_rounding_mode);
         if(third == &PL_sv_yes) mpfr_pow(*mpfr_t_obj, *mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIV(SvRV(p)))), __gmpfr_default_rounding_mode);
         else mpfr_pow(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIV(SvRV(p)))), *mpfr_t_obj, __gmpfr_default_rounding_mode);
         return obj_ref;
       }
       if(strEQ(h, "Math::GMPf")) {
         mpfr_init2(t, (mpfr_prec_t)mpf_get_prec(*(INT2PTR(mpf_t *, SvIV(SvRV(second))))));
         mpfr_set_f(t, *(INT2PTR(mpf_t *, SvIV(SvRV(second)))), __gmpfr_default_rounding_mode);
         if(third == &PL_sv_yes) mpfr_pow(*mpfr_t_obj, t, *(INT2PTR(mpfr_t *, SvIV(SvRV(p)))), __gmpfr_default_rounding_mode);
         else mpfr_pow(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIV(SvRV(p)))), t, __gmpfr_default_rounding_mode);
         mpfr_clear(t);
         return obj_ref;
       }
     }

     croak("Invalid argument supplied to Math::MPFR::overload_pow.");
}

SV * overload_log(pTHX_ mpfr_t * p, SV * second, SV * third) {
     mpfr_t * mpfr_t_obj;
     SV * obj_ref, * obj;

     Newx(mpfr_t_obj, 1, mpfr_t);
     if(mpfr_t_obj == NULL) croak("Failed to allocate memory in overload_log function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::MPFR");
     mpfr_init(*mpfr_t_obj);

     mpfr_log(*mpfr_t_obj, *p, __gmpfr_default_rounding_mode);
     sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
     SvREADONLY_on(obj);
     return obj_ref;
}

SV * overload_exp(pTHX_ mpfr_t * p, SV * second, SV * third) {
     mpfr_t * mpfr_t_obj;
     SV * obj_ref, * obj;

     Newx(mpfr_t_obj, 1, mpfr_t);
     if(mpfr_t_obj == NULL) croak("Failed to allocate memory in overload_exp function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::MPFR");
     mpfr_init(*mpfr_t_obj);

     mpfr_exp(*mpfr_t_obj, *p, __gmpfr_default_rounding_mode);
     sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
     SvREADONLY_on(obj);
     return obj_ref;
}

SV * overload_sin(pTHX_ mpfr_t * p, SV * second, SV * third) {
     mpfr_t * mpfr_t_obj;
     SV * obj_ref, * obj;

     Newx(mpfr_t_obj, 1, mpfr_t);
     if(mpfr_t_obj == NULL) croak("Failed to allocate memory in overload_sin function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::MPFR");
     mpfr_init(*mpfr_t_obj);

     mpfr_sin(*mpfr_t_obj, *p, __gmpfr_default_rounding_mode);
     sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
     SvREADONLY_on(obj);
     return obj_ref;
}

SV * overload_cos(pTHX_ mpfr_t * p, SV * second, SV * third) {
     mpfr_t * mpfr_t_obj;
     SV * obj_ref, * obj;

     Newx(mpfr_t_obj, 1, mpfr_t);
     if(mpfr_t_obj == NULL) croak("Failed to allocate memory in overload_cos function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::MPFR");
     mpfr_init(*mpfr_t_obj);

     mpfr_cos(*mpfr_t_obj, *p, __gmpfr_default_rounding_mode);
     sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
     SvREADONLY_on(obj);
     return obj_ref;
}

SV * overload_int(pTHX_ mpfr_t * p, SV * second, SV * third) {
     mpfr_t * mpfr_t_obj;
     SV * obj_ref, * obj;

     Newx(mpfr_t_obj, 1, mpfr_t);
     if(mpfr_t_obj == NULL) croak("Failed to allocate memory in overload_int function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::MPFR");
     mpfr_init(*mpfr_t_obj);

     mpfr_trunc(*mpfr_t_obj, *p);
     sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
     SvREADONLY_on(obj);
     return obj_ref;
}

SV * overload_atan2(pTHX_ mpfr_t * a, SV * b, SV * third) {
     mpfr_t * mpfr_t_obj, t;
     SV * obj_ref, * obj;
     int ret;

     Newx(mpfr_t_obj, 1, mpfr_t);
     if(mpfr_t_obj == NULL) croak("Failed to allocate memory in overload_atan2 function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::MPFR");
     mpfr_init(*mpfr_t_obj);

#ifdef MATH_MPFR_NEED_LONG_LONG_INT
#ifndef _MSC_VER
     if(SvUOK(b)) {
       mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
       mpfr_set_uj(t, SvUV(b), __gmpfr_default_rounding_mode);
       if(third == &PL_sv_yes){
         mpfr_atan2(*mpfr_t_obj, t, *a, __gmpfr_default_rounding_mode);
       }
       else {
         mpfr_atan2(*mpfr_t_obj, *a, t, __gmpfr_default_rounding_mode);
       }
       sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
       mpfr_clear(t);
       SvREADONLY_on(obj);
       return obj_ref;
     }

     if(SvIOK(b)) {
       mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
       mpfr_set_sj(t, SvIV(b), __gmpfr_default_rounding_mode);
       if(third == &PL_sv_yes){
         mpfr_atan2(*mpfr_t_obj, t, *a, __gmpfr_default_rounding_mode);
       }
       else {
         mpfr_atan2(*mpfr_t_obj, *a, t, __gmpfr_default_rounding_mode);
       }
       mpfr_clear(t);
       sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
       SvREADONLY_on(obj);
       return obj_ref;
     }
#else
     if(SvIOK(b)) {
       ret = mpfr_set_str(*mpfr_t_obj, SvPV_nolen(b), 10, __gmpfr_default_rounding_mode);
       if(ret) {
         nnum++;
         if(SvIV(get_sv("Math::MPFR::NNW", 0)))
           warn("string used in overloaded atan2 contains non-numeric characters");
       }
       if(third == &PL_sv_yes){
         mpfr_atan2(*mpfr_t_obj, *mpfr_t_obj, *a, __gmpfr_default_rounding_mode);
       }
       else {
         mpfr_atan2(*mpfr_t_obj, *a, *mpfr_t_obj, __gmpfr_default_rounding_mode);
       }
       sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
       SvREADONLY_on(obj);
       return obj_ref;
     }
#endif
#else
     if(SvUOK(b)) {
       mpfr_init2(t, 8 * sizeof(long));
       mpfr_set_ui(t, SvUV(b), __gmpfr_default_rounding_mode);
       if(third == &PL_sv_yes){
         mpfr_atan2(*mpfr_t_obj, t, *a, __gmpfr_default_rounding_mode);
       }
       else {
         mpfr_atan2(*mpfr_t_obj, *a, t, __gmpfr_default_rounding_mode);
       }
       mpfr_clear(t);
       sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
       SvREADONLY_on(obj);
       return obj_ref;
     }

     if(SvIOK(b)) {
       mpfr_init2(t, 8 * sizeof(long));
       mpfr_set_si(t, SvIV(b), __gmpfr_default_rounding_mode);
       if(third == &PL_sv_yes){
         mpfr_atan2(*mpfr_t_obj, t, *a, __gmpfr_default_rounding_mode);
       }
       else {
         mpfr_atan2(*mpfr_t_obj, *a, t, __gmpfr_default_rounding_mode);
       }
       mpfr_clear(t);
       sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
       SvREADONLY_on(obj);
       return obj_ref;
     }
#endif

     if(SvNOK(b)) {

#if defined(CAN_PASS_FLOAT128)
       mpfr_init2(t, FLT128_MANT_DIG);
       mpfr_set_float128(t, (float128)SvNV(b), __gmpfr_default_rounding_mode);
#elif defined(USE_LONG_DOUBLE)
       mpfr_init2(t, REQUIRED_LDBL_MANT_DIG);
       mpfr_set_ld(t, (long double)SvNV(b), __gmpfr_default_rounding_mode);
#else
       mpfr_init2(t, DBL_MANT_DIG);
       mpfr_set_d(t, (double)SvNV(b), __gmpfr_default_rounding_mode);
#endif

       if(third == &PL_sv_yes){
         mpfr_atan2(*mpfr_t_obj, t, *a, __gmpfr_default_rounding_mode);
       }
       else {
         mpfr_atan2(*mpfr_t_obj, *a, t, __gmpfr_default_rounding_mode);
       }
       mpfr_clear(t);
       sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
       SvREADONLY_on(obj);
       return obj_ref;
     }

     if(SvPOK(b)) {
       ret = mpfr_set_str(*mpfr_t_obj, SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);
       if(ret) {
         nnum++;
         if(SvIV(get_sv("Math::MPFR::NNW", 0)))
           warn("string used in overloaded atan2 contains non-numeric characters");
       }
       if(third == &PL_sv_yes){
         mpfr_atan2(*mpfr_t_obj, *mpfr_t_obj, *a, __gmpfr_default_rounding_mode);
         }
       else {
         mpfr_atan2(*mpfr_t_obj, *a, *mpfr_t_obj, __gmpfr_default_rounding_mode);
         }
       sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
       SvREADONLY_on(obj);
       return obj_ref;
     }

     if(sv_isobject(b)) {
       const char* h = HvNAME(SvSTASH(SvRV(b)));

       if(strEQ(h, "Math::MPFR")) {
         mpfr_atan2(*mpfr_t_obj, *a, *(INT2PTR(mpfr_t *, SvIV(SvRV(b)))), __gmpfr_default_rounding_mode);
         sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
         SvREADONLY_on(obj);
         return obj_ref;
       }
     }

     croak("Invalid argument supplied to Math::MPFR::overload_atan2 function");
}

/* Finish typemapping */

SV * Rmpfr_randinit_default_nobless(pTHX) {
     gmp_randstate_t * state;
     SV * obj_ref, * obj;

     Newx(state, 1, gmp_randstate_t);
     if(state == NULL) croak("Failed to allocate memory in Rmpfr_randinit_default function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, NULL);
     gmp_randinit_default(*state);

     sv_setiv(obj, INT2PTR(IV,state));
     SvREADONLY_on(obj);
     return obj_ref;
}

SV * Rmpfr_randinit_mt_nobless(pTHX) {
     gmp_randstate_t * rand_obj;
     SV * obj_ref, * obj;

     Newx(rand_obj, 1, gmp_randstate_t);
     if(rand_obj == NULL) croak("Failed to allocate memory in Math::GMPz::Random::Rmpfr_randinit_mt function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, NULL);
     gmp_randinit_mt(*rand_obj);

     sv_setiv(obj, INT2PTR(IV, rand_obj));
     SvREADONLY_on(obj);
     return obj_ref;
}

SV * Rmpfr_randinit_lc_2exp_nobless(pTHX_ SV * a, SV * c, SV * m2exp ) {
     gmp_randstate_t * state;
     mpz_t aa;
     SV * obj_ref, * obj;

     Newx(state, 1, gmp_randstate_t);
     if(state == NULL) croak("Failed to allocate memory in Rmpfr_randinit_lc_2exp function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, NULL);
     if(sv_isobject(a)) {
       const char* h = HvNAME(SvSTASH(SvRV(a)));

       if(strEQ(h, "Math::GMP") ||
          strEQ(h, "GMP::Mpz")  ||
          strEQ(h, "Math::GMPz"))
            gmp_randinit_lc_2exp(*state, *(INT2PTR(mpz_t *, SvIV(SvRV(a)))), (unsigned long)SvUV(c), (unsigned long)SvUV(m2exp));
       else croak("First arg to Rmpfr_randinit_lc_2exp is of invalid type");
     }

     else {
       if(!mpz_init_set_str(aa, SvPV_nolen(a), 0)) {
         gmp_randinit_lc_2exp(*state, aa, (unsigned long)SvUV(c), (unsigned long)SvUV(m2exp));
         mpz_clear(aa);
       }
       else croak("Seedstring supplied to Rmpfr_randinit_lc_2exp is not a valid number");
     }

     sv_setiv(obj, INT2PTR(IV,state));
     SvREADONLY_on(obj);
     return obj_ref;
}

SV * Rmpfr_randinit_lc_2exp_size_nobless(pTHX_ SV * size) {
     gmp_randstate_t * state;
     SV * obj_ref, * obj;

     if(SvUV(size) > 128) croak("The argument supplied to Rmpfr_randinit_lc_2exp_size function (%u) needs to be in the range [1..128]", SvUV(size));

     Newx(state, 1, gmp_randstate_t);
     if(state == NULL) croak("Failed to allocate memory in Rmpfr_randinit_lc_2exp_size function");
     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, NULL);

     if(gmp_randinit_lc_2exp_size(*state, (unsigned long)SvUV(size))) {
       sv_setiv(obj, INT2PTR(IV,state));
       SvREADONLY_on(obj);
       return obj_ref;
       }

     croak("Rmpfr_randinit_lc_2exp_size function failed");
}

void Rmpfr_randclear(pTHX_ SV * p) {
     gmp_randclear(*(INT2PTR(gmp_randstate_t *, SvIV(SvRV(p)))));
     Safefree(INT2PTR(gmp_randstate_t *, SvIV(SvRV(p))));
}

void Rmpfr_randseed(pTHX_ SV * state, SV * seed) {
     mpz_t s;

     if(sv_isobject(seed)) {
       const char* h = HvNAME(SvSTASH(SvRV(seed)));

       if(strEQ(h, "Math::GMP") ||
          strEQ(h, "GMP::Mpz") ||
          strEQ(h, "Math::GMPz"))
            gmp_randseed(*(INT2PTR(gmp_randstate_t *, SvIV(SvRV(state)))), *(INT2PTR(mpz_t *, SvIV(SvRV(seed)))));
       else croak("2nd arg to Rmpfr_randseed is of invalid type");
     }

     else {
       if(!mpz_init_set_str(s, SvPV_nolen(seed), 0)) {
         gmp_randseed(*(INT2PTR(gmp_randstate_t *, SvIV(SvRV(state)))), s);
         mpz_clear(s);
       }
       else croak("Seedstring supplied to Rmpfr_randseed is not a valid number");
     }
}

void Rmpfr_randseed_ui(pTHX_ SV * state, SV * seed) {
     gmp_randseed_ui(*(INT2PTR(gmp_randstate_t *, SvIV(SvRV(state)))), (unsigned long)SvUV(seed));
}

SV * overload_pow_eq(pTHX_ SV * p, SV * second, SV * third) {
     mpfr_t t;
     int ret;

     SvREFCNT_inc(p);

#ifdef MATH_MPFR_NEED_LONG_LONG_INT
#ifndef _MSC_VER
     if(SvUOK(second)) {
       mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
       mpfr_set_uj(t, SvUV(second), __gmpfr_default_rounding_mode);
       mpfr_pow(*(INT2PTR(mpfr_t *, SvIV(SvRV(p)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(p)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return p;
     }

     if(SvIOK(second)) {
       mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
       mpfr_set_sj(t, SvIV(second), __gmpfr_default_rounding_mode);
       mpfr_pow(*(INT2PTR(mpfr_t *, SvIV(SvRV(p)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(p)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return p;
     }
#else
     if(SvIOK(second)) {
       ret = mpfr_init_set_str(t, SvPV_nolen(second), 10, __gmpfr_default_rounding_mode);
       if(ret) {
         nnum++;
         if(SvIV(get_sv("Math::MPFR::NNW", 0)))
           warn("string used in overloaded exponentiation (**=) contains non-numeric characters");
       }
       mpfr_pow(*(INT2PTR(mpfr_t *, SvIV(SvRV(p)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(p)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return p;
     }
#endif
#else
     if(SvUOK(second)) {
       mpfr_pow_ui(*(INT2PTR(mpfr_t *, SvIV(SvRV(p)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(p)))), SvUV(second), __gmpfr_default_rounding_mode);
       return p;
     }

     if(SvIOK(second)) {
       /*
       if(SvIV(second) >= 0) {
         mpfr_pow_ui(*(INT2PTR(mpfr_t *, SvIV(SvRV(p)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(p)))), SvUV(second), __gmpfr_default_rounding_mode);
         return p;
       }
       */
       mpfr_pow_si(*(INT2PTR(mpfr_t *, SvIV(SvRV(p)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(p)))), SvIV(second), __gmpfr_default_rounding_mode);
       return p;
     }
#endif

     if(SvNOK(second)) {

#if defined(CAN_PASS_FLOAT128)
       mpfr_init2(t, FLT128_MANT_DIG);
       mpfr_set_float128(t, (float128)SvNV(second), __gmpfr_default_rounding_mode);
#elif defined(USE_LONG_DOUBLE)
       mpfr_init2(t, REQUIRED_LDBL_MANT_DIG);
       mpfr_set_ld(t, (long double)SvNV(second), __gmpfr_default_rounding_mode);
#else
       mpfr_init2(t, DBL_MANT_DIG);
       mpfr_set_d(t, (double)SvNV(second), __gmpfr_default_rounding_mode);
#endif

       mpfr_pow(*(INT2PTR(mpfr_t *, SvIV(SvRV(p)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(p)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return p;
     }

     if(SvPOK(second)) {
       ret = mpfr_init_set_str(t, SvPV_nolen(second), 0, __gmpfr_default_rounding_mode);
       if(ret) {
         nnum++;
         if(SvIV(get_sv("Math::MPFR::NNW", 0)))
           warn("string used in overloaded exponentiation (**=) contains non-numeric characters");
       }
       mpfr_pow(*(INT2PTR(mpfr_t *, SvIV(SvRV(p)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(p)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return p;
     }

     if(sv_isobject(second)) {
       const char* h = HvNAME(SvSTASH(SvRV(second)));

       if(strEQ(h, "Math::MPFR")) {
         mpfr_pow(*(INT2PTR(mpfr_t *, SvIV(SvRV(p)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(p)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(second)))), __gmpfr_default_rounding_mode);
         return p;
       }
       if(strEQ(h, "Math::GMPz")) {
         mpfr_pow_z(*(INT2PTR(mpfr_t *, SvIV(SvRV(p)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(p)))), *(INT2PTR(mpz_t *, SvIV(SvRV(second)))), __gmpfr_default_rounding_mode);
         return p;
       }
       if(strEQ(h, "Math::GMPf")) {
         mpfr_init2(t, (mpfr_prec_t)mpf_get_prec(*(INT2PTR(mpf_t *, SvIV(SvRV(second))))));
         mpfr_set_f(t, *(INT2PTR(mpf_t *, SvIV(SvRV(second)))), __gmpfr_default_rounding_mode);
         mpfr_pow(*(INT2PTR(mpfr_t *, SvIV(SvRV(p)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(p)))), t, __gmpfr_default_rounding_mode);
         mpfr_clear(t);
         return p;
       }
       if(strEQ(h, "Math::GMPq")) {
         mpfr_init(t);
         mpfr_set_q(t, *(INT2PTR(mpq_t *, SvIV(SvRV(second)))), __gmpfr_default_rounding_mode);
         mpfr_pow(*(INT2PTR(mpfr_t *, SvIV(SvRV(p)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(p)))), t, __gmpfr_default_rounding_mode);
         mpfr_clear(t);
         return p;
       }
     }

     SvREFCNT_dec(p);
     croak("Invalid argument supplied to Math::MPFR::overload_pow_eq.");
}

SV * overload_div_eq(pTHX_ SV * a, SV * b, SV * third) {
     mpfr_t t;
     int ret;

     SvREFCNT_inc(a);

#ifdef MATH_MPFR_NEED_LONG_LONG_INT
#ifndef _MSC_VER
     if(SvUOK(b)) {
       mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
       mpfr_set_uj(t, SvUV(b), __gmpfr_default_rounding_mode);
       mpfr_div(*(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return a;
     }

     if(SvIOK(b)) {
       mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
       mpfr_set_sj(t, SvIV(b), __gmpfr_default_rounding_mode);
       mpfr_div(*(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return a;
     }
#else
     if(SvIOK(b)) {
       ret = mpfr_init_set_str(t, SvPV_nolen(b), 10, __gmpfr_default_rounding_mode);
       if(ret) {
         nnum++;
         if(SvIV(get_sv("Math::MPFR::NNW", 0)))
           warn("string used in overloaded division (/=) contains non-numeric characters");
       }
       mpfr_div(*(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return a;
     }
#endif
#else
     if(SvUOK(b)) {
       mpfr_div_ui(*(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), SvUV(b), __gmpfr_default_rounding_mode);
       return a;
     }

     if(SvIOK(b)) {
       mpfr_div_si(*(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), SvIV(b), __gmpfr_default_rounding_mode);
       return a;
       /*
       if(SvIV(b) >= 0) {
         mpfr_div_ui(*(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), SvUV(b), __gmpfr_default_rounding_mode);
         return a;
       }
       mpfr_div_ui(*(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), SvIV(b) * -1, __gmpfr_default_rounding_mode);
       mpfr_neg(*(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), __gmpfr_default_rounding_mode);
       return a;
       */
     }
#endif

     if(SvNOK(b)) {

#if defined(CAN_PASS_FLOAT128)

       mpfr_init2(t, FLT128_MANT_DIG);
       mpfr_set_float128(t, (float128)SvNV(b), __gmpfr_default_rounding_mode);

#elif defined(USE_LONG_DOUBLE)

       mpfr_init2(t, REQUIRED_LDBL_MANT_DIG);
       mpfr_set_ld(t, (long double)SvNV(b), __gmpfr_default_rounding_mode);

#else

       mpfr_init2(t, DBL_MANT_DIG);
       mpfr_set_d(t, (double)SvNV(b), __gmpfr_default_rounding_mode);
#endif

       mpfr_div(*(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return a;
     }

     if(SvPOK(b)) {
       ret = mpfr_init_set_str(t, SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);
       if(ret) {
         nnum++;
         if(SvIV(get_sv("Math::MPFR::NNW", 0)))
           warn("string used in overloaded division (/=) contains non-numeric characters");
       }
       mpfr_div(*(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return a;
     }

     if(sv_isobject(b)) {
       const char* h = HvNAME(SvSTASH(SvRV(b)));

       if(strEQ(h, "Math::MPFR")) {
         mpfr_div(*(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(b)))), __gmpfr_default_rounding_mode);
         return a;
       }
       if(strEQ(h, "Math::GMPz")) {
         mpfr_div_z(*(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), *(INT2PTR(mpz_t *, SvIV(SvRV(b)))), __gmpfr_default_rounding_mode);
         return a;
       }
       if(strEQ(h, "Math::GMPf")) {
         mpfr_init2(t, (mpfr_prec_t)mpf_get_prec(*(INT2PTR(mpf_t *, SvIV(SvRV(b))))));
         mpfr_set_f(t, *(INT2PTR(mpf_t *, SvIV(SvRV(b)))), __gmpfr_default_rounding_mode);
         mpfr_div(*(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), t, __gmpfr_default_rounding_mode);
         mpfr_clear(t);
         return a;
       }
       if(strEQ(h, "Math::GMPq")) {
         mpfr_div_q(*(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), *(INT2PTR(mpq_t *, SvIV(SvRV(b)))), __gmpfr_default_rounding_mode);
         return a;
       }
     }

     SvREFCNT_dec(a);
     croak("Invalid argument supplied to Math::MPFR::overload_div_eq function");
}

SV * overload_sub_eq(pTHX_ SV * a, SV * b, SV * third) {
     mpfr_t t;
     int ret;

     SvREFCNT_inc(a);

#ifdef MATH_MPFR_NEED_LONG_LONG_INT
#ifndef _MSC_VER
     if(SvUOK(b)) {
       mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
       mpfr_set_uj(t, SvUV(b), __gmpfr_default_rounding_mode);
       mpfr_sub(*(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return a;
     }

     if(SvIOK(b)) {
       mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
       mpfr_set_sj(t, SvIV(b), __gmpfr_default_rounding_mode);
       mpfr_sub(*(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return a;
     }
#else
     if(SvIOK(b)) {
       ret = mpfr_init_set_str(t, SvPV_nolen(b), 10, __gmpfr_default_rounding_mode);
       if(ret) {
         nnum++;
         if(SvIV(get_sv("Math::MPFR::NNW", 0)))
           warn("string used in overloaded subtraction (-=) contains non-numeric characters");
       }
       mpfr_sub(*(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return a;
     }
#endif
#else
     if(SvUOK(b)) {
       mpfr_sub_ui(*(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), SvUV(b), __gmpfr_default_rounding_mode);
       return a;
     }

     if(SvIOK(b)) {
       mpfr_sub_si(*(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), SvIV(b), __gmpfr_default_rounding_mode);
       return a;
       /*
       if(SvIV(b) >= 0) {
         mpfr_sub_ui(*(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), SvUV(b), __gmpfr_default_rounding_mode);
         return a;
       }
       mpfr_add_ui(*(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), SvIV(b) * -1, __gmpfr_default_rounding_mode);
       return a;
       */
     }
#endif

     if(SvNOK(b)) {

#if defined(CAN_PASS_FLOAT128)

       mpfr_init2(t, FLT128_MANT_DIG);
       mpfr_set_float128(t, (float128)SvNV(b), __gmpfr_default_rounding_mode);

#elif defined(USE_LONG_DOUBLE)

       mpfr_init2(t, REQUIRED_LDBL_MANT_DIG);
       mpfr_set_ld(t, (long double)SvNV(b), __gmpfr_default_rounding_mode);

#else

       mpfr_init2(t, DBL_MANT_DIG);
       mpfr_init_set_d(t, (double)SvNV(b), __gmpfr_default_rounding_mode);

#endif

       mpfr_sub(*(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return a;
     }

     if(SvPOK(b)) {
       ret = mpfr_init_set_str(t, SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);
       if(ret) {
         nnum++;
         if(SvIV(get_sv("Math::MPFR::NNW", 0)))
           warn("string used in overloaded subtraction (-=) contains non-numeric characters");
       }
       mpfr_sub(*(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return a;
     }

     if(sv_isobject(b)) {
       const char* h = HvNAME(SvSTASH(SvRV(b)));

       if(strEQ(h, "Math::MPFR")) {
         mpfr_sub(*(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(b)))), __gmpfr_default_rounding_mode);
         return a;
       }
       if(strEQ(h, "Math::GMPz")) {
         mpfr_sub_z(*(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), *(INT2PTR(mpz_t *, SvIV(SvRV(b)))), __gmpfr_default_rounding_mode);
         return a;
       }
       if(strEQ(h, "Math::GMPf")) {
         mpfr_init2(t, (mpfr_prec_t)mpf_get_prec(*(INT2PTR(mpf_t *, SvIV(SvRV(b))))));
         mpfr_set_f(t, *(INT2PTR(mpf_t *, SvIV(SvRV(b)))), __gmpfr_default_rounding_mode);
         mpfr_sub(*(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), t, __gmpfr_default_rounding_mode);
         mpfr_clear(t);
         return a;
       }
       if(strEQ(h, "Math::GMPq")) {
         mpfr_sub_q(*(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), *(INT2PTR(mpq_t *, SvIV(SvRV(b)))), __gmpfr_default_rounding_mode);
         return a;
       }
     }

     SvREFCNT_dec(a);
     croak("Invalid argument supplied to Math::MPFR::overload_sub_eq function");
}

SV * overload_add_eq(pTHX_ SV * a, SV * b, SV * third) {
     mpfr_t t;
     int ret;

     SvREFCNT_inc(a);

#ifdef MATH_MPFR_NEED_LONG_LONG_INT
#ifndef _MSC_VER
     if(SvUOK(b)) {
       mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
       mpfr_set_uj(t, SvUV(b), __gmpfr_default_rounding_mode);
       mpfr_add(*(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return a;
     }

     if(SvIOK(b)) {
       mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
       mpfr_set_sj(t, SvIV(b), __gmpfr_default_rounding_mode);
       mpfr_add(*(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return a;
     }
#else
     if(SvIOK(b)) {
       ret = mpfr_init_set_str(t, SvPV_nolen(b), 10, __gmpfr_default_rounding_mode);
       if(ret) {
         nnum++;
         if(SvIV(get_sv("Math::MPFR::NNW", 0)))
           warn("string used in overloaded addition (+=) contains non-numeric characters");
       }
       mpfr_add(*(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return a;
     }
#endif
#else
     if(SvUOK(b)) {
       mpfr_add_ui(*(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), SvUV(b), __gmpfr_default_rounding_mode);
       return a;
     }

     if(SvIOK(b)) {
       mpfr_add_si(*(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), SvIV(b), __gmpfr_default_rounding_mode);
       return a;
       /*
       if(SvIV(b) >= 0) {
         mpfr_add_ui(*(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), SvUV(b), __gmpfr_default_rounding_mode);
         return a;
       }
       mpfr_sub_ui(*(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), SvIV(b) * -1, __gmpfr_default_rounding_mode);
       return a;
       */
     }
#endif

     if(SvNOK(b)) {

#if defined(CAN_PASS_FLOAT128)

       mpfr_init2(t, FLT128_MANT_DIG);
       mpfr_set_float128(t, (float128)SvNV(b), __gmpfr_default_rounding_mode);

#elif defined(USE_LONG_DOUBLE)

       mpfr_init2(t, REQUIRED_LDBL_MANT_DIG);
       mpfr_set_ld(t, (long double)SvNV(b), __gmpfr_default_rounding_mode);

#else

       mpfr_init2(t, DBL_MANT_DIG);
       mpfr_set_d(t, (double)SvNV(b), __gmpfr_default_rounding_mode);

#endif

       mpfr_add(*(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return a;
     }

     if(SvPOK(b)) {
       ret = mpfr_init_set_str(t, SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);
       if(ret) {
         nnum++;
         if(SvIV(get_sv("Math::MPFR::NNW", 0)))
           warn("string used in overloaded addition (+=) contains non-numeric characters");
       }
       mpfr_add(*(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return a;
     }

     if(sv_isobject(b)) {
       const char* h = HvNAME(SvSTASH(SvRV(b)));

       if(strEQ(h, "Math::MPFR")) {
         mpfr_add(*(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(b)))), __gmpfr_default_rounding_mode);
         return a;
       }
       if(strEQ(h, "Math::GMPz")) {
         mpfr_add_z(*(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), *(INT2PTR(mpz_t *, SvIV(SvRV(b)))), __gmpfr_default_rounding_mode);
         return a;
       }
       if(strEQ(h, "Math::GMPf")) {
         mpfr_init2(t, (mpfr_prec_t)mpf_get_prec(*(INT2PTR(mpf_t *, SvIV(SvRV(b))))));
         mpfr_set_f(t, *(INT2PTR(mpf_t *, SvIV(SvRV(b)))), __gmpfr_default_rounding_mode);
         mpfr_add(*(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), t, __gmpfr_default_rounding_mode);
         mpfr_clear(t);
         return a;
       }
       if(strEQ(h, "Math::GMPq")) {
         mpfr_add_q(*(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), *(INT2PTR(mpq_t *, SvIV(SvRV(b)))), __gmpfr_default_rounding_mode);
         return a;
       }
     }

     SvREFCNT_dec(a);
     croak("Invalid argument supplied to Math::MPFR::overload_add_eq");
}

SV * overload_mul_eq(pTHX_ SV * a, SV * b, SV * third) {
     mpfr_t t;
     int ret;

     SvREFCNT_inc(a);

#ifdef MATH_MPFR_NEED_LONG_LONG_INT
#ifndef _MSC_VER
     if(SvUOK(b)) {
       mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
       mpfr_set_uj(t, SvUV(b), __gmpfr_default_rounding_mode);
       mpfr_mul(*(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return a;
     }

     if(SvIOK(b)) {
       mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
       mpfr_set_sj(t, SvIV(b), __gmpfr_default_rounding_mode);
       mpfr_mul(*(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return a;
     }
#else
     if(SvIOK(b)) {
       ret = mpfr_init_set_str(t, SvPV_nolen(b), 10, __gmpfr_default_rounding_mode);
       if(ret) {
         nnum++;
         if(SvIV(get_sv("Math::MPFR::NNW", 0)))
           warn("string used in overloaded multiplication (*=) contains non-numeric characters");
       }
       mpfr_mul(*(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return a;
     }
#endif
#else
     if(SvUOK(b)) {
       mpfr_mul_ui(*(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), SvUV(b), __gmpfr_default_rounding_mode);
       return a;
     }

     if(SvIOK(b)) {
       mpfr_mul_si(*(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), SvIV(b), __gmpfr_default_rounding_mode);
       return a;
       /*
       if(SvIV(b) >= 0) {
         mpfr_mul_ui(*(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), SvUV(b), __gmpfr_default_rounding_mode);
         return a;
       }
       mpfr_mul_ui(*(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), SvIV(b) * -1, __gmpfr_default_rounding_mode);
       mpfr_neg(*(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), __gmpfr_default_rounding_mode);
       return a;
       */
     }
#endif

     if(SvNOK(b)) {

#if defined(CAN_PASS_FLOAT128)

       mpfr_init2(t, FLT128_MANT_DIG);
       mpfr_set_float128(t, (float128)SvNV(b), __gmpfr_default_rounding_mode);

#elif defined(USE_LONG_DOUBLE)

       mpfr_init2(t, REQUIRED_LDBL_MANT_DIG);
       mpfr_set_ld(t, (long double)SvNV(b), __gmpfr_default_rounding_mode);

#else

       mpfr_init2(t, DBL_MANT_DIG);
       mpfr_init_set_d(t, (double)SvNV(b), __gmpfr_default_rounding_mode);

#endif

       mpfr_mul(*(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return a;
     }

     if(SvPOK(b)) {
       ret = mpfr_init_set_str(t, SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);
       if(ret) {
         nnum++;
         if(SvIV(get_sv("Math::MPFR::NNW", 0)))
           warn("string used in overloaded multiplication (*=) contains non-numeric characters");
       }
       mpfr_mul(*(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), t, __gmpfr_default_rounding_mode);
       mpfr_clear(t);
       return a;
     }

     if(sv_isobject(b)) {
       const char* h = HvNAME(SvSTASH(SvRV(b)));

       if(strEQ(h, "Math::MPFR")) {
         mpfr_mul(*(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(b)))), __gmpfr_default_rounding_mode);
         return a;
       }
       if(strEQ(h, "Math::GMPz")) {
         mpfr_mul_z(*(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), *(INT2PTR(mpz_t *, SvIV(SvRV(b)))), __gmpfr_default_rounding_mode);
         return a;
       }
       if(strEQ(h, "Math::GMPf")) {
         mpfr_init2(t, (mpfr_prec_t)mpf_get_prec(*(INT2PTR(mpf_t *, SvIV(SvRV(b))))));
         mpfr_set_f(t, *(INT2PTR(mpf_t *, SvIV(SvRV(b)))), __gmpfr_default_rounding_mode);
         mpfr_mul(*(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), t, __gmpfr_default_rounding_mode);
         mpfr_clear(t);
         return a;
       }
       if(strEQ(h, "Math::GMPq")) {
         mpfr_mul_q(*(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(a)))), *(INT2PTR(mpq_t *, SvIV(SvRV(b)))), __gmpfr_default_rounding_mode);
         return a;
       }
     }

     SvREFCNT_dec(a);
     croak("Invalid argument supplied to Math::MPFR::overload_mul_eq");
}

SV * _itsa(pTHX_ SV * a) {
     if(SvUOK(a)) return newSVuv(1);
     if(SvIOK(a)) return newSVuv(2);
     if(SvNOK(a)) return newSVuv(3);
     if(SvPOK(a)) return newSVuv(4);
     if(sv_isobject(a)) {
       const char* h = HvNAME(SvSTASH(SvRV(a)));

       if(strEQ(h, "Math::MPFR")) return newSVuv(5);
       if(strEQ(h, "Math::GMPf")) return newSVuv(6);
       if(strEQ(h, "Math::GMPq")) return newSVuv(7);
       if(strEQ(h, "Math::GMPz")) return newSVuv(8);
       if(strEQ(h, "Math::GMP")) return newSVuv(9);        }
     return newSVuv(0);
}

int _has_longlong(void) {
#ifdef MATH_MPFR_NEED_LONG_LONG_INT
    return 1;
#else
    return 0;
#endif
}

int _has_longdouble(void) {
#ifdef USE_LONG_DOUBLE
    return 1;
#else
    return 0;
#endif
}

int _ivsize_bits(void) {
   int ret = 0;
#ifdef IVSIZE_BITS
   ret = IVSIZE_BITS;
#endif
   return ret;
}

/*
int _mpfr_longsize(void) {
    mpfr_t x, y;

    mpfr_init2(x, 100);
    mpfr_init2(y, 100);

    mpfr_set_str(x, "18446744073709551615", 10, GMP_RNDN);
    mpfr_set_ui(y, 18446744073709551615, GMP_RNDN);

    if(!mpfr_cmp(x,y)) return 64;
    return 32;
}
*/

SV * RMPFR_PREC_MAX(pTHX) {
     return newSViv(MPFR_PREC_MAX);
}

SV * RMPFR_PREC_MIN(pTHX) {
     return newSViv(MPFR_PREC_MIN);
}

SV * wrap_mpfr_printf(pTHX_ SV * a, SV * b) {
     int ret;
     if(sv_isobject(b)) {
       const char* h = HvNAME(SvSTASH(SvRV(b)));

       if(strEQ(h, "Math::MPFR")){
         ret = mpfr_printf(SvPV_nolen(a), *(INT2PTR(mpfr_t *, SvIV(SvRV(b)))));
         fflush(stdout);
         return newSViv(ret);
       }

       if(strEQ(h, "Math::MPFR::Prec")){
         ret = mpfr_printf(SvPV_nolen(a), *(INT2PTR(mp_prec_t *, SvIV(SvRV(b)))));
         fflush(stdout);
         return newSViv(ret);
       }

       croak("Unrecognised object supplied as argument to Rmpfr_printf");
     }

     if(SvUOK(b)) {
       ret = mpfr_printf(SvPV_nolen(a), SvUV(b));
       fflush(stdout);
       return newSViv(ret);
     }
     if(SvIOK(b)) {
       ret = mpfr_printf(SvPV_nolen(a), SvIV(b));
       fflush(stdout);
       return newSViv(ret);
     }
     if(SvNOK(b)) {
       ret = mpfr_printf(SvPV_nolen(a), SvNV(b));
       fflush(stdout);
       return newSViv(ret);
     }
     if(SvPOK(b)) {
       ret = mpfr_printf(SvPV_nolen(a), SvPV_nolen(b));
       fflush(stdout);
       return newSViv(ret);
     }

     croak("Unrecognised type supplied as argument to Rmpfr_printf");
}

SV * wrap_mpfr_fprintf(pTHX_ FILE * stream, SV * a, SV * b) {
     int ret;
     if(sv_isobject(b)) {
       const char* h = HvNAME(SvSTASH(SvRV(b)));

       if(strEQ(h, "Math::MPFR")) {
         ret = mpfr_fprintf(stream, SvPV_nolen(a), *(INT2PTR(mpfr_t *, SvIV(SvRV(b)))));
         fflush(stream);
         return newSViv(ret);
       }

       if(strEQ(h, "Math::MPFR::Prec")) {
         ret = mpfr_fprintf(stream, SvPV_nolen(a), *(INT2PTR(mp_prec_t *, SvIV(SvRV(b)))));
         fflush(stream);
         return newSViv(ret);
       }

       croak("Unrecognised object supplied as argument to Rmpfr_fprintf");
     }

     if(SvUOK(b)) {
       ret = mpfr_fprintf(stream, SvPV_nolen(a), SvUV(b));
       fflush(stream);
       return newSViv(ret);
     }
     if(SvIOK(b)) {
       ret = mpfr_fprintf(stream, SvPV_nolen(a), SvIV(b));
       fflush(stream);
       return newSViv(ret);
     }
     if(SvNOK(b)) {
       ret = mpfr_fprintf(stream, SvPV_nolen(a), SvNV(b));
       fflush(stream);
       return newSViv(ret);
     }
     if(SvPOK(b)) {
       ret = mpfr_fprintf(stream, SvPV_nolen(a), SvPV_nolen(b));
       fflush(stream);
       return newSViv(ret);
     }

     croak("Unrecognised type supplied as argument to Rmpfr_fprintf");
}

SV * wrap_mpfr_sprintf(pTHX_ SV * s, SV * a, SV * b, int buflen) {
     int ret;
     char * stream;

     Newx(stream, buflen, char);

     if(sv_isobject(b)) {
       const char* h = HvNAME(SvSTASH(SvRV(b)));

       if(strEQ(h, "Math::MPFR")) {
         ret = mpfr_sprintf(stream, SvPV_nolen(a), *(INT2PTR(mpfr_t *, SvIV(SvRV(b)))));
         sv_setpv(s, stream);
         Safefree(stream);
         return newSViv(ret);
       }

       if(strEQ(h, "Math::MPFR::Prec")) {
         ret = mpfr_sprintf(stream, SvPV_nolen(a), *(INT2PTR(mp_prec_t *, SvIV(SvRV(b)))));
         sv_setpv(s, stream);
         Safefree(stream);
         return newSViv(ret);
       }

       croak("Unrecognised object supplied as argument to Rmpfr_sprintf");
     }

     if(SvUOK(b)) {
       ret = mpfr_sprintf(stream, SvPV_nolen(a), SvUV(b));
       sv_setpv(s, stream);
       Safefree(stream);
       return newSViv(ret);
     }

     if(SvIOK(b)) {
       ret = mpfr_sprintf(stream, SvPV_nolen(a), SvIV(b));
       sv_setpv(s, stream);
       Safefree(stream);
       return newSViv(ret);
     }

     if(SvNOK(b)) {
       ret = mpfr_sprintf(stream, SvPV_nolen(a), SvNV(b));
       sv_setpv(s, stream);
       Safefree(stream);
       return newSViv(ret);
     }

     if(SvPOK(b)) {
       ret = mpfr_sprintf(stream, SvPV_nolen(a), SvPV_nolen(b));
       sv_setpv(s, stream);
       Safefree(stream);
       return newSViv(ret);
     }

     croak("Unrecognised type supplied as argument to Rmpfr_sprintf");
}

SV * wrap_mpfr_snprintf(pTHX_ SV * s, SV * bytes, SV * a, SV * b, int buflen) {
     int ret;
     char * stream;

     Newx(stream, buflen, char);

     if(sv_isobject(b)) {
       const char* h = HvNAME(SvSTASH(SvRV(b)));

       if(strEQ(h, "Math::MPFR")) {
         ret = mpfr_snprintf(stream, (size_t)SvUV(bytes), SvPV_nolen(a), *(INT2PTR(mpfr_t *, SvIV(SvRV(b)))));
         sv_setpv(s, stream);
         Safefree(stream);
         return newSViv(ret);
       }

       if(strEQ(h, "Math::MPFR::Prec")) {
         ret = mpfr_snprintf(stream, (size_t)SvUV(bytes), SvPV_nolen(a), *(INT2PTR(mp_prec_t *, SvIV(SvRV(b)))));
         sv_setpv(s, stream);
         Safefree(stream);
         return newSViv(ret);
       }

       croak("Unrecognised object supplied as argument to Rmpfr_snprintf");
     }

     if(SvUOK(b)) {
       ret = mpfr_snprintf(stream, (size_t)SvUV(bytes), SvPV_nolen(a), SvUV(b));
       sv_setpv(s, stream);
       Safefree(stream);
       return newSViv(ret);
     }

     if(SvIOK(b)) {
       ret = mpfr_snprintf(stream, (size_t)SvUV(bytes), SvPV_nolen(a), SvIV(b));
       sv_setpv(s, stream);
       Safefree(stream);
       return newSViv(ret);
     }

     if(SvNOK(b)) {
       ret = mpfr_snprintf(stream, (size_t)SvUV(bytes), SvPV_nolen(a), SvNV(b));
       sv_setpv(s, stream);
       Safefree(stream);
       return newSViv(ret);
     }

     if(SvPOK(b)) {
       ret = mpfr_snprintf(stream, (size_t)SvUV(bytes), SvPV_nolen(a), SvPV_nolen(b));
       sv_setpv(s, stream);
       Safefree(stream);
       return newSViv(ret);
     }

     croak("Unrecognised type supplied as argument to Rmpfr_snprintf");
}

SV * wrap_mpfr_printf_rnd(pTHX_ SV * a, SV * round, SV * b) {
     int ret;
#if MPFR_VERSION_MAJOR >= 3
     if((mp_rnd_t)SvUV(round) > 4) croak("Invalid 2nd argument (rounding value) of %u passed to Rmpfr_printf", (mp_rnd_t)SvUV(round));
#else
     if((mp_rnd_t)SvUV(round) > 3) croak("Invalid 2nd argument (rounding value) of %u passed to Rmpfr_printf", (mp_rnd_t)SvUV(round));
#endif
     if(sv_isobject(b)) {
       const char* h = HvNAME(SvSTASH(SvRV(b)));

       if(strEQ(h, "Math::MPFR")){
         ret = mpfr_printf(SvPV_nolen(a), (mp_rnd_t)SvUV(round), *(INT2PTR(mpfr_t *, SvIV(SvRV(b)))));
         fflush(stdout);
         return newSViv(ret);
       }

       if(strEQ(h, "Math::MPFR::Prec")){
         croak("You've provided both a rounding arg and a Math::MPFR::Prec object to Rmpfr_printf");
       }

       croak("Unrecognised object supplied as argument to Rmpfr_printf");
     }

     croak("In Rmpfr_printf: The rounding argument is specific to Math::MPFR objects");
}

SV * wrap_mpfr_fprintf_rnd(pTHX_ FILE * stream, SV * a, SV * round, SV * b) {
     int ret;
#if MPFR_VERSION_MAJOR >= 3
     if((mp_rnd_t)SvUV(round) > 4) croak("Invalid 3rd argument (rounding value) of %u passed to Rmpfr_fprintf", (mp_rnd_t)SvUV(round));
#else
     if((mp_rnd_t)SvUV(round) > 3) croak("Invalid 3rd argument (rounding value) of %u passed to Rmpfr_fprintf", (mp_rnd_t)SvUV(round));
#endif
     if(sv_isobject(b)) {
       const char* h = HvNAME(SvSTASH(SvRV(b)));

       if(strEQ(h, "Math::MPFR")) {
         ret = mpfr_fprintf(stream, SvPV_nolen(a), (mp_rnd_t)SvUV(round), *(INT2PTR(mpfr_t *, SvIV(SvRV(b)))));
         fflush(stream);
         return newSViv(ret);
       }

       if(strEQ(h, "Math::MPFR::Prec")) {
         croak("You've provided both a rounding arg and a Math::MPFR::Prec object to Rmpfr_fprintf");
       }

       croak("Unrecognised object supplied as argument to Rmpfr_fprintf");
     }

     croak("In Rmpfr_fprintf: The rounding argument is specific to Math::MPFR objects");
}

SV * wrap_mpfr_sprintf_rnd(pTHX_ SV * s, SV * a, SV * round, SV * b, int buflen) {
     int ret;
     char * stream;

     Newx(stream, buflen, char);

#if MPFR_VERSION_MAJOR >= 3
     if((mp_rnd_t)SvUV(round) > 4) croak("Invalid 3rd argument (rounding value) of %u passed to Rmpfr_sprintf", (mp_rnd_t)SvUV(round));
#else
     if((mp_rnd_t)SvUV(round) > 3) croak("Invalid 3rd argument (rounding value) of %u passed to Rmpfr_sprintf", (mp_rnd_t)SvUV(round));
#endif
     if(sv_isobject(b)) {
       const char* h = HvNAME(SvSTASH(SvRV(b)));

       if(strEQ(h, "Math::MPFR")) {
         ret = mpfr_sprintf(stream, SvPV_nolen(a), (mp_rnd_t)SvUV(round), *(INT2PTR(mpfr_t *, SvIV(SvRV(b)))));
         sv_setpv(s, stream);
         Safefree(stream);
         return newSViv(ret);
       }

       if(strEQ(h, "Math::MPFR::Prec")) {
         croak("You've provided both a rounding arg and a Math::MPFR::Prec object to Rmpfr_sprintf");
       }

       croak("Unrecognised object supplied as argument to Rmpfr_sprintf");
     }

     croak("In Rmpfr_sprintf: The rounding argument is specific to Math::MPFR objects");
}

SV * wrap_mpfr_snprintf_rnd(pTHX_ SV * s, SV * bytes, SV * a, SV * round, SV * b, int buflen) {
     int ret;
     char * stream;

     Newx(stream, buflen, char);

#if MPFR_VERSION_MAJOR >= 3
     if((mp_rnd_t)SvUV(round) > 4) croak("Invalid 3rd argument (rounding value) of %u passed to Rmpfr_snprintf", (mp_rnd_t)SvUV(round));
#else
     if((mp_rnd_t)SvUV(round) > 3) croak("Invalid 3rd argument (rounding value) of %u passed to Rmpfr_snprintf", (mp_rnd_t)SvUV(round));
#endif
     if(sv_isobject(b)) {
       const char* h = HvNAME(SvSTASH(SvRV(b)));

       if(strEQ(h, "Math::MPFR")) {
         ret = mpfr_snprintf(stream, (size_t)SvUV(bytes), SvPV_nolen(a), (mp_rnd_t)SvUV(round), *(INT2PTR(mpfr_t *, SvIV(SvRV(b)))));
         sv_setpv(s, stream);
         Safefree(stream);
         return newSViv(ret);
       }

       if(strEQ(h, "Math::MPFR::Prec")) {
         croak("You've provided both a rounding arg and a Math::MPFR::Prec object to Rmpfr_snprintf");
       }

       croak("Unrecognised object supplied as argument to Rmpfr_snprintf");
     }

     croak("In Rmpfr_snprintf: The rounding argument is specific to Math::MPFR objects");
}



SV * Rmpfr_buildopt_tls_p(pTHX) {
#if MPFR_VERSION_MAJOR >= 3
     return newSViv(mpfr_buildopt_tls_p());
#else
     croak("Rmpfr_buildopt_tls_p not implemented with this version of the mpfr library - we have %s but need at least 3.0.0", MPFR_VERSION_STRING);
#endif
}

SV * Rmpfr_buildopt_decimal_p(pTHX) {
#if MPFR_VERSION_MAJOR >= 3
     return newSViv(mpfr_buildopt_decimal_p());
#else
     croak("Rmpfr_buildopt_decimal_p not implemented with this version of the mpfr library - we have %s but need at least 3.0.0", MPFR_VERSION_STRING);
#endif
}

SV * Rmpfr_regular_p(pTHX_ mpfr_t * a) {
#if MPFR_VERSION_MAJOR >= 3
     return newSViv(mpfr_regular_p(*a));
#else
     croak("Rmpfr_regular_p not implemented with this version of the mpfr library - we have %s but need at least 3.0.0", MPFR_VERSION_STRING);
#endif
}

void Rmpfr_set_zero(pTHX_ mpfr_t * a, SV * sign) {
#if MPFR_VERSION_MAJOR >= 3
     mpfr_set_zero(*a, (int)SvIV(sign));
#else
     croak("Rmpfr_set_zero not implemented with this version of the mpfr library - we have %s but need at least 3.0.0", MPFR_VERSION_STRING);
#endif
}

SV * Rmpfr_digamma(pTHX_ mpfr_t * rop, mpfr_t * op, SV * round) {
#if MPFR_VERSION_MAJOR >= 3
     return newSViv(mpfr_digamma(*rop, *op, (mp_rnd_t)SvIV(round)));
#else
     croak("Rmpfr_digamma not implemented with this version of the mpfr library - we have %s but need at least 3.0.0", MPFR_VERSION_STRING);
#endif
}

SV * Rmpfr_ai(pTHX_ mpfr_t * rop, mpfr_t * op, SV * round) {
#if MPFR_VERSION_MAJOR >= 3
     return newSViv(mpfr_ai(*rop, *op, (mp_rnd_t)SvUV(round)));
#else
     croak("Rmpfr_ai not implemented with this version of the mpfr library - we have %s but need at least 3.0.0", MPFR_VERSION_STRING);
#endif
}

SV * Rmpfr_get_flt(pTHX_ mpfr_t * a, SV * round) {
#if MPFR_VERSION_MAJOR >= 3
     return newSVnv(mpfr_get_flt(*a, (mp_rnd_t)SvUV(round)));
#else
     croak("Rmpfr_get_flt not implemented with this version of the mpfr library - we have %s but need at least 3.0.0", MPFR_VERSION_STRING);
#endif
}

SV * Rmpfr_set_flt(pTHX_ mpfr_t * rop, SV * f, SV * round) {
#if MPFR_VERSION_MAJOR >= 3
     return newSViv(mpfr_set_flt(*rop, (float)SvNV(f), (mp_rnd_t)SvUV(round)));
#else
     croak("Rmpfr_set_flt not implemented with this version of the mpfr library - we have %s but need at least 3.0.0", MPFR_VERSION_STRING);
#endif
}

SV * Rmpfr_urandom(pTHX_ mpfr_t * rop, gmp_randstate_t* state, SV * round) {
#if MPFR_VERSION_MAJOR >= 3
     return newSViv(mpfr_urandom(*rop, *state, (mp_rnd_t)SvUV(round)));
#else
     croak("Rmpfr_urandom not implemented with this version of the mpfr library - we have %s but need at least 3.0.0", MPFR_VERSION_STRING);
#endif
}

SV * Rmpfr_set_z_2exp(pTHX_ mpfr_t * rop, mpz_t * op, SV * exp, SV * round) {
#if MPFR_VERSION_MAJOR >= 3
     return newSViv(mpfr_set_z_2exp(*rop, *op, (mpfr_exp_t)SvIV(exp), (mp_rnd_t)SvUV(round)));
#else
     croak("Rmpfr_set_z_2exp not implemented with this version of the mpfr library - we have %s but need at least 3.0.0", MPFR_VERSION_STRING);
#endif
}

SV * Rmpfr_buildopt_tune_case(pTHX) {
#if (MPFR_VERSION_MAJOR == 3 && MPFR_VERSION_MINOR >= 1) || MPFR_VERSION_MAJOR > 3
     return newSVpv(mpfr_buildopt_tune_case(), 0);
#else
     croak("Rmpfr_buildopt_tune_case not implemented with this version of the mpfr library - we have %s but need at least 3.1.0", MPFR_VERSION_STRING);
#endif
}

SV * Rmpfr_frexp(pTHX_ SV * exp, mpfr_t * rop, mpfr_t * op, SV * round) {
#if (MPFR_VERSION_MAJOR == 3 && MPFR_VERSION_MINOR >= 1) || MPFR_VERSION_MAJOR > 3
     mpfr_exp_t _exp;
     int ret;

     ret = mpfr_frexp(&_exp, *rop, *op, (mp_rnd_t)SvUV(round));
     sv_setiv(exp, _exp);
     return newSViv(ret);
#else
     croak("Rmpfr_frexp not implemented with this version of the mpfr library - we have %s but need at least 3.1.0", MPFR_VERSION_STRING);
#endif
}

SV * Rmpfr_z_sub(pTHX_ mpfr_t * rop, mpz_t * op1, mpfr_t * op2, SV * round) {
#if (MPFR_VERSION_MAJOR == 3 && MPFR_VERSION_MINOR >= 1) || MPFR_VERSION_MAJOR > 3
     return newSViv(mpfr_z_sub(*rop, *op1, *op2, (mp_rnd_t)SvUV(round)));
#else
     croak("Rmpfr_z_sub not implemented with this version of the mpfr library - we have %s but need at least 3.1.0", MPFR_VERSION_STRING);
#endif
}

SV * Rmpfr_grandom(pTHX_ mpfr_t * rop1, mpfr_t * rop2, gmp_randstate_t * state, SV * round) {
#if (MPFR_VERSION_MAJOR == 3 && MPFR_VERSION_MINOR >= 1) || MPFR_VERSION_MAJOR > 3
     return newSViv(mpfr_grandom(*rop1, *rop2, *state, (mp_rnd_t)SvUV(round)));
#else
     croak("Rmpfr_grandom not implemented with this version of the mpfr library - we have %s but need at least 3.1.0", MPFR_VERSION_STRING);
#endif
}

void Rmpfr_clear_divby0(pTHX) {
#if (MPFR_VERSION_MAJOR == 3 && MPFR_VERSION_MINOR >= 1) || MPFR_VERSION_MAJOR > 3
     mpfr_clear_divby0();
#else
     croak("Rmpfr_clear_divby0 not implemented with this version of the mpfr library - we have %s but need at least 3.1.0", MPFR_VERSION_STRING);
#endif
}

void Rmpfr_set_divby0(pTHX) {
#if (MPFR_VERSION_MAJOR == 3 && MPFR_VERSION_MINOR >= 1) || MPFR_VERSION_MAJOR > 3
     mpfr_set_divby0();
#else
     croak("Rmpfr_set_divby0 not implemented with this version of the mpfr library - we have %s but need at least 3.1.0", MPFR_VERSION_STRING);
#endif
}

SV * Rmpfr_divby0_p(pTHX) {
#if (MPFR_VERSION_MAJOR == 3 && MPFR_VERSION_MINOR >= 1) || MPFR_VERSION_MAJOR > 3
     return newSViv(mpfr_divby0_p());
#else
     croak("Rmpfr_divby0_p not implemented with this version of the mpfr library - we have %s but need at least 3.1.0", MPFR_VERSION_STRING);
#endif
}

SV * Rmpfr_buildopt_gmpinternals_p(pTHX) {
#if (MPFR_VERSION_MAJOR == 3 && MPFR_VERSION_MINOR >= 1) || MPFR_VERSION_MAJOR > 3
     return newSViv(mpfr_buildopt_gmpinternals_p());
#else
     croak("Rmpfr_buildopt_gmpinternals_p not implemented with this version of the mpfr library - we have %s but need at least 3.1.0", MPFR_VERSION_STRING);
#endif
}

SV * _get_xs_version(pTHX) {
     return newSVpv(XS_VERSION, 0);
}

SV * overload_inc(pTHX_ SV * p, SV * second, SV * third) {
     SvREFCNT_inc(p);
     mpfr_add_ui(*(INT2PTR(mpfr_t *, SvIV(SvRV(p)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(p)))), 1, __gmpfr_default_rounding_mode);
     return p;
}

SV * overload_dec(pTHX_ SV * p, SV * second, SV * third) {
     SvREFCNT_inc(p);
     mpfr_sub_ui(*(INT2PTR(mpfr_t *, SvIV(SvRV(p)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(p)))), 1, __gmpfr_default_rounding_mode);
     return p;
}

SV * _wrap_count(pTHX) {
     return newSVuv(PL_sv_count);
}

SV * Rmpfr_set_LD(pTHX_ mpfr_t * rop, SV * op, SV *rnd) {
     if(sv_isobject(op)) {
       const char* h = HvNAME(SvSTASH(SvRV(op)));

       if(strEQ(h, "Math::LongDouble")) {
         return newSViv(mpfr_set_ld(*rop, *(INT2PTR(long double *, SvIV(SvRV(op)))), (mp_rnd_t)SvUV(rnd)));
       }
       croak("2nd arg (a %s object) supplied to Rmpfr_set_LD needs to be a Math::LongDouble object",
              HvNAME(SvSTASH(SvRV(op))));
     }
     else croak("2nd arg (which needs to be a Math::LongDouble object) supplied to Rmpfr_set_LD is not an object");
}

/*
int mpfr_set_decimal64 (mpfr_t rop, _Decimal64 op, mpfr_rnd_t rnd)
*/

SV * Rmpfr_set_DECIMAL64(pTHX_ mpfr_t * rop, SV * op, SV * rnd) {
#if (!defined(MPFR_VERSION) || (MPFR_VERSION<MPFR_VERSION_NUM(3,1,0)))
     croak("Perl interface to Rmpfr_set_DECIMAL64 not available for this version (%s) of the mpfr library. We need at least version 3.1.0",
            MPFR_VERSION_STRING);
#endif

/*
 MPFR_WANT_DECIMAL_FLOATS needs to have been defined prior to inclusion of mpfr.h - this is done by
 defining it at the 'Makefile.PL' step - see the Makefile.PL
*/

#ifdef MPFR_WANT_DECIMAL_FLOATS
    if(sv_isobject(op)) {
      const char* h = HvNAME(SvSTASH(SvRV(op)));

      if(strEQ(h, "Math::Decimal64"))
        return newSViv(mpfr_set_decimal64(*rop, *(INT2PTR(_Decimal64 *, SvIV(SvRV(op)))), (mp_rnd_t)SvUV(rnd)));
       croak("2nd arg (a %s object) supplied to Rmpfr_set_DECIMAL64 needs to be a Math::Decimal64 object",
               HvNAME(SvSTASH(SvRV(op))));
    }
    else croak("2nd arg (which needs to be a Math::Decimal64 object) supplied to Rmpfr_set_DECIMAL64 is not an object");

#else

    croak("MPFR_WANT_DECIMAL_FLOATS needs to have been defined when building Math::MPFR - see the Makefile.PL");

#endif
}

void Rmpfr_get_LD(pTHX_ SV * rop, mpfr_t * op, SV * rnd) {
     if(sv_isobject(rop)) {
       const char* h = HvNAME(SvSTASH(SvRV(rop)));

       if(strEQ(h, "Math::LongDouble")) {
         *(INT2PTR(long double *, SvIV(SvRV(rop)))) = mpfr_get_ld(*op, (mp_rnd_t)SvUV(rnd));
       }
       else croak("1st arg (a %s object) supplied to Rmpfr_get_LD needs to be a Math::LongDouble object",
                  HvNAME(SvSTASH(SvRV(rop))));
     }
     else croak("1st arg (which needs to be a Math::LongDouble object) supplied to Rmpfr_get_LD is not an object");
}

void Rmpfr_get_DECIMAL64(pTHX_ SV * rop, mpfr_t * op, SV * rnd) {
#if (!defined(MPFR_VERSION) || (MPFR_VERSION<MPFR_VERSION_NUM(3,1,0)))
     croak("Perl interface to Rmpfr_get_DECIMAL64 not available for this version (%s) of the mpfr library. We need at least version 3.1.0",
              MPFR_VERSION_STRING);
#endif

/*
 MPFR_WANT_DECIMAL_FLOATS needs to have been defined prior to inclusion of mpfr.h - this is done by
 defining it at the 'Makefile.PL' step - see the Makefile.PL
*/

#ifdef MPFR_WANT_DECIMAL_FLOATS
    if(sv_isobject(rop)) {
      const char* h = HvNAME(SvSTASH(SvRV(rop)));

      if(strEQ(h, "Math::Decimal64"))
        *(INT2PTR(_Decimal64 *, SvIV(SvRV(rop)))) = mpfr_get_decimal64(*op, (mp_rnd_t)SvUV(rnd));

       else croak("1st arg (a %s object) supplied to Rmpfr_get_DECIMAL64 needs to be a Math::Decimal64 object",
                      HvNAME(SvSTASH(SvRV(rop))));
    }
    else croak("1st arg (which needs to be a Math::Decimal64 object) supplied to Rmpfr_get_DECIMAL64 is not an object");

#else

    croak("MPFR_WANT_DECIMAL_FLOATS needs to have been defined when building Math::MPFR - see the Makefile.PL");

#endif
}

int _MPFR_WANT_DECIMAL_FLOATS(void) {
#ifdef MPFR_WANT_DECIMAL_FLOATS
 return 1;
#else
 return 0;
#endif
}

int _MPFR_WANT_FLOAT128(void) {
#ifdef MPFR_WANT_FLOAT128
 return 1;
#else
 return 0;
#endif
}

SV * _max_base(pTHX) {
     return newSViv(MAXIMUM_ALLOWABLE_BASE);
}

SV * _isobject(pTHX_ SV * x) {
    if(sv_isobject(x))return newSVuv(1);
    return newSVuv(0);
}

void _mp_sizes(void) {
     dTHX;
     dXSARGS;
/* I don't know if 3.0.0 is the actual switchover version, but it shouldn't matter */
#if MPFR_VERSION_MAJOR >= 3
     XPUSHs(sv_2mortal(newSVuv(sizeof(mpfr_exp_t))));
     XPUSHs(sv_2mortal(newSVuv(sizeof(mpfr_prec_t))));
     XPUSHs(sv_2mortal(newSVuv(sizeof(mpfr_rnd_t))));
#else
     XPUSHs(sv_2mortal(newSVuv(sizeof(mp_exp_t))));
     XPUSHs(sv_2mortal(newSVuv(sizeof(mp_prec_t))));
     XPUSHs(sv_2mortal(newSVuv(sizeof(mp_rnd_t))));
#endif


     XSRETURN(3);
}

SV * _ivsize(pTHX) {
     return newSVuv(sizeof(IV));
}

SV * _nvsize(pTHX) {
     return newSVuv(sizeof(NV));
}

SV * _FLT128_DIG(pTHX) {
#ifdef FLT128_DIG
     return newSViv(FLT128_DIG);
#else
     return &PL_sv_undef;
#endif
}

SV * _LDBL_DIG(pTHX) {
#ifdef LDBL_DIG
     return newSViv(LDBL_DIG);
#else
     return &PL_sv_undef;
#endif
}

SV * _DBL_DIG(pTHX) {
#ifdef DBL_DIG
     return newSViv(DBL_DIG);
#else
     return &PL_sv_undef;
#endif
}

SV * _FLT128_MANT_DIG(pTHX) {
#ifdef FLT128_MANT_DIG
     return newSViv(FLT128_MANT_DIG);
#else
     return &PL_sv_undef;
#endif
}

SV * _LDBL_MANT_DIG(pTHX) {
#ifdef LDBL_MANT_DIG
     return newSViv(LDBL_MANT_DIG);
#else
     return &PL_sv_undef;
#endif
}

SV * _DBL_MANT_DIG(pTHX) {
#ifdef DBL_MANT_DIG
     return newSViv(DBL_MANT_DIG);
#else
     return &PL_sv_undef;
#endif
}


/*///////////////////////////////////////////
////////////////////////////////////////////*/
/* All randinit functions now moved to Math::MPFR::Random */
/*

*/
/***********************************************
************************************************/

SV * Rmpfr_get_float128(pTHX_ mpfr_t * op, SV * rnd) {

#ifdef CAN_PASS_FLOAT128
     return newSVnv(mpfr_get_float128(*op, (mp_rnd_t)SvUV(rnd)));
#else
     croak("Cannot use Rmpfr_get_float128 to return an NV");
#endif
}

void Rmpfr_get_FLOAT128(pTHX_ SV * rop, mpfr_t * op, SV * rnd) {
#if (!defined(MPFR_VERSION) || (MPFR_VERSION < MPFR_VERSION_NUM(3,2,0)))
     croak("Perl interface to Rmpfr_get_FLOAT128 not available for this version (%s) of the mpfr library. We need at least version 3.2.0",
              MPFR_VERSION_STRING);
#endif

/*
 MPFR_WANT_FLOAT128 needs to have been defined prior to inclusion of mpfr.h - this is done by
 defining it at the 'Makefile.PL' step - see the Makefile.PL
*/

#ifdef MPFR_WANT_FLOAT128
    if(sv_isobject(rop)) {
      const char* h = HvNAME(SvSTASH(SvRV(rop)));

      if(strEQ(h, "Math::Float128"))
        *(INT2PTR(float128 *, SvIV(SvRV(rop)))) = mpfr_get_float128(*op, (mp_rnd_t)SvUV(rnd));

       else croak("1st arg (a %s object) supplied to Rmpfr_get_FLOAT128 needs to be a Math::Float128 object",
                      HvNAME(SvSTASH(SvRV(rop))));
    }
    else croak("1st arg (which needs to be a Math::Float128 object) supplied to Rmpfr_get_FLOAT128 is not an object");

#else

    croak("MPFR_WANT_FLOAT128 needs to have been defined when building Math::MPFR - see the Makefile.PL");

#endif
}

SV * Rmpfr_set_FLOAT128(pTHX_ mpfr_t * rop, SV * op, SV * rnd) {
#if (!defined(MPFR_VERSION) || (MPFR_VERSION < MPFR_VERSION_NUM(3,2,0)))
     croak("Perl interface to Rmpfr_set_FLOAT128 not available for this version (%s) of the mpfr library. We need at least version 3.2.0",
            MPFR_VERSION_STRING);
#endif

/*
 MPFR_WANT_FLOAT128 needs to have been defined prior to inclusion of mpfr.h - this is done by
 defining it at the 'Makefile.PL' step - see the Makefile.PL
*/

#ifdef MPFR_WANT_FLOAT128
    if(sv_isobject(op)) {
      const char* h = HvNAME(SvSTASH(SvRV(op)));

      if(strEQ(h, "Math::Float128"))
        return newSViv(mpfr_set_float128(*rop, *(INT2PTR(float128 *, SvIV(SvRV(op)))), (mp_rnd_t)SvUV(rnd)));
       croak("2nd arg (a %s object) supplied to Rmpfr_set_FLOAT128 needs to be a Math::Float128 object",
               HvNAME(SvSTASH(SvRV(op))));
    }
    else croak("2nd arg (which needs to be a Math::Float128 object) supplied to Rmpfr_set_FLOAT128 is not an object");

#else

    croak("MPFR_WANT_FLOAT128 needs to have been defined when building Math::MPFR - see the Makefile.PL");

#endif
}

SV * Rmpfr_set_float128(pTHX_ mpfr_t * rop, SV * q, SV * rnd) {

#ifdef CAN_PASS_FLOAT128
     return newSViv(mpfr_set_float128(*rop, (float128)SvNV(q), (mp_rnd_t)SvUV(rnd)));
#else
     croak("Cannot use Rmpfr_set_float128 to set an NV");
#endif

}

SV * _is_readonly(pTHX_ SV * sv) {
     if SvREADONLY(sv) return newSVuv(1);
     return newSVuv(0);
}

void _readonly_on(pTHX_ SV * sv) {
     SvREADONLY_on(sv);
}

void _readonly_off(pTHX_ SV * sv) {
     SvREADONLY_off(sv);
}

int _can_pass_float128(void) {

#ifdef CAN_PASS_FLOAT128
   return 1;
#else
   return 0;
#endif

}

int _mpfr_want_float128(void) {

#ifdef MPFR_WANT_FLOAT128
   return 1;
#else
   return 0;
#endif

}

int nnumflag(void) {
  return nnum;
}

void clear_nnum(void) {
  nnum = 0;
}

void set_nnum(int x) {
  nnum = x;
}

void _d_bytes(pTHX_ SV * str, unsigned int bits) {

 /* Assumes 64-bit double (53-bit precision mantissa) */

  dXSARGS;
  mpfr_t temp;
  double ld;
  int i, n = 8;
  char * buff;
  void * p = &ld;

  if(bits != 53)
    croak("2nd arg to Math::MPFR::_d_bytes must be 53");

  if(SvUV(_itsa(aTHX_ str)) != 4)
    croak("1st arg supplied to Math::MPFR::_d_bytes is not a string");

  if((size_t)bits != DBL_MANT_DIG)
    croak("2nd arg (%u) supplied to Math::MPFR::_d_bytes does not match DBL_MANT_DIG (%u)", bits, DBL_MANT_DIG);

  mpfr_init2(temp, 53);

  mpfr_set_str(temp, SvPV_nolen(str), 0, GMP_RNDN);

  ld = mpfr_get_d(temp, GMP_RNDN);

  mpfr_clear(temp);

  Newx(buff, 4, char);
  if(buff == NULL) croak("Failed to allocate memory in Math::MPFR::_d_bytes function");

  sp = mark;

#ifdef MPFR_HAVE_BENDIAN /* Big Endian architecture */
  for (i = 0; i < n; i++) {
#else
  for (i = n - 1; i >= 0; i--) {
#endif

    sprintf(buff, "%02x", ((unsigned char*)p)[i]);
    XPUSHs(sv_2mortal(newSVpv(buff, 0)));
  }
  PUTBACK;
  Safefree(buff);
  XSRETURN(n);

}

void _d_bytes_fr(pTHX_ mpfr_t * str, unsigned int bits) {

 /* Assumes 64-bit double (53-bit precision mantissa) */

  dXSARGS;
  double ld;
  int i, n = 8;
  char * buff;
  void * p = &ld;

  if(bits != 53)
    croak("2nd arg to Math::MPFR::_d_bytes_fr must be 53");

  if(mpfr_get_prec(*str) != 53)
    croak("Precison of 1st arg supplied to _d_bytes_fr must be 53, not %u", mpfr_get_prec(*str));

  if((size_t)bits != DBL_MANT_DIG)
    croak("2nd arg (%u) supplied to Math::MPFR::_d_bytes_fr does not match DBL_MANT_DIG (%u)", bits, DBL_MANT_DIG);

  ld = mpfr_get_d(*str, GMP_RNDN);

  Newx(buff, 4, char);
  if(buff == NULL) croak("Failed to allocate memory in Math::MPFR::_d_bytes_fr function");

  sp = mark;

#ifdef MPFR_HAVE_BENDIAN /* Big Endian architecture */
  for (i = 0; i < n; i++) {
#else
  for (i = n - 1; i >= 0; i--) {
#endif

    sprintf(buff, "%02x", ((unsigned char*)p)[i]);
    XPUSHs(sv_2mortal(newSVpv(buff, 0)));
  }
  PUTBACK;
  Safefree(buff);
  XSRETURN(n);

}

void _dd_bytes(pTHX_ SV * str, unsigned int bits) {

 /* Assumes 128-bit long double (106-bit precision mantissa) */

  dXSARGS;
  mpfr_t temp;
  double msd, lsd;
  int i, n = 8;
  char * buff;
  void * pm = &msd;
  void * pl = &lsd;

  if(bits != 106)
    croak("2nd arg to Math::MPFR::_dd_bytes must be 106");

  if(SvUV(_itsa(aTHX_ str)) != 4)
    croak("1st arg supplied to Math::MPFR::_dd_bytes is not a string");

  mpfr_init2(temp, 2098);

  mpfr_set_str(temp, SvPV_nolen(str), 0, GMP_RNDN);

  msd = mpfr_get_d(temp, GMP_RNDN);
  mpfr_sub_d(temp, temp, msd, GMP_RNDN);
  lsd = mpfr_get_d(temp, GMP_RNDN);

  mpfr_clear(temp);

  Newx(buff, 4, char);
  if(buff == NULL) croak("Failed to allocate memory in Math::MPFR::_dd_bytes function");

  sp = mark;

#ifdef MPFR_HAVE_BENDIAN /* Big Endian architecture */
  for (i = 0; i < n; i++) {
#else
  for (i = n - 1; i >= 0; i--) {
#endif

    sprintf(buff, "%02x", ((unsigned char*)pm)[i]);
    XPUSHs(sv_2mortal(newSVpv(buff, 0)));
  }

#ifdef MPFR_HAVE_BENDIAN /* Big Endian architecture */
  for (i = 0; i < n; i++) {
#else
  for (i = n - 1; i >= 0; i--) {
#endif

    sprintf(buff, "%02x", ((unsigned char*)pl)[i]);
    XPUSHs(sv_2mortal(newSVpv(buff, 0)));
  }
  PUTBACK;
  Safefree(buff);
  XSRETURN(16);

}

void _dd_bytes_fr(pTHX_ mpfr_t * str, unsigned int bits) {

 /* Assumes 128-bit long double (106-bit precision mantissa) */

  dXSARGS;
  mpfr_t temp;
  double msd, lsd;
  int i, n = 8;
  char * buff;
  void * pm = &msd;
  void * pl = &lsd;

  if(bits != 106)
    croak("2nd arg to Math::MPFR::_dd_bytes must be 106");

  if(mpfr_get_prec(*str) != 2098)
    croak("Precison of 1st arg supplied to _dd_bytes_fr must be 2098, not %u", mpfr_get_prec(*str));

  mpfr_init2(temp, 2098);

  mpfr_set(temp, *str, GMP_RNDN); /* Avoid altering the value held by *str */

  msd = mpfr_get_d(temp, GMP_RNDN);
  mpfr_sub_d(temp, temp, msd, GMP_RNDN);
  lsd = mpfr_get_d(temp, GMP_RNDN);

  mpfr_clear(temp);

  Newx(buff, 4, char);
  if(buff == NULL) croak("Failed to allocate memory in Math::MPFR::_dd_bytes_fr function");

  sp = mark;

#ifdef MPFR_HAVE_BENDIAN /* Big Endian architecture */
  for (i = 0; i < n; i++) {
#else
  for (i = n - 1; i >= 0; i--) {
#endif

    sprintf(buff, "%02x", ((unsigned char*)pm)[i]);
    XPUSHs(sv_2mortal(newSVpv(buff, 0)));
  }

#ifdef MPFR_HAVE_BENDIAN /* Big Endian architecture */
  for (i = 0; i < n; i++) {
#else
  for (i = n - 1; i >= 0; i--) {
#endif

    sprintf(buff, "%02x", ((unsigned char*)pl)[i]);
    XPUSHs(sv_2mortal(newSVpv(buff, 0)));
  }
  PUTBACK;
  Safefree(buff);
  XSRETURN(16);

}

void _ld_bytes(pTHX_ SV * str, unsigned int bits) {

 /* For Math::NV - added in version 3.26 */
 /* Assumes 80-bit long double (64-bit precision mantissa) */

  dXSARGS;
  mpfr_t temp;
  long double ld;
  int i, n = 10;
  char * buff;
  void * p = &ld;

  if(bits != 64) {
    if(bits == 106) warn("\nYou probably want to call Math::MPFR::_dd_bytes\n");
    croak("2nd arg to Math::MPFR::_ld_bytes must be 64");
  }

  if(SvUV(_itsa(aTHX_ str)) != 4)
    croak("1st arg supplied to Math::MPFR::_ld_bytes is not a string");

  if((size_t)bits != LDBL_MANT_DIG)
    croak("2nd arg (%u) supplied to Math::MPFR::_ld_bytes does not match LDBL_MANT_DIG (%u)", bits, LDBL_MANT_DIG);

  mpfr_init2(temp, 64);

  mpfr_set_str(temp, SvPV_nolen(str), 0, GMP_RNDN);

  ld = mpfr_get_ld(temp, GMP_RNDN);

  mpfr_clear(temp);

  Newx(buff, 4, char);
  if(buff == NULL) croak("Failed to allocate memory in Math::MPFR::_ld_bytes function");

  sp = mark;

#ifdef MPFR_HAVE_BENDIAN /* Big Endian architecture */
  for (i = 0; i < n; i++) {
#else
  for (i = n - 1; i >= 0; i--) {
#endif

    sprintf(buff, "%02x", ((unsigned char*)p)[i]);
    XPUSHs(sv_2mortal(newSVpv(buff, 0)));
  }
  PUTBACK;
  Safefree(buff);
  XSRETURN(n);

}

void _ld_bytes_fr(pTHX_ mpfr_t * str, unsigned int bits) {

 /* For Math::NV - added in version 3.26 */
 /* Assumes 80-bit long double (64-bit precision mantissa) */

  dXSARGS;
  long double ld;
  int i, n = 10;
  char * buff;
  void * p = &ld;

  if(bits != 64) {
    if(bits == 106) warn("\nYou probably want to call Math::MPFR::_dd_bytes_fr\n");
    croak("2nd arg to Math::MPFR::_ld_bytes_fr must be 64");
  }

  if(mpfr_get_prec(*str) != 64)
    croak("Precison of 1st arg supplied to _ld_bytes_fr must be 64, not %u", mpfr_get_prec(*str));

  if((size_t)bits != LDBL_MANT_DIG)
    croak("2nd arg (%u) supplied to Math::MPFR::_ld_bytes_fr does not match LDBL_MANT_DIG (%u)", bits, LDBL_MANT_DIG);

  ld = mpfr_get_ld(*str, GMP_RNDN);

  Newx(buff, 4, char);
  if(buff == NULL) croak("Failed to allocate memory in Math::MPFR::_ld_bytes_fr function");

  sp = mark;

#ifdef MPFR_HAVE_BENDIAN /* Big Endian architecture */
  for (i = 0; i < n; i++) {
#else
  for (i = n - 1; i >= 0; i--) {
#endif

    sprintf(buff, "%02x", ((unsigned char*)p)[i]);
    XPUSHs(sv_2mortal(newSVpv(buff, 0)));
  }
  PUTBACK;
  Safefree(buff);
  XSRETURN(n);

}

void _f128_bytes(pTHX_ SV * str, unsigned int bits) {

 /* For Math::NV - added in version 3.26 */
 /* Assumes 128-bit __float128 (113-bit precision mantissa) */

#ifndef MPFR_WANT_FLOAT128

  croak("__float128 support not built into this Math::MPFR");

#else

  dXSARGS;
  mpfr_t temp;
  float128 ld;
  int i, n = 16;
  char * buff;
  void * p = &ld;

  if(bits != 113)
    croak("2nd arg to Math::MPFR::_f128_bytes must be 113");

  if(SvUV(_itsa(aTHX_ str)) != 4)
    croak("1st arg supplied to Math::MPFR::_f128_bytes is not a string");

  if((size_t)bits != FLT128_MANT_DIG)
    croak("2nd arg (%u) supplied to Math::MPFR::_f128_bytes does not match FLT128_MANT_DIG (%u)", bits, FLT128_MANT_DIG);

  mpfr_init2(temp, 113);

  mpfr_set_str(temp, SvPV_nolen(str), 0, GMP_RNDN);

  ld = mpfr_get_float128(temp, GMP_RNDN);

  mpfr_clear(temp);

  Newx(buff, 4, char);
  if(buff == NULL) croak("Failed to allocate memory in Math::MPFR::_f128_bytes function");

  sp = mark;

#ifdef MPFR_HAVE_BENDIAN /* Big Endian architecture */
  for (i = 0; i < n; i++) {
#else
  for (i = n - 1; i >= 0; i--) {
#endif

    sprintf(buff, "%02x", ((unsigned char*)p)[i]);
    XPUSHs(sv_2mortal(newSVpv(buff, 0)));
  }
  PUTBACK;
  Safefree(buff);
  XSRETURN(n);

#endif

}

void _f128_bytes_fr(pTHX_ mpfr_t * str, unsigned int bits) {

 /* Assumes 128-bit __float128 (113-bit precision mantissa) */

#ifndef MPFR_WANT_FLOAT128

  croak("__float128 support not built into this Math::MPFR");

#else

  dXSARGS;
  float128 ld;
  int i, n = 16;
  char * buff;
  void * p = &ld;

  if(bits != 113)
    croak("2nd arg to Math::MPFR::_f128_bytes_fr must be 113");

  if(mpfr_get_prec(*str) != 113)
    croak("Precison of 1st arg supplied to _f128_bytes_fr must be 113, not %u", mpfr_get_prec(*str));

  if((size_t)bits != FLT128_MANT_DIG)
    croak("2nd arg (%u) supplied to Math::MPFR::_f128_bytes_fr does not match FLT128_MANT_DIG (%u)", bits, FLT128_MANT_DIG);

  ld = mpfr_get_float128(*str, GMP_RNDN);

  Newx(buff, 4, char);
  if(buff == NULL) croak("Failed to allocate memory in Math::MPFR::_f128_bytes_fr function");

  sp = mark;

#ifdef MPFR_HAVE_BENDIAN /* Big Endian architecture */
  for (i = 0; i < n; i++) {
#else
  for (i = n - 1; i >= 0; i--) {
#endif

    sprintf(buff, "%02x", ((unsigned char*)p)[i]);
    XPUSHs(sv_2mortal(newSVpv(buff, 0)));
  }
  PUTBACK;
  Safefree(buff);
  XSRETURN(n);

#endif

}

int _required_ldbl_mant_dig(void) {
    return REQUIRED_LDBL_MANT_DIG;
}

SV * _GMP_LIMB_BITS(pTHX) {
#ifdef GMP_LIMB_BITS
     return newSVuv(GMP_LIMB_BITS);
#else
     return &PL_sv_undef;
#endif
}

SV * _GMP_NAIL_BITS(pTHX) {
#ifdef GMP_NAIL_BITS
     return newSVuv(GMP_NAIL_BITS);
#else
     return &PL_sv_undef;
#endif
}









#line 6165 "MPFR.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%"UVxf")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 6309 "MPFR.c"

XS_EUPXS(XS_Math__MPFR__has_inttypes); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__has_inttypes)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = _has_inttypes();
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_NNW_val); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_NNW_val)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;
#line 6167 "MPFR.xs"
  RETVAL = NNW_val (aTHX);
#line 6339 "MPFR.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_default_rounding_mode); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_default_rounding_mode)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	round = ST(0)
;
#line 6175 "MPFR.xs"
        I32* temp;
#line 6359 "MPFR.c"
#line 6177 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_set_default_rounding_mode(aTHX_ round);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 6370 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_default_rounding_mode); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_default_rounding_mode)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	unsigned long	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_get_default_rounding_mode();
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_prec_round); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_prec_round)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, prec, round");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	prec = ST(1)
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 6197 "MPFR.xs"
  RETVAL = Rmpfr_prec_round (aTHX_ p, prec, round);
#line 6410 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "p");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
#line 6204 "MPFR.xs"
        I32* temp;
#line 6431 "MPFR.c"
#line 6206 "MPFR.xs"
        temp = PL_markstack_ptr++;
        DESTROY(aTHX_ p);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 6442 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_clear); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_clear)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "p");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
#line 6220 "MPFR.xs"
        I32* temp;
#line 6462 "MPFR.c"
#line 6222 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_clear(aTHX_ p);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 6473 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_clear_mpfr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_clear_mpfr)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "p");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
#line 6236 "MPFR.xs"
        I32* temp;
#line 6493 "MPFR.c"
#line 6238 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_clear_mpfr(p);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 6504 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_clear_ptr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_clear_ptr)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "p");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
#line 6252 "MPFR.xs"
        I32* temp;
#line 6524 "MPFR.c"
#line 6254 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_clear_ptr(aTHX_ p);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 6535 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_clears); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_clears)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "p, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	p = ST(0)
;
#line 6268 "MPFR.xs"
        I32* temp;
#line 6555 "MPFR.c"
#line 6270 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_clears(aTHX_ p);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 6566 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_init); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_init)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 6283 "MPFR.xs"
  RETVAL = Rmpfr_init (aTHX);
#line 6583 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_init2); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_init2)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "prec");
    {
	SV *	prec = ST(0)
;
	SV *	RETVAL;
#line 6291 "MPFR.xs"
  RETVAL = Rmpfr_init2 (aTHX_ prec);
#line 6603 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_init_nobless); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_init_nobless)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 6297 "MPFR.xs"
  RETVAL = Rmpfr_init_nobless (aTHX);
#line 6621 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_init2_nobless); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_init2_nobless)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "prec");
    {
	SV *	prec = ST(0)
;
	SV *	RETVAL;
#line 6305 "MPFR.xs"
  RETVAL = Rmpfr_init2_nobless (aTHX_ prec);
#line 6641 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "q, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpfr_t *            q = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
#line 6313 "MPFR.xs"
        I32* temp;
#line 6664 "MPFR.c"
#line 6315 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_init_set(aTHX_ q, round);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 6675 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_ui); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_ui)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "q, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	q = ST(0)
;
	SV *	round = ST(1)
;
#line 6330 "MPFR.xs"
        I32* temp;
#line 6697 "MPFR.c"
#line 6332 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_init_set_ui(aTHX_ q, round);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 6708 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_si); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_si)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "q, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	q = ST(0)
;
	SV *	round = ST(1)
;
#line 6347 "MPFR.xs"
        I32* temp;
#line 6730 "MPFR.c"
#line 6349 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_init_set_si(aTHX_ q, round);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 6741 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_d); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_d)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "q, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	q = ST(0)
;
	SV *	round = ST(1)
;
#line 6364 "MPFR.xs"
        I32* temp;
#line 6763 "MPFR.c"
#line 6366 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_init_set_d(aTHX_ q, round);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 6774 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_ld); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_ld)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "q, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	q = ST(0)
;
	SV *	round = ST(1)
;
#line 6381 "MPFR.xs"
        I32* temp;
#line 6796 "MPFR.c"
#line 6383 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_init_set_ld(aTHX_ q, round);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 6807 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_f); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_f)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "q, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpf_t *            q = INT2PTR(mpf_t *, SvIV(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
#line 6398 "MPFR.xs"
        I32* temp;
#line 6829 "MPFR.c"
#line 6400 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_init_set_f(aTHX_ q, round);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 6840 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_z); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_z)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "q, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpz_t *            q = INT2PTR(mpz_t *, SvIV(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
#line 6415 "MPFR.xs"
        I32* temp;
#line 6862 "MPFR.c"
#line 6417 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_init_set_z(aTHX_ q, round);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 6873 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_q); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_q)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "q, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpq_t *            q = INT2PTR(mpq_t *, SvIV(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
#line 6432 "MPFR.xs"
        I32* temp;
#line 6895 "MPFR.c"
#line 6434 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_init_set_q(aTHX_ q, round);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 6906 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_str); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_str)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "q, base, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	q = ST(0)
;
	SV *	base = ST(1)
;
	SV *	round = ST(2)
;
#line 6450 "MPFR.xs"
        I32* temp;
#line 6930 "MPFR.c"
#line 6452 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_init_set_str(aTHX_ q, base, round);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 6941 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_nobless); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_nobless)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "q, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpfr_t *            q = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
#line 6467 "MPFR.xs"
        I32* temp;
#line 6963 "MPFR.c"
#line 6469 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_init_set_nobless(aTHX_ q, round);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 6974 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_ui_nobless); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_ui_nobless)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "q, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	q = ST(0)
;
	SV *	round = ST(1)
;
#line 6484 "MPFR.xs"
        I32* temp;
#line 6996 "MPFR.c"
#line 6486 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_init_set_ui_nobless(aTHX_ q, round);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 7007 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_si_nobless); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_si_nobless)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "q, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	q = ST(0)
;
	SV *	round = ST(1)
;
#line 6501 "MPFR.xs"
        I32* temp;
#line 7029 "MPFR.c"
#line 6503 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_init_set_si_nobless(aTHX_ q, round);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 7040 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_d_nobless); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_d_nobless)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "q, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	q = ST(0)
;
	SV *	round = ST(1)
;
#line 6518 "MPFR.xs"
        I32* temp;
#line 7062 "MPFR.c"
#line 6520 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_init_set_d_nobless(aTHX_ q, round);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 7073 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_ld_nobless); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_ld_nobless)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "q, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	q = ST(0)
;
	SV *	round = ST(1)
;
#line 6535 "MPFR.xs"
        I32* temp;
#line 7095 "MPFR.c"
#line 6537 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_init_set_ld_nobless(aTHX_ q, round);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 7106 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_f_nobless); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_f_nobless)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "q, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpf_t *            q = INT2PTR(mpf_t *, SvIV(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
#line 6552 "MPFR.xs"
        I32* temp;
#line 7128 "MPFR.c"
#line 6554 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_init_set_f_nobless(aTHX_ q, round);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 7139 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_z_nobless); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_z_nobless)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "q, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpz_t *            q = INT2PTR(mpz_t *, SvIV(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
#line 6569 "MPFR.xs"
        I32* temp;
#line 7161 "MPFR.c"
#line 6571 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_init_set_z_nobless(aTHX_ q, round);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 7172 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_q_nobless); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_q_nobless)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "q, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpq_t *            q = INT2PTR(mpq_t *, SvIV(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
#line 6586 "MPFR.xs"
        I32* temp;
#line 7194 "MPFR.c"
#line 6588 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_init_set_q_nobless(aTHX_ q, round);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 7205 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_str_nobless); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_str_nobless)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "q, base, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	q = ST(0)
;
	SV *	base = ST(1)
;
	SV *	round = ST(2)
;
#line 6604 "MPFR.xs"
        I32* temp;
#line 7229 "MPFR.c"
#line 6606 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_init_set_str_nobless(aTHX_ q, base, round);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 7240 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_deref2); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_deref2)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "p, base, n_digits, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	base = ST(1)
;
	SV *	n_digits = ST(2)
;
	SV *	round = ST(3)
;
#line 6623 "MPFR.xs"
        I32* temp;
#line 7266 "MPFR.c"
#line 6625 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_deref2(aTHX_ p, base, n_digits, round);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 7277 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_default_prec); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_default_prec)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "prec");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	prec = ST(0)
;
#line 6639 "MPFR.xs"
        I32* temp;
#line 7297 "MPFR.c"
#line 6641 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_set_default_prec(aTHX_ prec);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 7308 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_default_prec); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_default_prec)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 6654 "MPFR.xs"
  RETVAL = Rmpfr_get_default_prec (aTHX);
#line 7325 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_min_prec); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_min_prec)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "x");
    {
	mpfr_t *            x = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	RETVAL;
#line 6662 "MPFR.xs"
  RETVAL = Rmpfr_min_prec (aTHX_ x);
#line 7345 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_prec); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_prec)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "p, prec");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	prec = ST(1)
;
#line 6670 "MPFR.xs"
        I32* temp;
#line 7368 "MPFR.c"
#line 6672 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_set_prec(aTHX_ p, prec);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 7379 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_prec_raw); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_prec_raw)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "p, prec");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	prec = ST(1)
;
#line 6687 "MPFR.xs"
        I32* temp;
#line 7401 "MPFR.c"
#line 6689 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_set_prec_raw(aTHX_ p, prec);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 7412 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_prec); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_prec)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "p");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	RETVAL;
#line 6703 "MPFR.xs"
  RETVAL = Rmpfr_get_prec (aTHX_ p);
#line 7431 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, q, round");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            q = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 6712 "MPFR.xs"
  RETVAL = Rmpfr_set (aTHX_ p, q, round);
#line 7455 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_ui); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_ui)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, q, round");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	q = ST(1)
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 6721 "MPFR.xs"
  RETVAL = Rmpfr_set_ui (aTHX_ p, q, round);
#line 7479 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_si); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_si)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, q, round");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	q = ST(1)
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 6730 "MPFR.xs"
  RETVAL = Rmpfr_set_si (aTHX_ p, q, round);
#line 7503 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_uj); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_uj)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, q, round");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	q = ST(1)
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 6739 "MPFR.xs"
  RETVAL = Rmpfr_set_uj (aTHX_ p, q, round);
#line 7527 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_sj); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_sj)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, q, round");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	q = ST(1)
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 6748 "MPFR.xs"
  RETVAL = Rmpfr_set_sj (aTHX_ p, q, round);
#line 7551 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_NV); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_NV)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, q, round");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	q = ST(1)
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 6757 "MPFR.xs"
  RETVAL = Rmpfr_set_NV (aTHX_ p, q, round);
#line 7575 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_ld); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_ld)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, q, round");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	q = ST(1)
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 6766 "MPFR.xs"
  RETVAL = Rmpfr_set_ld (aTHX_ p, q, round);
#line 7599 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_d); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_d)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, q, round");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	q = ST(1)
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 6775 "MPFR.xs"
  RETVAL = Rmpfr_set_d (aTHX_ p, q, round);
#line 7623 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_z); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_z)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, q, round");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpz_t *            q = INT2PTR(mpz_t *, SvIV(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 6784 "MPFR.xs"
  RETVAL = Rmpfr_set_z (aTHX_ p, q, round);
#line 7647 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_q); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_q)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, q, round");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpq_t *            q = INT2PTR(mpq_t *, SvIV(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 6793 "MPFR.xs"
  RETVAL = Rmpfr_set_q (aTHX_ p, q, round);
#line 7671 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_f); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_f)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, q, round");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpf_t *            q = INT2PTR(mpf_t *, SvIV(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 6802 "MPFR.xs"
  RETVAL = Rmpfr_set_f (aTHX_ p, q, round);
#line 7695 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_str); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_str)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "p, num, base, round");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	num = ST(1)
;
	SV *	base = ST(2)
;
	SV *	round = ST(3)
;
	int	RETVAL;
	dXSTARG;
#line 6812 "MPFR.xs"
  RETVAL = Rmpfr_set_str (aTHX_ p, num, base, round);
#line 7722 "MPFR.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_inf); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_inf)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "p, sign");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	int	sign = (int)SvIV(ST(1))
;
#line 6820 "MPFR.xs"
        I32* temp;
#line 7744 "MPFR.c"
#line 6822 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_set_inf(p, sign);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 7755 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_nan); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_nan)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "p");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
#line 6836 "MPFR.xs"
        I32* temp;
#line 7775 "MPFR.c"
#line 6838 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_set_nan(p);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 7786 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_swap); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_swap)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "p, q");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            q = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
#line 6853 "MPFR.xs"
        I32* temp;
#line 7808 "MPFR.c"
#line 6855 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_swap(p, q);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 7819 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_d); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_d)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "p, round");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
	SV *	RETVAL;
#line 6870 "MPFR.xs"
  RETVAL = Rmpfr_get_d (aTHX_ p, round);
#line 7840 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_d_2exp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_d_2exp)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "exp, p, round");
    {
	SV *	exp = ST(0)
;
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 6879 "MPFR.xs"
  RETVAL = Rmpfr_get_d_2exp (aTHX_ exp, p, round);
#line 7864 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_ld_2exp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_ld_2exp)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "exp, p, round");
    {
	SV *	exp = ST(0)
;
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 6888 "MPFR.xs"
  RETVAL = Rmpfr_get_ld_2exp (aTHX_ exp, p, round);
#line 7888 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_ld); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_ld)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "p, round");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
	SV *	RETVAL;
#line 6896 "MPFR.xs"
  RETVAL = Rmpfr_get_ld (aTHX_ p, round);
#line 7910 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_d1); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_d1)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "p");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	double	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_get_d1(p);
	XSprePUSH; PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_z_2exp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_z_2exp)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "z, p");
    {
	mpz_t *            z = INT2PTR(mpz_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	RETVAL;
#line 6908 "MPFR.xs"
  RETVAL = Rmpfr_get_z_2exp (aTHX_ z, p);
#line 7951 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_add); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_add)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIV(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 6918 "MPFR.xs"
  RETVAL = Rmpfr_add (aTHX_ a, b, c, round);
#line 7977 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_add_ui); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_add_ui)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 6928 "MPFR.xs"
  RETVAL = Rmpfr_add_ui (aTHX_ a, b, c, round);
#line 8003 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_add_d); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_add_d)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 6938 "MPFR.xs"
  RETVAL = Rmpfr_add_d (aTHX_ a, b, c, round);
#line 8029 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_add_si); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_add_si)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 6948 "MPFR.xs"
  RETVAL = Rmpfr_add_si (aTHX_ a, b, c, round);
#line 8055 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_add_z); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_add_z)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	mpz_t *            c = INT2PTR(mpz_t *, SvIV(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 6958 "MPFR.xs"
  RETVAL = Rmpfr_add_z (aTHX_ a, b, c, round);
#line 8081 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_add_q); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_add_q)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	mpq_t *            c = INT2PTR(mpq_t *, SvIV(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 6968 "MPFR.xs"
  RETVAL = Rmpfr_add_q (aTHX_ a, b, c, round);
#line 8107 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_sub); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_sub)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIV(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 6978 "MPFR.xs"
  RETVAL = Rmpfr_sub (aTHX_ a, b, c, round);
#line 8133 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_sub_ui); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_sub_ui)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 6988 "MPFR.xs"
  RETVAL = Rmpfr_sub_ui (aTHX_ a, b, c, round);
#line 8159 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_sub_d); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_sub_d)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 6998 "MPFR.xs"
  RETVAL = Rmpfr_sub_d (aTHX_ a, b, c, round);
#line 8185 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_sub_z); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_sub_z)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	mpz_t *            c = INT2PTR(mpz_t *, SvIV(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 7008 "MPFR.xs"
  RETVAL = Rmpfr_sub_z (aTHX_ a, b, c, round);
#line 8211 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_sub_q); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_sub_q)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	mpq_t *            c = INT2PTR(mpq_t *, SvIV(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 7018 "MPFR.xs"
  RETVAL = Rmpfr_sub_q (aTHX_ a, b, c, round);
#line 8237 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_ui_sub); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_ui_sub)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIV(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 7028 "MPFR.xs"
  RETVAL = Rmpfr_ui_sub (aTHX_ a, b, c, round);
#line 8263 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_d_sub); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_d_sub)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIV(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 7038 "MPFR.xs"
  RETVAL = Rmpfr_d_sub (aTHX_ a, b, c, round);
#line 8289 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_mul); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_mul)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIV(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 7048 "MPFR.xs"
  RETVAL = Rmpfr_mul (aTHX_ a, b, c, round);
#line 8315 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_mul_ui); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_mul_ui)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 7058 "MPFR.xs"
  RETVAL = Rmpfr_mul_ui (aTHX_ a, b, c, round);
#line 8341 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_mul_d); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_mul_d)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 7068 "MPFR.xs"
  RETVAL = Rmpfr_mul_d (aTHX_ a, b, c, round);
#line 8367 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_mul_z); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_mul_z)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	mpz_t *            c = INT2PTR(mpz_t *, SvIV(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 7078 "MPFR.xs"
  RETVAL = Rmpfr_mul_z (aTHX_ a, b, c, round);
#line 8393 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_mul_q); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_mul_q)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	mpq_t *            c = INT2PTR(mpq_t *, SvIV(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 7088 "MPFR.xs"
  RETVAL = Rmpfr_mul_q (aTHX_ a, b, c, round);
#line 8419 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_dim); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_dim)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "rop, op1, op2, round");
    {
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            op1 = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	mpfr_t *            op2 = INT2PTR(mpfr_t *, SvIV(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 7098 "MPFR.xs"
  RETVAL = Rmpfr_dim (aTHX_ rop, op1, op2, round);
#line 8445 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_div); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_div)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIV(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 7108 "MPFR.xs"
  RETVAL = Rmpfr_div (aTHX_ a, b, c, round);
#line 8471 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_div_ui); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_div_ui)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 7118 "MPFR.xs"
  RETVAL = Rmpfr_div_ui (aTHX_ a, b, c, round);
#line 8497 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_div_d); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_div_d)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 7128 "MPFR.xs"
  RETVAL = Rmpfr_div_d (aTHX_ a, b, c, round);
#line 8523 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_div_z); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_div_z)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	mpz_t *            c = INT2PTR(mpz_t *, SvIV(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 7138 "MPFR.xs"
  RETVAL = Rmpfr_div_z (aTHX_ a, b, c, round);
#line 8549 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_div_q); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_div_q)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	mpq_t *            c = INT2PTR(mpq_t *, SvIV(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 7148 "MPFR.xs"
  RETVAL = Rmpfr_div_q (aTHX_ a, b, c, round);
#line 8575 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_ui_div); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_ui_div)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIV(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 7158 "MPFR.xs"
  RETVAL = Rmpfr_ui_div (aTHX_ a, b, c, round);
#line 8601 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_d_div); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_d_div)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIV(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 7168 "MPFR.xs"
  RETVAL = Rmpfr_d_div (aTHX_ a, b, c, round);
#line 8627 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_sqrt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_sqrt)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 7177 "MPFR.xs"
  RETVAL = Rmpfr_sqrt (aTHX_ a, b, round);
#line 8651 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_rec_sqrt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_rec_sqrt)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 7186 "MPFR.xs"
  RETVAL = Rmpfr_rec_sqrt (aTHX_ a, b, round);
#line 8675 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_cbrt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_cbrt)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 7195 "MPFR.xs"
  RETVAL = Rmpfr_cbrt (aTHX_ a, b, round);
#line 8699 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_sqrt_ui); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_sqrt_ui)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 7204 "MPFR.xs"
  RETVAL = Rmpfr_sqrt_ui (aTHX_ a, b, round);
#line 8723 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_pow_ui); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_pow_ui)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 7214 "MPFR.xs"
  RETVAL = Rmpfr_pow_ui (aTHX_ a, b, c, round);
#line 8749 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_ui_pow_ui); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_ui_pow_ui)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 7224 "MPFR.xs"
  RETVAL = Rmpfr_ui_pow_ui (aTHX_ a, b, c, round);
#line 8775 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_ui_pow); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_ui_pow)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIV(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 7234 "MPFR.xs"
  RETVAL = Rmpfr_ui_pow (aTHX_ a, b, c, round);
#line 8801 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_pow_si); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_pow_si)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 7244 "MPFR.xs"
  RETVAL = Rmpfr_pow_si (aTHX_ a, b, c, round);
#line 8827 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_pow); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_pow)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIV(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 7254 "MPFR.xs"
  RETVAL = Rmpfr_pow (aTHX_ a, b, c, round);
#line 8853 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_neg); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_neg)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 7263 "MPFR.xs"
  RETVAL = Rmpfr_neg (aTHX_ a, b, round);
#line 8877 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_abs); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_abs)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 7272 "MPFR.xs"
  RETVAL = Rmpfr_abs (aTHX_ a, b, round);
#line 8901 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_mul_2exp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_mul_2exp)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 7282 "MPFR.xs"
  RETVAL = Rmpfr_mul_2exp (aTHX_ a, b, c, round);
#line 8927 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_mul_2ui); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_mul_2ui)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 7292 "MPFR.xs"
  RETVAL = Rmpfr_mul_2ui (aTHX_ a, b, c, round);
#line 8953 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_mul_2si); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_mul_2si)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 7302 "MPFR.xs"
  RETVAL = Rmpfr_mul_2si (aTHX_ a, b, c, round);
#line 8979 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_div_2exp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_div_2exp)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 7312 "MPFR.xs"
  RETVAL = Rmpfr_div_2exp (aTHX_ a, b, c, round);
#line 9005 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_div_2ui); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_div_2ui)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 7322 "MPFR.xs"
  RETVAL = Rmpfr_div_2ui (aTHX_ a, b, c, round);
#line 9031 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_div_2si); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_div_2si)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 7332 "MPFR.xs"
  RETVAL = Rmpfr_div_2si (aTHX_ a, b, c, round);
#line 9057 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_cmp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_cmp)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_cmp(a, b);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_cmpabs); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_cmpabs)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_cmpabs(a, b);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_cmp_ui); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_cmp_ui)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	unsigned long	b = (unsigned long)SvUV(ST(1))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_cmp_ui(a, b);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_cmp_d); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_cmp_d)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	double	b = (double)SvNV(ST(1))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_cmp_d(a, b);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_cmp_ld); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_cmp_ld)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	int	RETVAL;
	dXSTARG;
#line 7360 "MPFR.xs"
  RETVAL = Rmpfr_cmp_ld (aTHX_ a, b);
#line 9164 "MPFR.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_cmp_si); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_cmp_si)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	long	b = (long)SvIV(ST(1))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_cmp_si(a, b);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_cmp_ui_2exp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_cmp_ui_2exp)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, c");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	c = ST(2)
;
	int	RETVAL;
	dXSTARG;
#line 7374 "MPFR.xs"
  RETVAL = Rmpfr_cmp_ui_2exp (aTHX_ a, b, c);
#line 9209 "MPFR.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_cmp_si_2exp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_cmp_si_2exp)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, c");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	c = ST(2)
;
	int	RETVAL;
	dXSTARG;
#line 7383 "MPFR.xs"
  RETVAL = Rmpfr_cmp_si_2exp (aTHX_ a, b, c);
#line 9233 "MPFR.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_eq); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_eq)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, c");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	unsigned long	c = (unsigned long)SvUV(ST(2))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_eq(a, b, c);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_nan_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_nan_p)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "p");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_nan_p(p);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_inf_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_inf_p)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "p");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_inf_p(p);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_number_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_number_p)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "p");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_number_p(p);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_reldiff); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_reldiff)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIV(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
#line 7411 "MPFR.xs"
        I32* temp;
#line 9339 "MPFR.c"
#line 7413 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_reldiff(aTHX_ a, b, c, round);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 9350 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_sgn); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_sgn)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "p");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_sgn(p);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_greater_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_greater_p)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_greater_p(a, b);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_greaterequal_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_greaterequal_p)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_greaterequal_p(a, b);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_less_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_less_p)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_less_p(a, b);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_lessequal_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_lessequal_p)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_lessequal_p(a, b);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_lessgreater_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_lessgreater_p)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_lessgreater_p(a, b);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_equal_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_equal_p)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_equal_p(a, b);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_unordered_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_unordered_p)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_unordered_p(a, b);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_sin_cos); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_sin_cos)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIV(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 7469 "MPFR.xs"
  RETVAL = Rmpfr_sin_cos (aTHX_ a, b, c, round);
#line 9541 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_sinh_cosh); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_sinh_cosh)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIV(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 7479 "MPFR.xs"
  RETVAL = Rmpfr_sinh_cosh (aTHX_ a, b, c, round);
#line 9567 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_sin); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_sin)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 7488 "MPFR.xs"
  RETVAL = Rmpfr_sin (aTHX_ a, b, round);
#line 9591 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_cos); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_cos)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 7497 "MPFR.xs"
  RETVAL = Rmpfr_cos (aTHX_ a, b, round);
#line 9615 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_tan); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_tan)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 7506 "MPFR.xs"
  RETVAL = Rmpfr_tan (aTHX_ a, b, round);
#line 9639 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_asin); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_asin)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 7515 "MPFR.xs"
  RETVAL = Rmpfr_asin (aTHX_ a, b, round);
#line 9663 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_acos); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_acos)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 7524 "MPFR.xs"
  RETVAL = Rmpfr_acos (aTHX_ a, b, round);
#line 9687 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_atan); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_atan)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 7533 "MPFR.xs"
  RETVAL = Rmpfr_atan (aTHX_ a, b, round);
#line 9711 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_sinh); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_sinh)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 7542 "MPFR.xs"
  RETVAL = Rmpfr_sinh (aTHX_ a, b, round);
#line 9735 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_cosh); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_cosh)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 7551 "MPFR.xs"
  RETVAL = Rmpfr_cosh (aTHX_ a, b, round);
#line 9759 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_tanh); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_tanh)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 7560 "MPFR.xs"
  RETVAL = Rmpfr_tanh (aTHX_ a, b, round);
#line 9783 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_asinh); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_asinh)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 7569 "MPFR.xs"
  RETVAL = Rmpfr_asinh (aTHX_ a, b, round);
#line 9807 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_acosh); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_acosh)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 7578 "MPFR.xs"
  RETVAL = Rmpfr_acosh (aTHX_ a, b, round);
#line 9831 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_atanh); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_atanh)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 7587 "MPFR.xs"
  RETVAL = Rmpfr_atanh (aTHX_ a, b, round);
#line 9855 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_fac_ui); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_fac_ui)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 7596 "MPFR.xs"
  RETVAL = Rmpfr_fac_ui (aTHX_ a, b, round);
#line 9879 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_log1p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_log1p)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 7605 "MPFR.xs"
  RETVAL = Rmpfr_log1p (aTHX_ a, b, round);
#line 9903 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_expm1); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_expm1)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 7614 "MPFR.xs"
  RETVAL = Rmpfr_expm1 (aTHX_ a, b, round);
#line 9927 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_log2); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_log2)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 7623 "MPFR.xs"
  RETVAL = Rmpfr_log2 (aTHX_ a, b, round);
#line 9951 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_log10); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_log10)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 7632 "MPFR.xs"
  RETVAL = Rmpfr_log10 (aTHX_ a, b, round);
#line 9975 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_fma); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_fma)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "a, b, c, d, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIV(SvRV(ST(2))))
;
	mpfr_t *            d = INT2PTR(mpfr_t *, SvIV(SvRV(ST(3))))
;
	SV *	round = ST(4)
;
	SV *	RETVAL;
#line 7643 "MPFR.xs"
  RETVAL = Rmpfr_fma (aTHX_ a, b, c, d, round);
#line 10003 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_fms); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_fms)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "a, b, c, d, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIV(SvRV(ST(2))))
;
	mpfr_t *            d = INT2PTR(mpfr_t *, SvIV(SvRV(ST(3))))
;
	SV *	round = ST(4)
;
	SV *	RETVAL;
#line 7654 "MPFR.xs"
  RETVAL = Rmpfr_fms (aTHX_ a, b, c, d, round);
#line 10031 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_agm); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_agm)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIV(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 7664 "MPFR.xs"
  RETVAL = Rmpfr_agm (aTHX_ a, b, c, round);
#line 10057 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_hypot); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_hypot)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIV(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 7674 "MPFR.xs"
  RETVAL = Rmpfr_hypot (aTHX_ a, b, c, round);
#line 10083 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_const_log2); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_const_log2)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "p, round");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
	SV *	RETVAL;
#line 7682 "MPFR.xs"
  RETVAL = Rmpfr_const_log2 (aTHX_ p, round);
#line 10105 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_const_pi); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_const_pi)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "p, round");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
	SV *	RETVAL;
#line 7690 "MPFR.xs"
  RETVAL = Rmpfr_const_pi (aTHX_ p, round);
#line 10127 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_const_euler); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_const_euler)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "p, round");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
	SV *	RETVAL;
#line 7698 "MPFR.xs"
  RETVAL = Rmpfr_const_euler (aTHX_ p, round);
#line 10149 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_rint); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_rint)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 7707 "MPFR.xs"
  RETVAL = Rmpfr_rint (aTHX_ a, b, round);
#line 10173 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_ceil); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_ceil)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_ceil(a, b);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_floor); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_floor)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_floor(a, b);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_round); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_round)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_round(a, b);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_trunc); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_trunc)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_trunc(a, b);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_can_round); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_can_round)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "p, err, round1, round2, prec");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	err = ST(1)
;
	SV *	round1 = ST(2)
;
	SV *	round2 = ST(3)
;
	SV *	prec = ST(4)
;
	SV *	RETVAL;
#line 7738 "MPFR.xs"
  RETVAL = Rmpfr_can_round (aTHX_ p, err, round1, round2, prec);
#line 10285 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_print_rnd_mode); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_print_rnd_mode)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "rnd");
    {
	SV *	rnd = ST(0)
;
	SV *	RETVAL;
#line 7745 "MPFR.xs"
  RETVAL = Rmpfr_print_rnd_mode (aTHX_ rnd);
#line 10305 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_emin); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_emin)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 7751 "MPFR.xs"
  RETVAL = Rmpfr_get_emin (aTHX);
#line 10323 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_emax); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_emax)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 7758 "MPFR.xs"
  RETVAL = Rmpfr_get_emax (aTHX);
#line 10341 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_emin); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_emin)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "e");
    {
	SV *	e = ST(0)
;
	int	RETVAL;
	dXSTARG;
#line 7766 "MPFR.xs"
  RETVAL = Rmpfr_set_emin (aTHX_ e);
#line 10362 "MPFR.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_emax); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_emax)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "e");
    {
	SV *	e = ST(0)
;
	int	RETVAL;
	dXSTARG;
#line 7773 "MPFR.xs"
  RETVAL = Rmpfr_set_emax (aTHX_ e);
#line 10382 "MPFR.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_check_range); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_check_range)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, t, round");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	t = ST(1)
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 7782 "MPFR.xs"
  RETVAL = Rmpfr_check_range (aTHX_ p, t, round);
#line 10405 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_clear_underflow); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_clear_underflow)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 7789 "MPFR.xs"
        I32* temp;
#line 10424 "MPFR.c"
#line 7791 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_clear_underflow();
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 10435 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_clear_overflow); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_clear_overflow)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 7805 "MPFR.xs"
        I32* temp;
#line 10453 "MPFR.c"
#line 7807 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_clear_overflow();
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 10464 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_clear_nanflag); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_clear_nanflag)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 7821 "MPFR.xs"
        I32* temp;
#line 10482 "MPFR.c"
#line 7823 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_clear_nanflag();
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 10493 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_clear_inexflag); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_clear_inexflag)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 7837 "MPFR.xs"
        I32* temp;
#line 10511 "MPFR.c"
#line 7839 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_clear_inexflag();
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 10522 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_clear_flags); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_clear_flags)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 7853 "MPFR.xs"
        I32* temp;
#line 10540 "MPFR.c"
#line 7855 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_clear_flags();
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 10551 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_underflow_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_underflow_p)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_underflow_p();
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_overflow_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_overflow_p)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_overflow_p();
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_nanflag_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_nanflag_p)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_nanflag_p();
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_inexflag_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_inexflag_p)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_inexflag_p();
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_log); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_log)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 7887 "MPFR.xs"
  RETVAL = Rmpfr_log (aTHX_ a, b, round);
#line 10642 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_exp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_exp)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 7896 "MPFR.xs"
  RETVAL = Rmpfr_exp (aTHX_ a, b, round);
#line 10666 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_exp2); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_exp2)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 7905 "MPFR.xs"
  RETVAL = Rmpfr_exp2 (aTHX_ a, b, round);
#line 10690 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_exp10); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_exp10)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 7914 "MPFR.xs"
  RETVAL = Rmpfr_exp10 (aTHX_ a, b, round);
#line 10714 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_urandomb); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_urandomb)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "x, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	x = ST(0)
;
#line 7921 "MPFR.xs"
        I32* temp;
#line 10735 "MPFR.c"
#line 7923 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_urandomb(aTHX_ x);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 10746 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_random2); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_random2)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, s, exp");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	s = ST(1)
;
	SV *	exp = ST(2)
;
#line 7939 "MPFR.xs"
        I32* temp;
#line 10770 "MPFR.c"
#line 7941 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_random2(aTHX_ p, s, exp);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 10781 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR__TRmpfr_out_str); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__TRmpfr_out_str)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "stream, base, dig, p, round");
    {
	FILE *	stream = PerlIO_findFILE(IoIFP(sv_2io(ST(0))))
;
	SV *	base = ST(1)
;
	SV *	dig = ST(2)
;
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIV(SvRV(ST(3))))
;
	SV *	round = ST(4)
;
	SV *	RETVAL;
#line 7959 "MPFR.xs"
  RETVAL = _TRmpfr_out_str (aTHX_ stream, base, dig, p, round);
#line 10808 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__Rmpfr_out_str); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__Rmpfr_out_str)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "p, base, dig, round");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	base = ST(1)
;
	SV *	dig = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 7969 "MPFR.xs"
  RETVAL = _Rmpfr_out_str (aTHX_ p, base, dig, round);
#line 10834 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__TRmpfr_out_strS); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__TRmpfr_out_strS)
{
    dVAR; dXSARGS;
    if (items != 6)
       croak_xs_usage(cv,  "stream, base, dig, p, round, suff");
    {
	FILE *	stream = PerlIO_findFILE(IoIFP(sv_2io(ST(0))))
;
	SV *	base = ST(1)
;
	SV *	dig = ST(2)
;
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIV(SvRV(ST(3))))
;
	SV *	round = ST(4)
;
	SV *	suff = ST(5)
;
	SV *	RETVAL;
#line 7981 "MPFR.xs"
  RETVAL = _TRmpfr_out_strS (aTHX_ stream, base, dig, p, round, suff);
#line 10864 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__TRmpfr_out_strP); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__TRmpfr_out_strP)
{
    dVAR; dXSARGS;
    if (items != 6)
       croak_xs_usage(cv,  "pre, stream, base, dig, p, round");
    {
	SV *	pre = ST(0)
;
	FILE *	stream = PerlIO_findFILE(IoIFP(sv_2io(ST(1))))
;
	SV *	base = ST(2)
;
	SV *	dig = ST(3)
;
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIV(SvRV(ST(4))))
;
	SV *	round = ST(5)
;
	SV *	RETVAL;
#line 7993 "MPFR.xs"
  RETVAL = _TRmpfr_out_strP (aTHX_ pre, stream, base, dig, p, round);
#line 10894 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__TRmpfr_out_strPS); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__TRmpfr_out_strPS)
{
    dVAR; dXSARGS;
    if (items != 7)
       croak_xs_usage(cv,  "pre, stream, base, dig, p, round, suff");
    {
	SV *	pre = ST(0)
;
	FILE *	stream = PerlIO_findFILE(IoIFP(sv_2io(ST(1))))
;
	SV *	base = ST(2)
;
	SV *	dig = ST(3)
;
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIV(SvRV(ST(4))))
;
	SV *	round = ST(5)
;
	SV *	suff = ST(6)
;
	SV *	RETVAL;
#line 8006 "MPFR.xs"
  RETVAL = _TRmpfr_out_strPS (aTHX_ pre, stream, base, dig, p, round, suff);
#line 10926 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__Rmpfr_out_strS); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__Rmpfr_out_strS)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "p, base, dig, round, suff");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	base = ST(1)
;
	SV *	dig = ST(2)
;
	SV *	round = ST(3)
;
	SV *	suff = ST(4)
;
	SV *	RETVAL;
#line 8017 "MPFR.xs"
  RETVAL = _Rmpfr_out_strS (aTHX_ p, base, dig, round, suff);
#line 10954 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__Rmpfr_out_strP); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__Rmpfr_out_strP)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "pre, p, base, dig, round");
    {
	SV *	pre = ST(0)
;
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	base = ST(2)
;
	SV *	dig = ST(3)
;
	SV *	round = ST(4)
;
	SV *	RETVAL;
#line 8028 "MPFR.xs"
  RETVAL = _Rmpfr_out_strP (aTHX_ pre, p, base, dig, round);
#line 10982 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__Rmpfr_out_strPS); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__Rmpfr_out_strPS)
{
    dVAR; dXSARGS;
    if (items != 6)
       croak_xs_usage(cv,  "pre, p, base, dig, round, suff");
    {
	SV *	pre = ST(0)
;
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	base = ST(2)
;
	SV *	dig = ST(3)
;
	SV *	round = ST(4)
;
	SV *	suff = ST(5)
;
	SV *	RETVAL;
#line 8040 "MPFR.xs"
  RETVAL = _Rmpfr_out_strPS (aTHX_ pre, p, base, dig, round, suff);
#line 11012 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_TRmpfr_inp_str); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_TRmpfr_inp_str)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "p, stream, base, round");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	FILE *	stream = PerlIO_findFILE(IoIFP(sv_2io(ST(1))))
;
	SV *	base = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 8050 "MPFR.xs"
  RETVAL = TRmpfr_inp_str (aTHX_ p, stream, base, round);
#line 11038 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_inp_str); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_inp_str)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, base, round");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	base = ST(1)
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 8059 "MPFR.xs"
  RETVAL = Rmpfr_inp_str (aTHX_ p, base, round);
#line 11062 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_gamma); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_gamma)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 8068 "MPFR.xs"
  RETVAL = Rmpfr_gamma (aTHX_ a, b, round);
#line 11086 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_zeta); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_zeta)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 8077 "MPFR.xs"
  RETVAL = Rmpfr_zeta (aTHX_ a, b, round);
#line 11110 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_zeta_ui); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_zeta_ui)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 8086 "MPFR.xs"
  RETVAL = Rmpfr_zeta_ui (aTHX_ a, b, round);
#line 11134 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_erf); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_erf)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 8095 "MPFR.xs"
  RETVAL = Rmpfr_erf (aTHX_ a, b, round);
#line 11158 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_frac); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_frac)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 8104 "MPFR.xs"
  RETVAL = Rmpfr_frac (aTHX_ a, b, round);
#line 11182 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_remainder); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_remainder)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIV(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 8114 "MPFR.xs"
  RETVAL = Rmpfr_remainder (aTHX_ a, b, c, round);
#line 11208 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_modf); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_modf)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIV(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 8124 "MPFR.xs"
  RETVAL = Rmpfr_modf (aTHX_ a, b, c, round);
#line 11234 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_fmod); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_fmod)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIV(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 8134 "MPFR.xs"
  RETVAL = Rmpfr_fmod (aTHX_ a, b, c, round);
#line 11260 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_remquo); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_remquo)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIV(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
#line 8144 "MPFR.xs"
        I32* temp;
#line 11287 "MPFR.c"
#line 8146 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_remquo(aTHX_ a, b, c, round);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 11298 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_integer_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_integer_p)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "p");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_integer_p(p);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_nexttoward); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_nexttoward)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
#line 8165 "MPFR.xs"
        I32* temp;
#line 11339 "MPFR.c"
#line 8167 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_nexttoward(a, b);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 11350 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_nextabove); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_nextabove)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "p");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
#line 8181 "MPFR.xs"
        I32* temp;
#line 11370 "MPFR.c"
#line 8183 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_nextabove(p);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 11381 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_nextbelow); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_nextbelow)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "p");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
#line 8197 "MPFR.xs"
        I32* temp;
#line 11401 "MPFR.c"
#line 8199 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_nextbelow(p);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 11412 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_min); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_min)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIV(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 8216 "MPFR.xs"
  RETVAL = Rmpfr_min (aTHX_ a, b, c, round);
#line 11437 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_max); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_max)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIV(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 8226 "MPFR.xs"
  RETVAL = Rmpfr_max (aTHX_ a, b, c, round);
#line 11463 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_exp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_exp)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "p");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	RETVAL;
#line 8233 "MPFR.xs"
  RETVAL = Rmpfr_get_exp (aTHX_ p);
#line 11483 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_exp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_exp)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "p, exp");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	exp = ST(1)
;
	SV *	RETVAL;
#line 8241 "MPFR.xs"
  RETVAL = Rmpfr_set_exp (aTHX_ p, exp);
#line 11505 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_signbit); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_signbit)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "op");
    {
	mpfr_t *            op = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_signbit(op);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_setsign); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_setsign)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "rop, op, sign, round");
    {
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            op = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	sign = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 8255 "MPFR.xs"
  RETVAL = Rmpfr_setsign (aTHX_ rop, op, sign, round);
#line 11550 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_copysign); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_copysign)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "rop, op1, op2, round");
    {
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            op1 = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	mpfr_t *            op2 = INT2PTR(mpfr_t *, SvIV(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 8265 "MPFR.xs"
  RETVAL = Rmpfr_copysign (aTHX_ rop, op1, op2, round);
#line 11576 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_get_refcnt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_get_refcnt)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "s");
    {
	SV *	s = ST(0)
;
	SV *	RETVAL;
#line 8272 "MPFR.xs"
  RETVAL = get_refcnt (aTHX_ s);
#line 11596 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_get_package_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_get_package_name)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "x");
    {
	SV *	x = ST(0)
;
	SV *	RETVAL;
#line 8279 "MPFR.xs"
  RETVAL = get_package_name (aTHX_ x);
#line 11616 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_dump); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_dump)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "a");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
#line 8286 "MPFR.xs"
        I32* temp;
#line 11637 "MPFR.c"
#line 8288 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_dump(a);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 11648 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_gmp_v); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_gmp_v)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 8301 "MPFR.xs"
  RETVAL = gmp_v (aTHX);
#line 11665 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_ui_2exp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_ui_2exp)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 8312 "MPFR.xs"
  RETVAL = Rmpfr_set_ui_2exp (aTHX_ a, b, c, round);
#line 11691 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_si_2exp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_si_2exp)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 8322 "MPFR.xs"
  RETVAL = Rmpfr_set_si_2exp (aTHX_ a, b, c, round);
#line 11717 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_uj_2exp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_uj_2exp)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 8332 "MPFR.xs"
  RETVAL = Rmpfr_set_uj_2exp (aTHX_ a, b, c, round);
#line 11743 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_sj_2exp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_sj_2exp)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 8342 "MPFR.xs"
  RETVAL = Rmpfr_set_sj_2exp (aTHX_ a, b, c, round);
#line 11769 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_z); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_z)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpz_t *            a = INT2PTR(mpz_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 8351 "MPFR.xs"
  RETVAL = Rmpfr_get_z (aTHX_ a, b, round);
#line 11793 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_si_sub); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_si_sub)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIV(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 8361 "MPFR.xs"
  RETVAL = Rmpfr_si_sub (aTHX_ a, b, c, round);
#line 11819 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_sub_si); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_sub_si)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 8371 "MPFR.xs"
  RETVAL = Rmpfr_sub_si (aTHX_ a, b, c, round);
#line 11845 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_mul_si); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_mul_si)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 8381 "MPFR.xs"
  RETVAL = Rmpfr_mul_si (aTHX_ a, b, c, round);
#line 11871 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_si_div); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_si_div)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIV(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 8391 "MPFR.xs"
  RETVAL = Rmpfr_si_div (aTHX_ a, b, c, round);
#line 11897 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_div_si); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_div_si)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 8401 "MPFR.xs"
  RETVAL = Rmpfr_div_si (aTHX_ a, b, c, round);
#line 11923 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_sqr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_sqr)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 8410 "MPFR.xs"
  RETVAL = Rmpfr_sqr (aTHX_ a, b, round);
#line 11947 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_cmp_z); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_cmp_z)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpz_t *            b = INT2PTR(mpz_t *, SvIV(SvRV(ST(1))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_cmp_z(a, b);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_cmp_q); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_cmp_q)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpq_t *            b = INT2PTR(mpq_t *, SvIV(SvRV(ST(1))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_cmp_q(a, b);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_cmp_f); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_cmp_f)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpf_t *            b = INT2PTR(mpf_t *, SvIV(SvRV(ST(1))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_cmp_f(a, b);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_zero_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_zero_p)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "a");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_zero_p(a);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_free_cache); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_free_cache)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 8436 "MPFR.xs"
        I32* temp;
#line 12048 "MPFR.c"
#line 8438 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_free_cache();
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 12059 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_version); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_version)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 8451 "MPFR.xs"
  RETVAL = Rmpfr_get_version (aTHX);
#line 12076 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_patches); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_patches)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 8458 "MPFR.xs"
  RETVAL = Rmpfr_get_patches (aTHX);
#line 12094 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_emin_min); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_emin_min)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 8465 "MPFR.xs"
  RETVAL = Rmpfr_get_emin_min (aTHX);
#line 12112 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_emin_max); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_emin_max)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 8472 "MPFR.xs"
  RETVAL = Rmpfr_get_emin_max (aTHX);
#line 12130 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_emax_min); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_emax_min)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 8479 "MPFR.xs"
  RETVAL = Rmpfr_get_emax_min (aTHX);
#line 12148 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_emax_max); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_emax_max)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 8486 "MPFR.xs"
  RETVAL = Rmpfr_get_emax_max (aTHX);
#line 12166 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_clear_erangeflag); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_clear_erangeflag)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 8494 "MPFR.xs"
        I32* temp;
#line 12185 "MPFR.c"
#line 8496 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_clear_erangeflag();
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 12196 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_erangeflag_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_erangeflag_p)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_erangeflag_p();
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_rint_round); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_rint_round)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 8516 "MPFR.xs"
  RETVAL = Rmpfr_rint_round (aTHX_ a, b, round);
#line 12236 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_rint_trunc); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_rint_trunc)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 8525 "MPFR.xs"
  RETVAL = Rmpfr_rint_trunc (aTHX_ a, b, round);
#line 12260 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_rint_ceil); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_rint_ceil)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 8534 "MPFR.xs"
  RETVAL = Rmpfr_rint_ceil (aTHX_ a, b, round);
#line 12284 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_rint_floor); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_rint_floor)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 8543 "MPFR.xs"
  RETVAL = Rmpfr_rint_floor (aTHX_ a, b, round);
#line 12308 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_ui); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_ui)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
	SV *	RETVAL;
#line 8551 "MPFR.xs"
  RETVAL = Rmpfr_get_ui (aTHX_ a, round);
#line 12330 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_si); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_si)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
	SV *	RETVAL;
#line 8559 "MPFR.xs"
  RETVAL = Rmpfr_get_si (aTHX_ a, round);
#line 12352 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_uj); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_uj)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
	SV *	RETVAL;
#line 8567 "MPFR.xs"
  RETVAL = Rmpfr_get_uj (aTHX_ a, round);
#line 12374 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_sj); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_sj)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
	SV *	RETVAL;
#line 8575 "MPFR.xs"
  RETVAL = Rmpfr_get_sj (aTHX_ a, round);
#line 12396 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_IV); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_IV)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "x, round");
    {
	mpfr_t *            x = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
	SV *	RETVAL;
#line 8583 "MPFR.xs"
  RETVAL = Rmpfr_get_IV (aTHX_ x, round);
#line 12418 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_UV); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_UV)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "x, round");
    {
	mpfr_t *            x = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
	SV *	RETVAL;
#line 8591 "MPFR.xs"
  RETVAL = Rmpfr_get_UV (aTHX_ x, round);
#line 12440 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_NV); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_NV)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "x, round");
    {
	mpfr_t *            x = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
	SV *	RETVAL;
#line 8599 "MPFR.xs"
  RETVAL = Rmpfr_get_NV (aTHX_ x, round);
#line 12462 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_fits_ulong_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_fits_ulong_p)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
	SV *	RETVAL;
#line 8607 "MPFR.xs"
  RETVAL = Rmpfr_fits_ulong_p (aTHX_ a, round);
#line 12484 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_fits_slong_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_fits_slong_p)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
	SV *	RETVAL;
#line 8615 "MPFR.xs"
  RETVAL = Rmpfr_fits_slong_p (aTHX_ a, round);
#line 12506 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_fits_ushort_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_fits_ushort_p)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
	SV *	RETVAL;
#line 8623 "MPFR.xs"
  RETVAL = Rmpfr_fits_ushort_p (aTHX_ a, round);
#line 12528 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_fits_sshort_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_fits_sshort_p)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
	SV *	RETVAL;
#line 8631 "MPFR.xs"
  RETVAL = Rmpfr_fits_sshort_p (aTHX_ a, round);
#line 12550 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_fits_uint_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_fits_uint_p)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
	SV *	RETVAL;
#line 8639 "MPFR.xs"
  RETVAL = Rmpfr_fits_uint_p (aTHX_ a, round);
#line 12572 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_fits_sint_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_fits_sint_p)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
	SV *	RETVAL;
#line 8647 "MPFR.xs"
  RETVAL = Rmpfr_fits_sint_p (aTHX_ a, round);
#line 12594 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_fits_uintmax_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_fits_uintmax_p)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
	SV *	RETVAL;
#line 8655 "MPFR.xs"
  RETVAL = Rmpfr_fits_uintmax_p (aTHX_ a, round);
#line 12616 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_fits_intmax_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_fits_intmax_p)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
	SV *	RETVAL;
#line 8663 "MPFR.xs"
  RETVAL = Rmpfr_fits_intmax_p (aTHX_ a, round);
#line 12638 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_fits_IV_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_fits_IV_p)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "x, round");
    {
	mpfr_t *            x = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
	SV *	RETVAL;
#line 8671 "MPFR.xs"
  RETVAL = Rmpfr_fits_IV_p (aTHX_ x, round);
#line 12660 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_fits_UV_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_fits_UV_p)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "x, round");
    {
	mpfr_t *            x = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
	SV *	RETVAL;
#line 8679 "MPFR.xs"
  RETVAL = Rmpfr_fits_UV_p (aTHX_ x, round);
#line 12682 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_strtofr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_strtofr)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, str, base, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	str = ST(1)
;
	SV *	base = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 8689 "MPFR.xs"
  RETVAL = Rmpfr_strtofr (aTHX_ a, str, base, round);
#line 12708 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_erangeflag); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_erangeflag)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 8696 "MPFR.xs"
        I32* temp;
#line 12727 "MPFR.c"
#line 8698 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_set_erangeflag();
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 12738 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_underflow); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_underflow)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 8712 "MPFR.xs"
        I32* temp;
#line 12756 "MPFR.c"
#line 8714 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_set_underflow();
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 12767 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_overflow); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_overflow)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 8728 "MPFR.xs"
        I32* temp;
#line 12785 "MPFR.c"
#line 8730 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_set_overflow();
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 12796 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_nanflag); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_nanflag)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 8744 "MPFR.xs"
        I32* temp;
#line 12814 "MPFR.c"
#line 8746 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_set_nanflag();
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 12825 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_inexflag); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_inexflag)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 8760 "MPFR.xs"
        I32* temp;
#line 12843 "MPFR.c"
#line 8762 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_set_inexflag();
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 12854 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_erfc); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_erfc)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 8778 "MPFR.xs"
  RETVAL = Rmpfr_erfc (aTHX_ a, b, round);
#line 12877 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_j0); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_j0)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 8787 "MPFR.xs"
  RETVAL = Rmpfr_j0 (aTHX_ a, b, round);
#line 12901 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_j1); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_j1)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 8796 "MPFR.xs"
  RETVAL = Rmpfr_j1 (aTHX_ a, b, round);
#line 12925 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_jn); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_jn)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, n, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	n = ST(1)
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 8806 "MPFR.xs"
  RETVAL = Rmpfr_jn (aTHX_ a, n, b, round);
#line 12951 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_y0); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_y0)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 8815 "MPFR.xs"
  RETVAL = Rmpfr_y0 (aTHX_ a, b, round);
#line 12975 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_y1); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_y1)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 8824 "MPFR.xs"
  RETVAL = Rmpfr_y1 (aTHX_ a, b, round);
#line 12999 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_yn); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_yn)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, n, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	n = ST(1)
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 8834 "MPFR.xs"
  RETVAL = Rmpfr_yn (aTHX_ a, n, b, round);
#line 13025 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_atan2); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_atan2)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIV(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 8844 "MPFR.xs"
  RETVAL = Rmpfr_atan2 (aTHX_ a, b, c, round);
#line 13051 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_pow_z); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_pow_z)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	mpz_t *            c = INT2PTR(mpz_t *, SvIV(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 8854 "MPFR.xs"
  RETVAL = Rmpfr_pow_z (aTHX_ a, b, c, round);
#line 13077 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_subnormalize); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_subnormalize)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 8863 "MPFR.xs"
  RETVAL = Rmpfr_subnormalize (aTHX_ a, b, round);
#line 13101 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_const_catalan); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_const_catalan)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
	SV *	RETVAL;
#line 8871 "MPFR.xs"
  RETVAL = Rmpfr_const_catalan (aTHX_ a, round);
#line 13123 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_sec); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_sec)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 8880 "MPFR.xs"
  RETVAL = Rmpfr_sec (aTHX_ a, b, round);
#line 13147 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_csc); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_csc)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 8889 "MPFR.xs"
  RETVAL = Rmpfr_csc (aTHX_ a, b, round);
#line 13171 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_cot); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_cot)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 8898 "MPFR.xs"
  RETVAL = Rmpfr_cot (aTHX_ a, b, round);
#line 13195 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_root); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_root)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 8908 "MPFR.xs"
  RETVAL = Rmpfr_root (aTHX_ a, b, c, round);
#line 13221 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_eint); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_eint)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 8917 "MPFR.xs"
  RETVAL = Rmpfr_eint (aTHX_ a, b, round);
#line 13245 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_li2); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_li2)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 8926 "MPFR.xs"
  RETVAL = Rmpfr_li2 (aTHX_ a, b, round);
#line 13269 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_f); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_f)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpf_t *            a = INT2PTR(mpf_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 8935 "MPFR.xs"
  RETVAL = Rmpfr_get_f (aTHX_ a, b, round);
#line 13293 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_q); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_q)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpq_t *            a = INT2PTR(mpq_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
#line 8943 "MPFR.xs"
        I32* temp;
#line 13316 "MPFR.c"
#line 8945 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_get_q(a, b);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 13327 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_sech); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_sech)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 8961 "MPFR.xs"
  RETVAL = Rmpfr_sech (aTHX_ a, b, round);
#line 13350 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_csch); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_csch)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 8970 "MPFR.xs"
  RETVAL = Rmpfr_csch (aTHX_ a, b, round);
#line 13374 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_coth); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_coth)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 8979 "MPFR.xs"
  RETVAL = Rmpfr_coth (aTHX_ a, b, round);
#line 13398 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_lngamma); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_lngamma)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 8988 "MPFR.xs"
  RETVAL = Rmpfr_lngamma (aTHX_ a, b, round);
#line 13422 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_lgamma); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_lgamma)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
#line 8997 "MPFR.xs"
        I32* temp;
#line 13447 "MPFR.c"
#line 8999 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_lgamma(aTHX_ a, b, round);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 13458 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR__MPFR_VERSION); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__MPFR_VERSION)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 9012 "MPFR.xs"
  RETVAL = _MPFR_VERSION (aTHX);
#line 13475 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__MPFR_VERSION_MAJOR); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__MPFR_VERSION_MAJOR)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 9019 "MPFR.xs"
  RETVAL = _MPFR_VERSION_MAJOR (aTHX);
#line 13493 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__MPFR_VERSION_MINOR); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__MPFR_VERSION_MINOR)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 9026 "MPFR.xs"
  RETVAL = _MPFR_VERSION_MINOR (aTHX);
#line 13511 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__MPFR_VERSION_PATCHLEVEL); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__MPFR_VERSION_PATCHLEVEL)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 9033 "MPFR.xs"
  RETVAL = _MPFR_VERSION_PATCHLEVEL (aTHX);
#line 13529 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__MPFR_VERSION_STRING); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__MPFR_VERSION_STRING)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 9040 "MPFR.xs"
  RETVAL = _MPFR_VERSION_STRING (aTHX);
#line 13547 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_RMPFR_VERSION_NUM); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_RMPFR_VERSION_NUM)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, c");
    {
	SV *	a = ST(0)
;
	SV *	b = ST(1)
;
	SV *	c = ST(2)
;
	SV *	RETVAL;
#line 9050 "MPFR.xs"
  RETVAL = RMPFR_VERSION_NUM (aTHX_ a, b, c);
#line 13571 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_sum); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_sum)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "rop, avref, len, round");
    {
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	avref = ST(1)
;
	SV *	len = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 9060 "MPFR.xs"
  RETVAL = Rmpfr_sum (aTHX_ rop, avref, len, round);
#line 13597 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_mul); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_mul)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	SV *	a = ST(0)
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 9069 "MPFR.xs"
  RETVAL = overload_mul (aTHX_ a, b, third);
#line 13621 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_add); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_add)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	SV *	a = ST(0)
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 9078 "MPFR.xs"
  RETVAL = overload_add (aTHX_ a, b, third);
#line 13645 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_sub); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_sub)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	SV *	a = ST(0)
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 9087 "MPFR.xs"
  RETVAL = overload_sub (aTHX_ a, b, third);
#line 13669 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_div); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_div)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	SV *	a = ST(0)
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 9096 "MPFR.xs"
  RETVAL = overload_div (aTHX_ a, b, third);
#line 13693 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_copy); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_copy)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, second, third");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	second = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 9105 "MPFR.xs"
  RETVAL = overload_copy (aTHX_ p, second, third);
#line 13717 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_abs); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_abs)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, second, third");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	second = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 9114 "MPFR.xs"
  RETVAL = overload_abs (aTHX_ p, second, third);
#line 13741 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_gt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_gt)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 9123 "MPFR.xs"
  RETVAL = overload_gt (aTHX_ a, b, third);
#line 13765 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_gte); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_gte)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 9132 "MPFR.xs"
  RETVAL = overload_gte (aTHX_ a, b, third);
#line 13789 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_lt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_lt)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 9141 "MPFR.xs"
  RETVAL = overload_lt (aTHX_ a, b, third);
#line 13813 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_lte); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_lte)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 9150 "MPFR.xs"
  RETVAL = overload_lte (aTHX_ a, b, third);
#line 13837 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_spaceship); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_spaceship)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 9159 "MPFR.xs"
  RETVAL = overload_spaceship (aTHX_ a, b, third);
#line 13861 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_equiv); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_equiv)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 9168 "MPFR.xs"
  RETVAL = overload_equiv (aTHX_ a, b, third);
#line 13885 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_not_equiv); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_not_equiv)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 9177 "MPFR.xs"
  RETVAL = overload_not_equiv (aTHX_ a, b, third);
#line 13909 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_true); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_true)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, second, third");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	second = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 9186 "MPFR.xs"
  RETVAL = overload_true (aTHX_ a, second, third);
#line 13933 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_not); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_not)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, second, third");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	second = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 9195 "MPFR.xs"
  RETVAL = overload_not (aTHX_ a, second, third);
#line 13957 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_sqrt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_sqrt)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, second, third");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	second = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 9204 "MPFR.xs"
  RETVAL = overload_sqrt (aTHX_ p, second, third);
#line 13981 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_pow); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_pow)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, second, third");
    {
	SV *	p = ST(0)
;
	SV *	second = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 9213 "MPFR.xs"
  RETVAL = overload_pow (aTHX_ p, second, third);
#line 14005 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_log); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_log)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, second, third");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	second = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 9222 "MPFR.xs"
  RETVAL = overload_log (aTHX_ p, second, third);
#line 14029 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_exp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_exp)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, second, third");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	second = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 9231 "MPFR.xs"
  RETVAL = overload_exp (aTHX_ p, second, third);
#line 14053 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_sin); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_sin)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, second, third");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	second = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 9240 "MPFR.xs"
  RETVAL = overload_sin (aTHX_ p, second, third);
#line 14077 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_cos); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_cos)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, second, third");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	second = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 9249 "MPFR.xs"
  RETVAL = overload_cos (aTHX_ p, second, third);
#line 14101 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_int); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_int)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, second, third");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	second = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 9258 "MPFR.xs"
  RETVAL = overload_int (aTHX_ p, second, third);
#line 14125 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_atan2); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_atan2)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 9267 "MPFR.xs"
  RETVAL = overload_atan2 (aTHX_ a, b, third);
#line 14149 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_randinit_default_nobless); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_randinit_default_nobless)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 9273 "MPFR.xs"
  RETVAL = Rmpfr_randinit_default_nobless (aTHX);
#line 14167 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_randinit_mt_nobless); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_randinit_mt_nobless)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 9280 "MPFR.xs"
  RETVAL = Rmpfr_randinit_mt_nobless (aTHX);
#line 14185 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_randinit_lc_2exp_nobless); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_randinit_lc_2exp_nobless)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, c, m2exp");
    {
	SV *	a = ST(0)
;
	SV *	c = ST(1)
;
	SV *	m2exp = ST(2)
;
	SV *	RETVAL;
#line 9290 "MPFR.xs"
  RETVAL = Rmpfr_randinit_lc_2exp_nobless (aTHX_ a, c, m2exp);
#line 14209 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_randinit_lc_2exp_size_nobless); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_randinit_lc_2exp_size_nobless)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "size");
    {
	SV *	size = ST(0)
;
	SV *	RETVAL;
#line 9297 "MPFR.xs"
  RETVAL = Rmpfr_randinit_lc_2exp_size_nobless (aTHX_ size);
#line 14229 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_randclear); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_randclear)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "p");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	p = ST(0)
;
#line 9304 "MPFR.xs"
        I32* temp;
#line 14250 "MPFR.c"
#line 9306 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_randclear(aTHX_ p);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 14261 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_randseed); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_randseed)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "state, seed");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	state = ST(0)
;
	SV *	seed = ST(1)
;
#line 9321 "MPFR.xs"
        I32* temp;
#line 14283 "MPFR.c"
#line 9323 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_randseed(aTHX_ state, seed);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 14294 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_randseed_ui); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_randseed_ui)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "state, seed");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	state = ST(0)
;
	SV *	seed = ST(1)
;
#line 9338 "MPFR.xs"
        I32* temp;
#line 14316 "MPFR.c"
#line 9340 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_randseed_ui(aTHX_ state, seed);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 14327 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_overload_pow_eq); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_pow_eq)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, second, third");
    {
	SV *	p = ST(0)
;
	SV *	second = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 9356 "MPFR.xs"
  RETVAL = overload_pow_eq (aTHX_ p, second, third);
#line 14350 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_div_eq); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_div_eq)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	SV *	a = ST(0)
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 9365 "MPFR.xs"
  RETVAL = overload_div_eq (aTHX_ a, b, third);
#line 14374 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_sub_eq); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_sub_eq)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	SV *	a = ST(0)
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 9374 "MPFR.xs"
  RETVAL = overload_sub_eq (aTHX_ a, b, third);
#line 14398 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_add_eq); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_add_eq)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	SV *	a = ST(0)
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 9383 "MPFR.xs"
  RETVAL = overload_add_eq (aTHX_ a, b, third);
#line 14422 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_mul_eq); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_mul_eq)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	SV *	a = ST(0)
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 9392 "MPFR.xs"
  RETVAL = overload_mul_eq (aTHX_ a, b, third);
#line 14446 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__itsa); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__itsa)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "a");
    {
	SV *	a = ST(0)
;
	SV *	RETVAL;
#line 9399 "MPFR.xs"
  RETVAL = _itsa (aTHX_ a);
#line 14466 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__has_longlong); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__has_longlong)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = _has_longlong();
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__has_longdouble); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__has_longdouble)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = _has_longdouble();
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__ivsize_bits); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__ivsize_bits)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = _ivsize_bits();
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_RMPFR_PREC_MAX); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_RMPFR_PREC_MAX)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 9417 "MPFR.xs"
  RETVAL = RMPFR_PREC_MAX (aTHX);
#line 14535 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_RMPFR_PREC_MIN); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_RMPFR_PREC_MIN)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 9424 "MPFR.xs"
  RETVAL = RMPFR_PREC_MIN (aTHX);
#line 14553 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_wrap_mpfr_printf); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_wrap_mpfr_printf)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	SV *	a = ST(0)
;
	SV *	b = ST(1)
;
	SV *	RETVAL;
#line 9433 "MPFR.xs"
  RETVAL = wrap_mpfr_printf (aTHX_ a, b);
#line 14575 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_wrap_mpfr_fprintf); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_wrap_mpfr_fprintf)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "stream, a, b");
    {
	FILE *	stream = PerlIO_findFILE(IoIFP(sv_2io(ST(0))))
;
	SV *	a = ST(1)
;
	SV *	b = ST(2)
;
	SV *	RETVAL;
#line 9442 "MPFR.xs"
  RETVAL = wrap_mpfr_fprintf (aTHX_ stream, a, b);
#line 14599 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_wrap_mpfr_sprintf); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_wrap_mpfr_sprintf)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "s, a, b, buflen");
    {
	SV *	s = ST(0)
;
	SV *	a = ST(1)
;
	SV *	b = ST(2)
;
	int	buflen = (int)SvIV(ST(3))
;
	SV *	RETVAL;
#line 9452 "MPFR.xs"
  RETVAL = wrap_mpfr_sprintf (aTHX_ s, a, b, buflen);
#line 14625 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_wrap_mpfr_snprintf); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_wrap_mpfr_snprintf)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "s, bytes, a, b, buflen");
    {
	SV *	s = ST(0)
;
	SV *	bytes = ST(1)
;
	SV *	a = ST(2)
;
	SV *	b = ST(3)
;
	int	buflen = (int)SvIV(ST(4))
;
	SV *	RETVAL;
#line 9463 "MPFR.xs"
  RETVAL = wrap_mpfr_snprintf (aTHX_ s, bytes, a, b, buflen);
#line 14653 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_wrap_mpfr_printf_rnd); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_wrap_mpfr_printf_rnd)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, round, b");
    {
	SV *	a = ST(0)
;
	SV *	round = ST(1)
;
	SV *	b = ST(2)
;
	SV *	RETVAL;
#line 9472 "MPFR.xs"
  RETVAL = wrap_mpfr_printf_rnd (aTHX_ a, round, b);
#line 14677 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_wrap_mpfr_fprintf_rnd); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_wrap_mpfr_fprintf_rnd)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "stream, a, round, b");
    {
	FILE *	stream = PerlIO_findFILE(IoIFP(sv_2io(ST(0))))
;
	SV *	a = ST(1)
;
	SV *	round = ST(2)
;
	SV *	b = ST(3)
;
	SV *	RETVAL;
#line 9482 "MPFR.xs"
  RETVAL = wrap_mpfr_fprintf_rnd (aTHX_ stream, a, round, b);
#line 14703 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_wrap_mpfr_sprintf_rnd); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_wrap_mpfr_sprintf_rnd)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "s, a, round, b, buflen");
    {
	SV *	s = ST(0)
;
	SV *	a = ST(1)
;
	SV *	round = ST(2)
;
	SV *	b = ST(3)
;
	int	buflen = (int)SvIV(ST(4))
;
	SV *	RETVAL;
#line 9493 "MPFR.xs"
  RETVAL = wrap_mpfr_sprintf_rnd (aTHX_ s, a, round, b, buflen);
#line 14731 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_wrap_mpfr_snprintf_rnd); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_wrap_mpfr_snprintf_rnd)
{
    dVAR; dXSARGS;
    if (items != 6)
       croak_xs_usage(cv,  "s, bytes, a, round, b, buflen");
    {
	SV *	s = ST(0)
;
	SV *	bytes = ST(1)
;
	SV *	a = ST(2)
;
	SV *	round = ST(3)
;
	SV *	b = ST(4)
;
	int	buflen = (int)SvIV(ST(5))
;
	SV *	RETVAL;
#line 9505 "MPFR.xs"
  RETVAL = wrap_mpfr_snprintf_rnd (aTHX_ s, bytes, a, round, b, buflen);
#line 14761 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_buildopt_tls_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_buildopt_tls_p)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 9511 "MPFR.xs"
  RETVAL = Rmpfr_buildopt_tls_p (aTHX);
#line 14779 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_buildopt_decimal_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_buildopt_decimal_p)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 9518 "MPFR.xs"
  RETVAL = Rmpfr_buildopt_decimal_p (aTHX);
#line 14797 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_regular_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_regular_p)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "a");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	RETVAL;
#line 9526 "MPFR.xs"
  RETVAL = Rmpfr_regular_p (aTHX_ a);
#line 14817 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_zero); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_zero)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, sign");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	sign = ST(1)
;
#line 9534 "MPFR.xs"
        I32* temp;
#line 14840 "MPFR.c"
#line 9536 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_set_zero(aTHX_ a, sign);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 14851 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_digamma); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_digamma)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, op, round");
    {
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            op = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 9552 "MPFR.xs"
  RETVAL = Rmpfr_digamma (aTHX_ rop, op, round);
#line 14874 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_ai); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_ai)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, op, round");
    {
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            op = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 9561 "MPFR.xs"
  RETVAL = Rmpfr_ai (aTHX_ rop, op, round);
#line 14898 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_flt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_flt)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
	SV *	RETVAL;
#line 9569 "MPFR.xs"
  RETVAL = Rmpfr_get_flt (aTHX_ a, round);
#line 14920 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_flt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_flt)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, f, round");
    {
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	f = ST(1)
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 9578 "MPFR.xs"
  RETVAL = Rmpfr_set_flt (aTHX_ rop, f, round);
#line 14944 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_urandom); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_urandom)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, state, round");
    {
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	gmp_randstate_t *            state = INT2PTR(gmp_randstate_t *, SvIV(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 9587 "MPFR.xs"
  RETVAL = Rmpfr_urandom (aTHX_ rop, state, round);
#line 14968 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_z_2exp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_z_2exp)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "rop, op, exp, round");
    {
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpz_t *            op = INT2PTR(mpz_t *, SvIV(SvRV(ST(1))))
;
	SV *	exp = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 9597 "MPFR.xs"
  RETVAL = Rmpfr_set_z_2exp (aTHX_ rop, op, exp, round);
#line 14994 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_buildopt_tune_case); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_buildopt_tune_case)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 9603 "MPFR.xs"
  RETVAL = Rmpfr_buildopt_tune_case (aTHX);
#line 15012 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_frexp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_frexp)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "exp, rop, op, round");
    {
	SV *	exp = ST(0)
;
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	mpfr_t *            op = INT2PTR(mpfr_t *, SvIV(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 9614 "MPFR.xs"
  RETVAL = Rmpfr_frexp (aTHX_ exp, rop, op, round);
#line 15038 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_z_sub); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_z_sub)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "rop, op1, op2, round");
    {
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpz_t *            op1 = INT2PTR(mpz_t *, SvIV(SvRV(ST(1))))
;
	mpfr_t *            op2 = INT2PTR(mpfr_t *, SvIV(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 9624 "MPFR.xs"
  RETVAL = Rmpfr_z_sub (aTHX_ rop, op1, op2, round);
#line 15064 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_grandom); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_grandom)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "rop1, rop2, state, round");
    {
	mpfr_t *            rop1 = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	mpfr_t *            rop2 = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	gmp_randstate_t *            state = INT2PTR(gmp_randstate_t *, SvIV(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 9634 "MPFR.xs"
  RETVAL = Rmpfr_grandom (aTHX_ rop1, rop2, state, round);
#line 15090 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_clear_divby0); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_clear_divby0)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 9641 "MPFR.xs"
        I32* temp;
#line 15109 "MPFR.c"
#line 9643 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_clear_divby0(aTHX);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 15120 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_divby0); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_divby0)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 9657 "MPFR.xs"
        I32* temp;
#line 15138 "MPFR.c"
#line 9659 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_set_divby0(aTHX);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 15149 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_divby0_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_divby0_p)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 9672 "MPFR.xs"
  RETVAL = Rmpfr_divby0_p (aTHX);
#line 15166 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_buildopt_gmpinternals_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_buildopt_gmpinternals_p)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 9679 "MPFR.xs"
  RETVAL = Rmpfr_buildopt_gmpinternals_p (aTHX);
#line 15184 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__get_xs_version); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__get_xs_version)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 9686 "MPFR.xs"
  RETVAL = _get_xs_version (aTHX);
#line 15202 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_inc); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_inc)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, second, third");
    {
	SV *	p = ST(0)
;
	SV *	second = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 9696 "MPFR.xs"
  RETVAL = overload_inc (aTHX_ p, second, third);
#line 15226 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_dec); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_dec)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, second, third");
    {
	SV *	p = ST(0)
;
	SV *	second = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 9705 "MPFR.xs"
  RETVAL = overload_dec (aTHX_ p, second, third);
#line 15250 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__wrap_count); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__wrap_count)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 9711 "MPFR.xs"
  RETVAL = _wrap_count (aTHX);
#line 15268 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_LD); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_LD)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, op, rnd");
    {
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	op = ST(1)
;
	SV *	rnd = ST(2)
;
	SV *	RETVAL;
#line 9721 "MPFR.xs"
  RETVAL = Rmpfr_set_LD (aTHX_ rop, op, rnd);
#line 15292 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_DECIMAL64); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_DECIMAL64)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, op, rnd");
    {
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	op = ST(1)
;
	SV *	rnd = ST(2)
;
	SV *	RETVAL;
#line 9730 "MPFR.xs"
  RETVAL = Rmpfr_set_DECIMAL64 (aTHX_ rop, op, rnd);
#line 15316 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_LD); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_LD)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, op, rnd");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	rop = ST(0)
;
	mpfr_t *            op = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	rnd = ST(2)
;
#line 9739 "MPFR.xs"
        I32* temp;
#line 15341 "MPFR.c"
#line 9741 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_get_LD(aTHX_ rop, op, rnd);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 15352 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_DECIMAL64); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_DECIMAL64)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, op, rnd");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	rop = ST(0)
;
	mpfr_t *            op = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	rnd = ST(2)
;
#line 9757 "MPFR.xs"
        I32* temp;
#line 15376 "MPFR.c"
#line 9759 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_get_DECIMAL64(aTHX_ rop, op, rnd);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 15387 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR__MPFR_WANT_DECIMAL_FLOATS); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__MPFR_WANT_DECIMAL_FLOATS)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = _MPFR_WANT_DECIMAL_FLOATS();
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__MPFR_WANT_FLOAT128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__MPFR_WANT_FLOAT128)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = _MPFR_WANT_FLOAT128();
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__max_base); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__max_base)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 9780 "MPFR.xs"
  RETVAL = _max_base (aTHX);
#line 15438 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__isobject); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__isobject)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "x");
    {
	SV *	x = ST(0)
;
	SV *	RETVAL;
#line 9788 "MPFR.xs"
  RETVAL = _isobject (aTHX_ x);
#line 15458 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__mp_sizes); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__mp_sizes)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 9795 "MPFR.xs"
        I32* temp;
#line 15477 "MPFR.c"
#line 9797 "MPFR.xs"
        temp = PL_markstack_ptr++;
        _mp_sizes();
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 15488 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR__ivsize); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__ivsize)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 9810 "MPFR.xs"
  RETVAL = _ivsize (aTHX);
#line 15505 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__nvsize); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__nvsize)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 9817 "MPFR.xs"
  RETVAL = _nvsize (aTHX);
#line 15523 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__FLT128_DIG); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__FLT128_DIG)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 9824 "MPFR.xs"
  RETVAL = _FLT128_DIG (aTHX);
#line 15541 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__LDBL_DIG); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__LDBL_DIG)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 9831 "MPFR.xs"
  RETVAL = _LDBL_DIG (aTHX);
#line 15559 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__DBL_DIG); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__DBL_DIG)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 9838 "MPFR.xs"
  RETVAL = _DBL_DIG (aTHX);
#line 15577 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__FLT128_MANT_DIG); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__FLT128_MANT_DIG)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 9845 "MPFR.xs"
  RETVAL = _FLT128_MANT_DIG (aTHX);
#line 15595 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__LDBL_MANT_DIG); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__LDBL_MANT_DIG)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 9852 "MPFR.xs"
  RETVAL = _LDBL_MANT_DIG (aTHX);
#line 15613 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__DBL_MANT_DIG); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__DBL_MANT_DIG)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 9859 "MPFR.xs"
  RETVAL = _DBL_MANT_DIG (aTHX);
#line 15631 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_float128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_float128)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "op, rnd");
    {
	mpfr_t *            op = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	rnd = ST(1)
;
	SV *	RETVAL;
#line 9868 "MPFR.xs"
  RETVAL = Rmpfr_get_float128 (aTHX_ op, rnd);
#line 15653 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_FLOAT128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_FLOAT128)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, op, rnd");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	rop = ST(0)
;
	mpfr_t *            op = INT2PTR(mpfr_t *, SvIV(SvRV(ST(1))))
;
	SV *	rnd = ST(2)
;
#line 9877 "MPFR.xs"
        I32* temp;
#line 15678 "MPFR.c"
#line 9879 "MPFR.xs"
        temp = PL_markstack_ptr++;
        Rmpfr_get_FLOAT128(aTHX_ rop, op, rnd);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 15689 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_FLOAT128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_FLOAT128)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, op, rnd");
    {
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	op = ST(1)
;
	SV *	rnd = ST(2)
;
	SV *	RETVAL;
#line 9895 "MPFR.xs"
  RETVAL = Rmpfr_set_FLOAT128 (aTHX_ rop, op, rnd);
#line 15712 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_float128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_float128)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, q, rnd");
    {
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	SV *	q = ST(1)
;
	SV *	rnd = ST(2)
;
	SV *	RETVAL;
#line 9904 "MPFR.xs"
  RETVAL = Rmpfr_set_float128 (aTHX_ rop, q, rnd);
#line 15736 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__is_readonly); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__is_readonly)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
	SV *	sv = ST(0)
;
	SV *	RETVAL;
#line 9911 "MPFR.xs"
  RETVAL = _is_readonly (aTHX_ sv);
#line 15756 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__readonly_on); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__readonly_on)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	sv = ST(0)
;
#line 9918 "MPFR.xs"
        I32* temp;
#line 15777 "MPFR.c"
#line 9920 "MPFR.xs"
        temp = PL_markstack_ptr++;
        _readonly_on(aTHX_ sv);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 15788 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR__readonly_off); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__readonly_off)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	sv = ST(0)
;
#line 9934 "MPFR.xs"
        I32* temp;
#line 15808 "MPFR.c"
#line 9936 "MPFR.xs"
        temp = PL_markstack_ptr++;
        _readonly_off(aTHX_ sv);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 15819 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR__can_pass_float128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__can_pass_float128)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = _can_pass_float128();
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__mpfr_want_float128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__mpfr_want_float128)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = _mpfr_want_float128();
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_nnumflag); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_nnumflag)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = nnumflag();
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_clear_nnum); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_clear_nnum)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 9962 "MPFR.xs"
        I32* temp;
#line 15888 "MPFR.c"
#line 9964 "MPFR.xs"
        temp = PL_markstack_ptr++;
        clear_nnum();
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 15899 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_set_nnum); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_set_nnum)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "x");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	int	x = (int)SvIV(ST(0))
;
#line 9978 "MPFR.xs"
        I32* temp;
#line 15919 "MPFR.c"
#line 9980 "MPFR.xs"
        temp = PL_markstack_ptr++;
        set_nnum(x);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 15930 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR__d_bytes); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__d_bytes)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "str, bits");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	str = ST(0)
;
	unsigned int	bits = (unsigned int)SvUV(ST(1))
;
#line 9995 "MPFR.xs"
        I32* temp;
#line 15952 "MPFR.c"
#line 9997 "MPFR.xs"
        temp = PL_markstack_ptr++;
        _d_bytes(aTHX_ str, bits);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 15963 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR__d_bytes_fr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__d_bytes_fr)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "str, bits");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpfr_t *            str = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	unsigned int	bits = (unsigned int)SvUV(ST(1))
;
#line 10012 "MPFR.xs"
        I32* temp;
#line 15985 "MPFR.c"
#line 10014 "MPFR.xs"
        temp = PL_markstack_ptr++;
        _d_bytes_fr(aTHX_ str, bits);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 15996 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR__dd_bytes); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__dd_bytes)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "str, bits");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	str = ST(0)
;
	unsigned int	bits = (unsigned int)SvUV(ST(1))
;
#line 10029 "MPFR.xs"
        I32* temp;
#line 16018 "MPFR.c"
#line 10031 "MPFR.xs"
        temp = PL_markstack_ptr++;
        _dd_bytes(aTHX_ str, bits);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 16029 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR__dd_bytes_fr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__dd_bytes_fr)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "str, bits");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpfr_t *            str = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	unsigned int	bits = (unsigned int)SvUV(ST(1))
;
#line 10046 "MPFR.xs"
        I32* temp;
#line 16051 "MPFR.c"
#line 10048 "MPFR.xs"
        temp = PL_markstack_ptr++;
        _dd_bytes_fr(aTHX_ str, bits);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 16062 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR__ld_bytes); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__ld_bytes)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "str, bits");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	str = ST(0)
;
	unsigned int	bits = (unsigned int)SvUV(ST(1))
;
#line 10063 "MPFR.xs"
        I32* temp;
#line 16084 "MPFR.c"
#line 10065 "MPFR.xs"
        temp = PL_markstack_ptr++;
        _ld_bytes(aTHX_ str, bits);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 16095 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR__ld_bytes_fr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__ld_bytes_fr)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "str, bits");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpfr_t *            str = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	unsigned int	bits = (unsigned int)SvUV(ST(1))
;
#line 10080 "MPFR.xs"
        I32* temp;
#line 16117 "MPFR.c"
#line 10082 "MPFR.xs"
        temp = PL_markstack_ptr++;
        _ld_bytes_fr(aTHX_ str, bits);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 16128 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR__f128_bytes); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__f128_bytes)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "str, bits");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	str = ST(0)
;
	unsigned int	bits = (unsigned int)SvUV(ST(1))
;
#line 10097 "MPFR.xs"
        I32* temp;
#line 16150 "MPFR.c"
#line 10099 "MPFR.xs"
        temp = PL_markstack_ptr++;
        _f128_bytes(aTHX_ str, bits);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 16161 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR__f128_bytes_fr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__f128_bytes_fr)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "str, bits");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpfr_t *            str = INT2PTR(mpfr_t *, SvIV(SvRV(ST(0))))
;
	unsigned int	bits = (unsigned int)SvUV(ST(1))
;
#line 10114 "MPFR.xs"
        I32* temp;
#line 16183 "MPFR.c"
#line 10116 "MPFR.xs"
        temp = PL_markstack_ptr++;
        _f128_bytes_fr(aTHX_ str, bits);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 16194 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR__required_ldbl_mant_dig); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__required_ldbl_mant_dig)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = _required_ldbl_mant_dig();
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__GMP_LIMB_BITS); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__GMP_LIMB_BITS)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 10133 "MPFR.xs"
  RETVAL = _GMP_LIMB_BITS (aTHX);
#line 16228 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__GMP_NAIL_BITS); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__GMP_NAIL_BITS)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 10140 "MPFR.xs"
  RETVAL = _GMP_NAIL_BITS (aTHX);
#line 16246 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Math__MPFR); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Math__MPFR)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Math::MPFR::_has_inttypes", XS_Math__MPFR__has_inttypes);
        newXS_deffile("Math::MPFR::NNW_val", XS_Math__MPFR_NNW_val);
        newXS_deffile("Math::MPFR::Rmpfr_set_default_rounding_mode", XS_Math__MPFR_Rmpfr_set_default_rounding_mode);
        newXS_deffile("Math::MPFR::Rmpfr_get_default_rounding_mode", XS_Math__MPFR_Rmpfr_get_default_rounding_mode);
        newXS_deffile("Math::MPFR::Rmpfr_prec_round", XS_Math__MPFR_Rmpfr_prec_round);
        newXS_deffile("Math::MPFR::DESTROY", XS_Math__MPFR_DESTROY);
        newXS_deffile("Math::MPFR::Rmpfr_clear", XS_Math__MPFR_Rmpfr_clear);
        newXS_deffile("Math::MPFR::Rmpfr_clear_mpfr", XS_Math__MPFR_Rmpfr_clear_mpfr);
        newXS_deffile("Math::MPFR::Rmpfr_clear_ptr", XS_Math__MPFR_Rmpfr_clear_ptr);
        newXS_deffile("Math::MPFR::Rmpfr_clears", XS_Math__MPFR_Rmpfr_clears);
        newXS_deffile("Math::MPFR::Rmpfr_init", XS_Math__MPFR_Rmpfr_init);
        newXS_deffile("Math::MPFR::Rmpfr_init2", XS_Math__MPFR_Rmpfr_init2);
        newXS_deffile("Math::MPFR::Rmpfr_init_nobless", XS_Math__MPFR_Rmpfr_init_nobless);
        newXS_deffile("Math::MPFR::Rmpfr_init2_nobless", XS_Math__MPFR_Rmpfr_init2_nobless);
        newXS_deffile("Math::MPFR::Rmpfr_init_set", XS_Math__MPFR_Rmpfr_init_set);
        newXS_deffile("Math::MPFR::Rmpfr_init_set_ui", XS_Math__MPFR_Rmpfr_init_set_ui);
        newXS_deffile("Math::MPFR::Rmpfr_init_set_si", XS_Math__MPFR_Rmpfr_init_set_si);
        newXS_deffile("Math::MPFR::Rmpfr_init_set_d", XS_Math__MPFR_Rmpfr_init_set_d);
        newXS_deffile("Math::MPFR::Rmpfr_init_set_ld", XS_Math__MPFR_Rmpfr_init_set_ld);
        newXS_deffile("Math::MPFR::Rmpfr_init_set_f", XS_Math__MPFR_Rmpfr_init_set_f);
        newXS_deffile("Math::MPFR::Rmpfr_init_set_z", XS_Math__MPFR_Rmpfr_init_set_z);
        newXS_deffile("Math::MPFR::Rmpfr_init_set_q", XS_Math__MPFR_Rmpfr_init_set_q);
        newXS_deffile("Math::MPFR::Rmpfr_init_set_str", XS_Math__MPFR_Rmpfr_init_set_str);
        newXS_deffile("Math::MPFR::Rmpfr_init_set_nobless", XS_Math__MPFR_Rmpfr_init_set_nobless);
        newXS_deffile("Math::MPFR::Rmpfr_init_set_ui_nobless", XS_Math__MPFR_Rmpfr_init_set_ui_nobless);
        newXS_deffile("Math::MPFR::Rmpfr_init_set_si_nobless", XS_Math__MPFR_Rmpfr_init_set_si_nobless);
        newXS_deffile("Math::MPFR::Rmpfr_init_set_d_nobless", XS_Math__MPFR_Rmpfr_init_set_d_nobless);
        newXS_deffile("Math::MPFR::Rmpfr_init_set_ld_nobless", XS_Math__MPFR_Rmpfr_init_set_ld_nobless);
        newXS_deffile("Math::MPFR::Rmpfr_init_set_f_nobless", XS_Math__MPFR_Rmpfr_init_set_f_nobless);
        newXS_deffile("Math::MPFR::Rmpfr_init_set_z_nobless", XS_Math__MPFR_Rmpfr_init_set_z_nobless);
        newXS_deffile("Math::MPFR::Rmpfr_init_set_q_nobless", XS_Math__MPFR_Rmpfr_init_set_q_nobless);
        newXS_deffile("Math::MPFR::Rmpfr_init_set_str_nobless", XS_Math__MPFR_Rmpfr_init_set_str_nobless);
        newXS_deffile("Math::MPFR::Rmpfr_deref2", XS_Math__MPFR_Rmpfr_deref2);
        newXS_deffile("Math::MPFR::Rmpfr_set_default_prec", XS_Math__MPFR_Rmpfr_set_default_prec);
        newXS_deffile("Math::MPFR::Rmpfr_get_default_prec", XS_Math__MPFR_Rmpfr_get_default_prec);
        newXS_deffile("Math::MPFR::Rmpfr_min_prec", XS_Math__MPFR_Rmpfr_min_prec);
        newXS_deffile("Math::MPFR::Rmpfr_set_prec", XS_Math__MPFR_Rmpfr_set_prec);
        newXS_deffile("Math::MPFR::Rmpfr_set_prec_raw", XS_Math__MPFR_Rmpfr_set_prec_raw);
        newXS_deffile("Math::MPFR::Rmpfr_get_prec", XS_Math__MPFR_Rmpfr_get_prec);
        newXS_deffile("Math::MPFR::Rmpfr_set", XS_Math__MPFR_Rmpfr_set);
        newXS_deffile("Math::MPFR::Rmpfr_set_ui", XS_Math__MPFR_Rmpfr_set_ui);
        newXS_deffile("Math::MPFR::Rmpfr_set_si", XS_Math__MPFR_Rmpfr_set_si);
        newXS_deffile("Math::MPFR::Rmpfr_set_uj", XS_Math__MPFR_Rmpfr_set_uj);
        newXS_deffile("Math::MPFR::Rmpfr_set_sj", XS_Math__MPFR_Rmpfr_set_sj);
        newXS_deffile("Math::MPFR::Rmpfr_set_NV", XS_Math__MPFR_Rmpfr_set_NV);
        newXS_deffile("Math::MPFR::Rmpfr_set_ld", XS_Math__MPFR_Rmpfr_set_ld);
        newXS_deffile("Math::MPFR::Rmpfr_set_d", XS_Math__MPFR_Rmpfr_set_d);
        newXS_deffile("Math::MPFR::Rmpfr_set_z", XS_Math__MPFR_Rmpfr_set_z);
        newXS_deffile("Math::MPFR::Rmpfr_set_q", XS_Math__MPFR_Rmpfr_set_q);
        newXS_deffile("Math::MPFR::Rmpfr_set_f", XS_Math__MPFR_Rmpfr_set_f);
        newXS_deffile("Math::MPFR::Rmpfr_set_str", XS_Math__MPFR_Rmpfr_set_str);
        newXS_deffile("Math::MPFR::Rmpfr_set_inf", XS_Math__MPFR_Rmpfr_set_inf);
        newXS_deffile("Math::MPFR::Rmpfr_set_nan", XS_Math__MPFR_Rmpfr_set_nan);
        newXS_deffile("Math::MPFR::Rmpfr_swap", XS_Math__MPFR_Rmpfr_swap);
        newXS_deffile("Math::MPFR::Rmpfr_get_d", XS_Math__MPFR_Rmpfr_get_d);
        newXS_deffile("Math::MPFR::Rmpfr_get_d_2exp", XS_Math__MPFR_Rmpfr_get_d_2exp);
        newXS_deffile("Math::MPFR::Rmpfr_get_ld_2exp", XS_Math__MPFR_Rmpfr_get_ld_2exp);
        newXS_deffile("Math::MPFR::Rmpfr_get_ld", XS_Math__MPFR_Rmpfr_get_ld);
        newXS_deffile("Math::MPFR::Rmpfr_get_d1", XS_Math__MPFR_Rmpfr_get_d1);
        newXS_deffile("Math::MPFR::Rmpfr_get_z_2exp", XS_Math__MPFR_Rmpfr_get_z_2exp);
        newXS_deffile("Math::MPFR::Rmpfr_add", XS_Math__MPFR_Rmpfr_add);
        newXS_deffile("Math::MPFR::Rmpfr_add_ui", XS_Math__MPFR_Rmpfr_add_ui);
        newXS_deffile("Math::MPFR::Rmpfr_add_d", XS_Math__MPFR_Rmpfr_add_d);
        newXS_deffile("Math::MPFR::Rmpfr_add_si", XS_Math__MPFR_Rmpfr_add_si);
        newXS_deffile("Math::MPFR::Rmpfr_add_z", XS_Math__MPFR_Rmpfr_add_z);
        newXS_deffile("Math::MPFR::Rmpfr_add_q", XS_Math__MPFR_Rmpfr_add_q);
        newXS_deffile("Math::MPFR::Rmpfr_sub", XS_Math__MPFR_Rmpfr_sub);
        newXS_deffile("Math::MPFR::Rmpfr_sub_ui", XS_Math__MPFR_Rmpfr_sub_ui);
        newXS_deffile("Math::MPFR::Rmpfr_sub_d", XS_Math__MPFR_Rmpfr_sub_d);
        newXS_deffile("Math::MPFR::Rmpfr_sub_z", XS_Math__MPFR_Rmpfr_sub_z);
        newXS_deffile("Math::MPFR::Rmpfr_sub_q", XS_Math__MPFR_Rmpfr_sub_q);
        newXS_deffile("Math::MPFR::Rmpfr_ui_sub", XS_Math__MPFR_Rmpfr_ui_sub);
        newXS_deffile("Math::MPFR::Rmpfr_d_sub", XS_Math__MPFR_Rmpfr_d_sub);
        newXS_deffile("Math::MPFR::Rmpfr_mul", XS_Math__MPFR_Rmpfr_mul);
        newXS_deffile("Math::MPFR::Rmpfr_mul_ui", XS_Math__MPFR_Rmpfr_mul_ui);
        newXS_deffile("Math::MPFR::Rmpfr_mul_d", XS_Math__MPFR_Rmpfr_mul_d);
        newXS_deffile("Math::MPFR::Rmpfr_mul_z", XS_Math__MPFR_Rmpfr_mul_z);
        newXS_deffile("Math::MPFR::Rmpfr_mul_q", XS_Math__MPFR_Rmpfr_mul_q);
        newXS_deffile("Math::MPFR::Rmpfr_dim", XS_Math__MPFR_Rmpfr_dim);
        newXS_deffile("Math::MPFR::Rmpfr_div", XS_Math__MPFR_Rmpfr_div);
        newXS_deffile("Math::MPFR::Rmpfr_div_ui", XS_Math__MPFR_Rmpfr_div_ui);
        newXS_deffile("Math::MPFR::Rmpfr_div_d", XS_Math__MPFR_Rmpfr_div_d);
        newXS_deffile("Math::MPFR::Rmpfr_div_z", XS_Math__MPFR_Rmpfr_div_z);
        newXS_deffile("Math::MPFR::Rmpfr_div_q", XS_Math__MPFR_Rmpfr_div_q);
        newXS_deffile("Math::MPFR::Rmpfr_ui_div", XS_Math__MPFR_Rmpfr_ui_div);
        newXS_deffile("Math::MPFR::Rmpfr_d_div", XS_Math__MPFR_Rmpfr_d_div);
        newXS_deffile("Math::MPFR::Rmpfr_sqrt", XS_Math__MPFR_Rmpfr_sqrt);
        newXS_deffile("Math::MPFR::Rmpfr_rec_sqrt", XS_Math__MPFR_Rmpfr_rec_sqrt);
        newXS_deffile("Math::MPFR::Rmpfr_cbrt", XS_Math__MPFR_Rmpfr_cbrt);
        newXS_deffile("Math::MPFR::Rmpfr_sqrt_ui", XS_Math__MPFR_Rmpfr_sqrt_ui);
        newXS_deffile("Math::MPFR::Rmpfr_pow_ui", XS_Math__MPFR_Rmpfr_pow_ui);
        newXS_deffile("Math::MPFR::Rmpfr_ui_pow_ui", XS_Math__MPFR_Rmpfr_ui_pow_ui);
        newXS_deffile("Math::MPFR::Rmpfr_ui_pow", XS_Math__MPFR_Rmpfr_ui_pow);
        newXS_deffile("Math::MPFR::Rmpfr_pow_si", XS_Math__MPFR_Rmpfr_pow_si);
        newXS_deffile("Math::MPFR::Rmpfr_pow", XS_Math__MPFR_Rmpfr_pow);
        newXS_deffile("Math::MPFR::Rmpfr_neg", XS_Math__MPFR_Rmpfr_neg);
        newXS_deffile("Math::MPFR::Rmpfr_abs", XS_Math__MPFR_Rmpfr_abs);
        newXS_deffile("Math::MPFR::Rmpfr_mul_2exp", XS_Math__MPFR_Rmpfr_mul_2exp);
        newXS_deffile("Math::MPFR::Rmpfr_mul_2ui", XS_Math__MPFR_Rmpfr_mul_2ui);
        newXS_deffile("Math::MPFR::Rmpfr_mul_2si", XS_Math__MPFR_Rmpfr_mul_2si);
        newXS_deffile("Math::MPFR::Rmpfr_div_2exp", XS_Math__MPFR_Rmpfr_div_2exp);
        newXS_deffile("Math::MPFR::Rmpfr_div_2ui", XS_Math__MPFR_Rmpfr_div_2ui);
        newXS_deffile("Math::MPFR::Rmpfr_div_2si", XS_Math__MPFR_Rmpfr_div_2si);
        newXS_deffile("Math::MPFR::Rmpfr_cmp", XS_Math__MPFR_Rmpfr_cmp);
        newXS_deffile("Math::MPFR::Rmpfr_cmpabs", XS_Math__MPFR_Rmpfr_cmpabs);
        newXS_deffile("Math::MPFR::Rmpfr_cmp_ui", XS_Math__MPFR_Rmpfr_cmp_ui);
        newXS_deffile("Math::MPFR::Rmpfr_cmp_d", XS_Math__MPFR_Rmpfr_cmp_d);
        newXS_deffile("Math::MPFR::Rmpfr_cmp_ld", XS_Math__MPFR_Rmpfr_cmp_ld);
        newXS_deffile("Math::MPFR::Rmpfr_cmp_si", XS_Math__MPFR_Rmpfr_cmp_si);
        newXS_deffile("Math::MPFR::Rmpfr_cmp_ui_2exp", XS_Math__MPFR_Rmpfr_cmp_ui_2exp);
        newXS_deffile("Math::MPFR::Rmpfr_cmp_si_2exp", XS_Math__MPFR_Rmpfr_cmp_si_2exp);
        newXS_deffile("Math::MPFR::Rmpfr_eq", XS_Math__MPFR_Rmpfr_eq);
        newXS_deffile("Math::MPFR::Rmpfr_nan_p", XS_Math__MPFR_Rmpfr_nan_p);
        newXS_deffile("Math::MPFR::Rmpfr_inf_p", XS_Math__MPFR_Rmpfr_inf_p);
        newXS_deffile("Math::MPFR::Rmpfr_number_p", XS_Math__MPFR_Rmpfr_number_p);
        newXS_deffile("Math::MPFR::Rmpfr_reldiff", XS_Math__MPFR_Rmpfr_reldiff);
        newXS_deffile("Math::MPFR::Rmpfr_sgn", XS_Math__MPFR_Rmpfr_sgn);
        newXS_deffile("Math::MPFR::Rmpfr_greater_p", XS_Math__MPFR_Rmpfr_greater_p);
        newXS_deffile("Math::MPFR::Rmpfr_greaterequal_p", XS_Math__MPFR_Rmpfr_greaterequal_p);
        newXS_deffile("Math::MPFR::Rmpfr_less_p", XS_Math__MPFR_Rmpfr_less_p);
        newXS_deffile("Math::MPFR::Rmpfr_lessequal_p", XS_Math__MPFR_Rmpfr_lessequal_p);
        newXS_deffile("Math::MPFR::Rmpfr_lessgreater_p", XS_Math__MPFR_Rmpfr_lessgreater_p);
        newXS_deffile("Math::MPFR::Rmpfr_equal_p", XS_Math__MPFR_Rmpfr_equal_p);
        newXS_deffile("Math::MPFR::Rmpfr_unordered_p", XS_Math__MPFR_Rmpfr_unordered_p);
        newXS_deffile("Math::MPFR::Rmpfr_sin_cos", XS_Math__MPFR_Rmpfr_sin_cos);
        newXS_deffile("Math::MPFR::Rmpfr_sinh_cosh", XS_Math__MPFR_Rmpfr_sinh_cosh);
        newXS_deffile("Math::MPFR::Rmpfr_sin", XS_Math__MPFR_Rmpfr_sin);
        newXS_deffile("Math::MPFR::Rmpfr_cos", XS_Math__MPFR_Rmpfr_cos);
        newXS_deffile("Math::MPFR::Rmpfr_tan", XS_Math__MPFR_Rmpfr_tan);
        newXS_deffile("Math::MPFR::Rmpfr_asin", XS_Math__MPFR_Rmpfr_asin);
        newXS_deffile("Math::MPFR::Rmpfr_acos", XS_Math__MPFR_Rmpfr_acos);
        newXS_deffile("Math::MPFR::Rmpfr_atan", XS_Math__MPFR_Rmpfr_atan);
        newXS_deffile("Math::MPFR::Rmpfr_sinh", XS_Math__MPFR_Rmpfr_sinh);
        newXS_deffile("Math::MPFR::Rmpfr_cosh", XS_Math__MPFR_Rmpfr_cosh);
        newXS_deffile("Math::MPFR::Rmpfr_tanh", XS_Math__MPFR_Rmpfr_tanh);
        newXS_deffile("Math::MPFR::Rmpfr_asinh", XS_Math__MPFR_Rmpfr_asinh);
        newXS_deffile("Math::MPFR::Rmpfr_acosh", XS_Math__MPFR_Rmpfr_acosh);
        newXS_deffile("Math::MPFR::Rmpfr_atanh", XS_Math__MPFR_Rmpfr_atanh);
        newXS_deffile("Math::MPFR::Rmpfr_fac_ui", XS_Math__MPFR_Rmpfr_fac_ui);
        newXS_deffile("Math::MPFR::Rmpfr_log1p", XS_Math__MPFR_Rmpfr_log1p);
        newXS_deffile("Math::MPFR::Rmpfr_expm1", XS_Math__MPFR_Rmpfr_expm1);
        newXS_deffile("Math::MPFR::Rmpfr_log2", XS_Math__MPFR_Rmpfr_log2);
        newXS_deffile("Math::MPFR::Rmpfr_log10", XS_Math__MPFR_Rmpfr_log10);
        newXS_deffile("Math::MPFR::Rmpfr_fma", XS_Math__MPFR_Rmpfr_fma);
        newXS_deffile("Math::MPFR::Rmpfr_fms", XS_Math__MPFR_Rmpfr_fms);
        newXS_deffile("Math::MPFR::Rmpfr_agm", XS_Math__MPFR_Rmpfr_agm);
        newXS_deffile("Math::MPFR::Rmpfr_hypot", XS_Math__MPFR_Rmpfr_hypot);
        newXS_deffile("Math::MPFR::Rmpfr_const_log2", XS_Math__MPFR_Rmpfr_const_log2);
        newXS_deffile("Math::MPFR::Rmpfr_const_pi", XS_Math__MPFR_Rmpfr_const_pi);
        newXS_deffile("Math::MPFR::Rmpfr_const_euler", XS_Math__MPFR_Rmpfr_const_euler);
        newXS_deffile("Math::MPFR::Rmpfr_rint", XS_Math__MPFR_Rmpfr_rint);
        newXS_deffile("Math::MPFR::Rmpfr_ceil", XS_Math__MPFR_Rmpfr_ceil);
        newXS_deffile("Math::MPFR::Rmpfr_floor", XS_Math__MPFR_Rmpfr_floor);
        newXS_deffile("Math::MPFR::Rmpfr_round", XS_Math__MPFR_Rmpfr_round);
        newXS_deffile("Math::MPFR::Rmpfr_trunc", XS_Math__MPFR_Rmpfr_trunc);
        newXS_deffile("Math::MPFR::Rmpfr_can_round", XS_Math__MPFR_Rmpfr_can_round);
        newXS_deffile("Math::MPFR::Rmpfr_print_rnd_mode", XS_Math__MPFR_Rmpfr_print_rnd_mode);
        newXS_deffile("Math::MPFR::Rmpfr_get_emin", XS_Math__MPFR_Rmpfr_get_emin);
        newXS_deffile("Math::MPFR::Rmpfr_get_emax", XS_Math__MPFR_Rmpfr_get_emax);
        newXS_deffile("Math::MPFR::Rmpfr_set_emin", XS_Math__MPFR_Rmpfr_set_emin);
        newXS_deffile("Math::MPFR::Rmpfr_set_emax", XS_Math__MPFR_Rmpfr_set_emax);
        newXS_deffile("Math::MPFR::Rmpfr_check_range", XS_Math__MPFR_Rmpfr_check_range);
        newXS_deffile("Math::MPFR::Rmpfr_clear_underflow", XS_Math__MPFR_Rmpfr_clear_underflow);
        newXS_deffile("Math::MPFR::Rmpfr_clear_overflow", XS_Math__MPFR_Rmpfr_clear_overflow);
        newXS_deffile("Math::MPFR::Rmpfr_clear_nanflag", XS_Math__MPFR_Rmpfr_clear_nanflag);
        newXS_deffile("Math::MPFR::Rmpfr_clear_inexflag", XS_Math__MPFR_Rmpfr_clear_inexflag);
        newXS_deffile("Math::MPFR::Rmpfr_clear_flags", XS_Math__MPFR_Rmpfr_clear_flags);
        newXS_deffile("Math::MPFR::Rmpfr_underflow_p", XS_Math__MPFR_Rmpfr_underflow_p);
        newXS_deffile("Math::MPFR::Rmpfr_overflow_p", XS_Math__MPFR_Rmpfr_overflow_p);
        newXS_deffile("Math::MPFR::Rmpfr_nanflag_p", XS_Math__MPFR_Rmpfr_nanflag_p);
        newXS_deffile("Math::MPFR::Rmpfr_inexflag_p", XS_Math__MPFR_Rmpfr_inexflag_p);
        newXS_deffile("Math::MPFR::Rmpfr_log", XS_Math__MPFR_Rmpfr_log);
        newXS_deffile("Math::MPFR::Rmpfr_exp", XS_Math__MPFR_Rmpfr_exp);
        newXS_deffile("Math::MPFR::Rmpfr_exp2", XS_Math__MPFR_Rmpfr_exp2);
        newXS_deffile("Math::MPFR::Rmpfr_exp10", XS_Math__MPFR_Rmpfr_exp10);
        newXS_deffile("Math::MPFR::Rmpfr_urandomb", XS_Math__MPFR_Rmpfr_urandomb);
        newXS_deffile("Math::MPFR::Rmpfr_random2", XS_Math__MPFR_Rmpfr_random2);
        newXS_deffile("Math::MPFR::_TRmpfr_out_str", XS_Math__MPFR__TRmpfr_out_str);
        newXS_deffile("Math::MPFR::_Rmpfr_out_str", XS_Math__MPFR__Rmpfr_out_str);
        newXS_deffile("Math::MPFR::_TRmpfr_out_strS", XS_Math__MPFR__TRmpfr_out_strS);
        newXS_deffile("Math::MPFR::_TRmpfr_out_strP", XS_Math__MPFR__TRmpfr_out_strP);
        newXS_deffile("Math::MPFR::_TRmpfr_out_strPS", XS_Math__MPFR__TRmpfr_out_strPS);
        newXS_deffile("Math::MPFR::_Rmpfr_out_strS", XS_Math__MPFR__Rmpfr_out_strS);
        newXS_deffile("Math::MPFR::_Rmpfr_out_strP", XS_Math__MPFR__Rmpfr_out_strP);
        newXS_deffile("Math::MPFR::_Rmpfr_out_strPS", XS_Math__MPFR__Rmpfr_out_strPS);
        newXS_deffile("Math::MPFR::TRmpfr_inp_str", XS_Math__MPFR_TRmpfr_inp_str);
        newXS_deffile("Math::MPFR::Rmpfr_inp_str", XS_Math__MPFR_Rmpfr_inp_str);
        newXS_deffile("Math::MPFR::Rmpfr_gamma", XS_Math__MPFR_Rmpfr_gamma);
        newXS_deffile("Math::MPFR::Rmpfr_zeta", XS_Math__MPFR_Rmpfr_zeta);
        newXS_deffile("Math::MPFR::Rmpfr_zeta_ui", XS_Math__MPFR_Rmpfr_zeta_ui);
        newXS_deffile("Math::MPFR::Rmpfr_erf", XS_Math__MPFR_Rmpfr_erf);
        newXS_deffile("Math::MPFR::Rmpfr_frac", XS_Math__MPFR_Rmpfr_frac);
        newXS_deffile("Math::MPFR::Rmpfr_remainder", XS_Math__MPFR_Rmpfr_remainder);
        newXS_deffile("Math::MPFR::Rmpfr_modf", XS_Math__MPFR_Rmpfr_modf);
        newXS_deffile("Math::MPFR::Rmpfr_fmod", XS_Math__MPFR_Rmpfr_fmod);
        newXS_deffile("Math::MPFR::Rmpfr_remquo", XS_Math__MPFR_Rmpfr_remquo);
        newXS_deffile("Math::MPFR::Rmpfr_integer_p", XS_Math__MPFR_Rmpfr_integer_p);
        newXS_deffile("Math::MPFR::Rmpfr_nexttoward", XS_Math__MPFR_Rmpfr_nexttoward);
        newXS_deffile("Math::MPFR::Rmpfr_nextabove", XS_Math__MPFR_Rmpfr_nextabove);
        newXS_deffile("Math::MPFR::Rmpfr_nextbelow", XS_Math__MPFR_Rmpfr_nextbelow);
        newXS_deffile("Math::MPFR::Rmpfr_min", XS_Math__MPFR_Rmpfr_min);
        newXS_deffile("Math::MPFR::Rmpfr_max", XS_Math__MPFR_Rmpfr_max);
        newXS_deffile("Math::MPFR::Rmpfr_get_exp", XS_Math__MPFR_Rmpfr_get_exp);
        newXS_deffile("Math::MPFR::Rmpfr_set_exp", XS_Math__MPFR_Rmpfr_set_exp);
        newXS_deffile("Math::MPFR::Rmpfr_signbit", XS_Math__MPFR_Rmpfr_signbit);
        newXS_deffile("Math::MPFR::Rmpfr_setsign", XS_Math__MPFR_Rmpfr_setsign);
        newXS_deffile("Math::MPFR::Rmpfr_copysign", XS_Math__MPFR_Rmpfr_copysign);
        newXS_deffile("Math::MPFR::get_refcnt", XS_Math__MPFR_get_refcnt);
        newXS_deffile("Math::MPFR::get_package_name", XS_Math__MPFR_get_package_name);
        newXS_deffile("Math::MPFR::Rmpfr_dump", XS_Math__MPFR_Rmpfr_dump);
        newXS_deffile("Math::MPFR::gmp_v", XS_Math__MPFR_gmp_v);
        newXS_deffile("Math::MPFR::Rmpfr_set_ui_2exp", XS_Math__MPFR_Rmpfr_set_ui_2exp);
        newXS_deffile("Math::MPFR::Rmpfr_set_si_2exp", XS_Math__MPFR_Rmpfr_set_si_2exp);
        newXS_deffile("Math::MPFR::Rmpfr_set_uj_2exp", XS_Math__MPFR_Rmpfr_set_uj_2exp);
        newXS_deffile("Math::MPFR::Rmpfr_set_sj_2exp", XS_Math__MPFR_Rmpfr_set_sj_2exp);
        newXS_deffile("Math::MPFR::Rmpfr_get_z", XS_Math__MPFR_Rmpfr_get_z);
        newXS_deffile("Math::MPFR::Rmpfr_si_sub", XS_Math__MPFR_Rmpfr_si_sub);
        newXS_deffile("Math::MPFR::Rmpfr_sub_si", XS_Math__MPFR_Rmpfr_sub_si);
        newXS_deffile("Math::MPFR::Rmpfr_mul_si", XS_Math__MPFR_Rmpfr_mul_si);
        newXS_deffile("Math::MPFR::Rmpfr_si_div", XS_Math__MPFR_Rmpfr_si_div);
        newXS_deffile("Math::MPFR::Rmpfr_div_si", XS_Math__MPFR_Rmpfr_div_si);
        newXS_deffile("Math::MPFR::Rmpfr_sqr", XS_Math__MPFR_Rmpfr_sqr);
        newXS_deffile("Math::MPFR::Rmpfr_cmp_z", XS_Math__MPFR_Rmpfr_cmp_z);
        newXS_deffile("Math::MPFR::Rmpfr_cmp_q", XS_Math__MPFR_Rmpfr_cmp_q);
        newXS_deffile("Math::MPFR::Rmpfr_cmp_f", XS_Math__MPFR_Rmpfr_cmp_f);
        newXS_deffile("Math::MPFR::Rmpfr_zero_p", XS_Math__MPFR_Rmpfr_zero_p);
        newXS_deffile("Math::MPFR::Rmpfr_free_cache", XS_Math__MPFR_Rmpfr_free_cache);
        newXS_deffile("Math::MPFR::Rmpfr_get_version", XS_Math__MPFR_Rmpfr_get_version);
        newXS_deffile("Math::MPFR::Rmpfr_get_patches", XS_Math__MPFR_Rmpfr_get_patches);
        newXS_deffile("Math::MPFR::Rmpfr_get_emin_min", XS_Math__MPFR_Rmpfr_get_emin_min);
        newXS_deffile("Math::MPFR::Rmpfr_get_emin_max", XS_Math__MPFR_Rmpfr_get_emin_max);
        newXS_deffile("Math::MPFR::Rmpfr_get_emax_min", XS_Math__MPFR_Rmpfr_get_emax_min);
        newXS_deffile("Math::MPFR::Rmpfr_get_emax_max", XS_Math__MPFR_Rmpfr_get_emax_max);
        newXS_deffile("Math::MPFR::Rmpfr_clear_erangeflag", XS_Math__MPFR_Rmpfr_clear_erangeflag);
        newXS_deffile("Math::MPFR::Rmpfr_erangeflag_p", XS_Math__MPFR_Rmpfr_erangeflag_p);
        newXS_deffile("Math::MPFR::Rmpfr_rint_round", XS_Math__MPFR_Rmpfr_rint_round);
        newXS_deffile("Math::MPFR::Rmpfr_rint_trunc", XS_Math__MPFR_Rmpfr_rint_trunc);
        newXS_deffile("Math::MPFR::Rmpfr_rint_ceil", XS_Math__MPFR_Rmpfr_rint_ceil);
        newXS_deffile("Math::MPFR::Rmpfr_rint_floor", XS_Math__MPFR_Rmpfr_rint_floor);
        newXS_deffile("Math::MPFR::Rmpfr_get_ui", XS_Math__MPFR_Rmpfr_get_ui);
        newXS_deffile("Math::MPFR::Rmpfr_get_si", XS_Math__MPFR_Rmpfr_get_si);
        newXS_deffile("Math::MPFR::Rmpfr_get_uj", XS_Math__MPFR_Rmpfr_get_uj);
        newXS_deffile("Math::MPFR::Rmpfr_get_sj", XS_Math__MPFR_Rmpfr_get_sj);
        newXS_deffile("Math::MPFR::Rmpfr_get_IV", XS_Math__MPFR_Rmpfr_get_IV);
        newXS_deffile("Math::MPFR::Rmpfr_get_UV", XS_Math__MPFR_Rmpfr_get_UV);
        newXS_deffile("Math::MPFR::Rmpfr_get_NV", XS_Math__MPFR_Rmpfr_get_NV);
        newXS_deffile("Math::MPFR::Rmpfr_fits_ulong_p", XS_Math__MPFR_Rmpfr_fits_ulong_p);
        newXS_deffile("Math::MPFR::Rmpfr_fits_slong_p", XS_Math__MPFR_Rmpfr_fits_slong_p);
        newXS_deffile("Math::MPFR::Rmpfr_fits_ushort_p", XS_Math__MPFR_Rmpfr_fits_ushort_p);
        newXS_deffile("Math::MPFR::Rmpfr_fits_sshort_p", XS_Math__MPFR_Rmpfr_fits_sshort_p);
        newXS_deffile("Math::MPFR::Rmpfr_fits_uint_p", XS_Math__MPFR_Rmpfr_fits_uint_p);
        newXS_deffile("Math::MPFR::Rmpfr_fits_sint_p", XS_Math__MPFR_Rmpfr_fits_sint_p);
        newXS_deffile("Math::MPFR::Rmpfr_fits_uintmax_p", XS_Math__MPFR_Rmpfr_fits_uintmax_p);
        newXS_deffile("Math::MPFR::Rmpfr_fits_intmax_p", XS_Math__MPFR_Rmpfr_fits_intmax_p);
        newXS_deffile("Math::MPFR::Rmpfr_fits_IV_p", XS_Math__MPFR_Rmpfr_fits_IV_p);
        newXS_deffile("Math::MPFR::Rmpfr_fits_UV_p", XS_Math__MPFR_Rmpfr_fits_UV_p);
        newXS_deffile("Math::MPFR::Rmpfr_strtofr", XS_Math__MPFR_Rmpfr_strtofr);
        newXS_deffile("Math::MPFR::Rmpfr_set_erangeflag", XS_Math__MPFR_Rmpfr_set_erangeflag);
        newXS_deffile("Math::MPFR::Rmpfr_set_underflow", XS_Math__MPFR_Rmpfr_set_underflow);
        newXS_deffile("Math::MPFR::Rmpfr_set_overflow", XS_Math__MPFR_Rmpfr_set_overflow);
        newXS_deffile("Math::MPFR::Rmpfr_set_nanflag", XS_Math__MPFR_Rmpfr_set_nanflag);
        newXS_deffile("Math::MPFR::Rmpfr_set_inexflag", XS_Math__MPFR_Rmpfr_set_inexflag);
        newXS_deffile("Math::MPFR::Rmpfr_erfc", XS_Math__MPFR_Rmpfr_erfc);
        newXS_deffile("Math::MPFR::Rmpfr_j0", XS_Math__MPFR_Rmpfr_j0);
        newXS_deffile("Math::MPFR::Rmpfr_j1", XS_Math__MPFR_Rmpfr_j1);
        newXS_deffile("Math::MPFR::Rmpfr_jn", XS_Math__MPFR_Rmpfr_jn);
        newXS_deffile("Math::MPFR::Rmpfr_y0", XS_Math__MPFR_Rmpfr_y0);
        newXS_deffile("Math::MPFR::Rmpfr_y1", XS_Math__MPFR_Rmpfr_y1);
        newXS_deffile("Math::MPFR::Rmpfr_yn", XS_Math__MPFR_Rmpfr_yn);
        newXS_deffile("Math::MPFR::Rmpfr_atan2", XS_Math__MPFR_Rmpfr_atan2);
        newXS_deffile("Math::MPFR::Rmpfr_pow_z", XS_Math__MPFR_Rmpfr_pow_z);
        newXS_deffile("Math::MPFR::Rmpfr_subnormalize", XS_Math__MPFR_Rmpfr_subnormalize);
        newXS_deffile("Math::MPFR::Rmpfr_const_catalan", XS_Math__MPFR_Rmpfr_const_catalan);
        newXS_deffile("Math::MPFR::Rmpfr_sec", XS_Math__MPFR_Rmpfr_sec);
        newXS_deffile("Math::MPFR::Rmpfr_csc", XS_Math__MPFR_Rmpfr_csc);
        newXS_deffile("Math::MPFR::Rmpfr_cot", XS_Math__MPFR_Rmpfr_cot);
        newXS_deffile("Math::MPFR::Rmpfr_root", XS_Math__MPFR_Rmpfr_root);
        newXS_deffile("Math::MPFR::Rmpfr_eint", XS_Math__MPFR_Rmpfr_eint);
        newXS_deffile("Math::MPFR::Rmpfr_li2", XS_Math__MPFR_Rmpfr_li2);
        newXS_deffile("Math::MPFR::Rmpfr_get_f", XS_Math__MPFR_Rmpfr_get_f);
        newXS_deffile("Math::MPFR::Rmpfr_get_q", XS_Math__MPFR_Rmpfr_get_q);
        newXS_deffile("Math::MPFR::Rmpfr_sech", XS_Math__MPFR_Rmpfr_sech);
        newXS_deffile("Math::MPFR::Rmpfr_csch", XS_Math__MPFR_Rmpfr_csch);
        newXS_deffile("Math::MPFR::Rmpfr_coth", XS_Math__MPFR_Rmpfr_coth);
        newXS_deffile("Math::MPFR::Rmpfr_lngamma", XS_Math__MPFR_Rmpfr_lngamma);
        newXS_deffile("Math::MPFR::Rmpfr_lgamma", XS_Math__MPFR_Rmpfr_lgamma);
        newXS_deffile("Math::MPFR::_MPFR_VERSION", XS_Math__MPFR__MPFR_VERSION);
        newXS_deffile("Math::MPFR::_MPFR_VERSION_MAJOR", XS_Math__MPFR__MPFR_VERSION_MAJOR);
        newXS_deffile("Math::MPFR::_MPFR_VERSION_MINOR", XS_Math__MPFR__MPFR_VERSION_MINOR);
        newXS_deffile("Math::MPFR::_MPFR_VERSION_PATCHLEVEL", XS_Math__MPFR__MPFR_VERSION_PATCHLEVEL);
        newXS_deffile("Math::MPFR::_MPFR_VERSION_STRING", XS_Math__MPFR__MPFR_VERSION_STRING);
        newXS_deffile("Math::MPFR::RMPFR_VERSION_NUM", XS_Math__MPFR_RMPFR_VERSION_NUM);
        newXS_deffile("Math::MPFR::Rmpfr_sum", XS_Math__MPFR_Rmpfr_sum);
        newXS_deffile("Math::MPFR::overload_mul", XS_Math__MPFR_overload_mul);
        newXS_deffile("Math::MPFR::overload_add", XS_Math__MPFR_overload_add);
        newXS_deffile("Math::MPFR::overload_sub", XS_Math__MPFR_overload_sub);
        newXS_deffile("Math::MPFR::overload_div", XS_Math__MPFR_overload_div);
        newXS_deffile("Math::MPFR::overload_copy", XS_Math__MPFR_overload_copy);
        newXS_deffile("Math::MPFR::overload_abs", XS_Math__MPFR_overload_abs);
        newXS_deffile("Math::MPFR::overload_gt", XS_Math__MPFR_overload_gt);
        newXS_deffile("Math::MPFR::overload_gte", XS_Math__MPFR_overload_gte);
        newXS_deffile("Math::MPFR::overload_lt", XS_Math__MPFR_overload_lt);
        newXS_deffile("Math::MPFR::overload_lte", XS_Math__MPFR_overload_lte);
        newXS_deffile("Math::MPFR::overload_spaceship", XS_Math__MPFR_overload_spaceship);
        newXS_deffile("Math::MPFR::overload_equiv", XS_Math__MPFR_overload_equiv);
        newXS_deffile("Math::MPFR::overload_not_equiv", XS_Math__MPFR_overload_not_equiv);
        newXS_deffile("Math::MPFR::overload_true", XS_Math__MPFR_overload_true);
        newXS_deffile("Math::MPFR::overload_not", XS_Math__MPFR_overload_not);
        newXS_deffile("Math::MPFR::overload_sqrt", XS_Math__MPFR_overload_sqrt);
        newXS_deffile("Math::MPFR::overload_pow", XS_Math__MPFR_overload_pow);
        newXS_deffile("Math::MPFR::overload_log", XS_Math__MPFR_overload_log);
        newXS_deffile("Math::MPFR::overload_exp", XS_Math__MPFR_overload_exp);
        newXS_deffile("Math::MPFR::overload_sin", XS_Math__MPFR_overload_sin);
        newXS_deffile("Math::MPFR::overload_cos", XS_Math__MPFR_overload_cos);
        newXS_deffile("Math::MPFR::overload_int", XS_Math__MPFR_overload_int);
        newXS_deffile("Math::MPFR::overload_atan2", XS_Math__MPFR_overload_atan2);
        newXS_deffile("Math::MPFR::Rmpfr_randinit_default_nobless", XS_Math__MPFR_Rmpfr_randinit_default_nobless);
        newXS_deffile("Math::MPFR::Rmpfr_randinit_mt_nobless", XS_Math__MPFR_Rmpfr_randinit_mt_nobless);
        newXS_deffile("Math::MPFR::Rmpfr_randinit_lc_2exp_nobless", XS_Math__MPFR_Rmpfr_randinit_lc_2exp_nobless);
        newXS_deffile("Math::MPFR::Rmpfr_randinit_lc_2exp_size_nobless", XS_Math__MPFR_Rmpfr_randinit_lc_2exp_size_nobless);
        newXS_deffile("Math::MPFR::Rmpfr_randclear", XS_Math__MPFR_Rmpfr_randclear);
        newXS_deffile("Math::MPFR::Rmpfr_randseed", XS_Math__MPFR_Rmpfr_randseed);
        newXS_deffile("Math::MPFR::Rmpfr_randseed_ui", XS_Math__MPFR_Rmpfr_randseed_ui);
        newXS_deffile("Math::MPFR::overload_pow_eq", XS_Math__MPFR_overload_pow_eq);
        newXS_deffile("Math::MPFR::overload_div_eq", XS_Math__MPFR_overload_div_eq);
        newXS_deffile("Math::MPFR::overload_sub_eq", XS_Math__MPFR_overload_sub_eq);
        newXS_deffile("Math::MPFR::overload_add_eq", XS_Math__MPFR_overload_add_eq);
        newXS_deffile("Math::MPFR::overload_mul_eq", XS_Math__MPFR_overload_mul_eq);
        newXS_deffile("Math::MPFR::_itsa", XS_Math__MPFR__itsa);
        newXS_deffile("Math::MPFR::_has_longlong", XS_Math__MPFR__has_longlong);
        newXS_deffile("Math::MPFR::_has_longdouble", XS_Math__MPFR__has_longdouble);
        newXS_deffile("Math::MPFR::_ivsize_bits", XS_Math__MPFR__ivsize_bits);
        newXS_deffile("Math::MPFR::RMPFR_PREC_MAX", XS_Math__MPFR_RMPFR_PREC_MAX);
        newXS_deffile("Math::MPFR::RMPFR_PREC_MIN", XS_Math__MPFR_RMPFR_PREC_MIN);
        newXS_deffile("Math::MPFR::wrap_mpfr_printf", XS_Math__MPFR_wrap_mpfr_printf);
        newXS_deffile("Math::MPFR::wrap_mpfr_fprintf", XS_Math__MPFR_wrap_mpfr_fprintf);
        newXS_deffile("Math::MPFR::wrap_mpfr_sprintf", XS_Math__MPFR_wrap_mpfr_sprintf);
        newXS_deffile("Math::MPFR::wrap_mpfr_snprintf", XS_Math__MPFR_wrap_mpfr_snprintf);
        newXS_deffile("Math::MPFR::wrap_mpfr_printf_rnd", XS_Math__MPFR_wrap_mpfr_printf_rnd);
        newXS_deffile("Math::MPFR::wrap_mpfr_fprintf_rnd", XS_Math__MPFR_wrap_mpfr_fprintf_rnd);
        newXS_deffile("Math::MPFR::wrap_mpfr_sprintf_rnd", XS_Math__MPFR_wrap_mpfr_sprintf_rnd);
        newXS_deffile("Math::MPFR::wrap_mpfr_snprintf_rnd", XS_Math__MPFR_wrap_mpfr_snprintf_rnd);
        newXS_deffile("Math::MPFR::Rmpfr_buildopt_tls_p", XS_Math__MPFR_Rmpfr_buildopt_tls_p);
        newXS_deffile("Math::MPFR::Rmpfr_buildopt_decimal_p", XS_Math__MPFR_Rmpfr_buildopt_decimal_p);
        newXS_deffile("Math::MPFR::Rmpfr_regular_p", XS_Math__MPFR_Rmpfr_regular_p);
        newXS_deffile("Math::MPFR::Rmpfr_set_zero", XS_Math__MPFR_Rmpfr_set_zero);
        newXS_deffile("Math::MPFR::Rmpfr_digamma", XS_Math__MPFR_Rmpfr_digamma);
        newXS_deffile("Math::MPFR::Rmpfr_ai", XS_Math__MPFR_Rmpfr_ai);
        newXS_deffile("Math::MPFR::Rmpfr_get_flt", XS_Math__MPFR_Rmpfr_get_flt);
        newXS_deffile("Math::MPFR::Rmpfr_set_flt", XS_Math__MPFR_Rmpfr_set_flt);
        newXS_deffile("Math::MPFR::Rmpfr_urandom", XS_Math__MPFR_Rmpfr_urandom);
        newXS_deffile("Math::MPFR::Rmpfr_set_z_2exp", XS_Math__MPFR_Rmpfr_set_z_2exp);
        newXS_deffile("Math::MPFR::Rmpfr_buildopt_tune_case", XS_Math__MPFR_Rmpfr_buildopt_tune_case);
        newXS_deffile("Math::MPFR::Rmpfr_frexp", XS_Math__MPFR_Rmpfr_frexp);
        newXS_deffile("Math::MPFR::Rmpfr_z_sub", XS_Math__MPFR_Rmpfr_z_sub);
        newXS_deffile("Math::MPFR::Rmpfr_grandom", XS_Math__MPFR_Rmpfr_grandom);
        newXS_deffile("Math::MPFR::Rmpfr_clear_divby0", XS_Math__MPFR_Rmpfr_clear_divby0);
        newXS_deffile("Math::MPFR::Rmpfr_set_divby0", XS_Math__MPFR_Rmpfr_set_divby0);
        newXS_deffile("Math::MPFR::Rmpfr_divby0_p", XS_Math__MPFR_Rmpfr_divby0_p);
        newXS_deffile("Math::MPFR::Rmpfr_buildopt_gmpinternals_p", XS_Math__MPFR_Rmpfr_buildopt_gmpinternals_p);
        newXS_deffile("Math::MPFR::_get_xs_version", XS_Math__MPFR__get_xs_version);
        newXS_deffile("Math::MPFR::overload_inc", XS_Math__MPFR_overload_inc);
        newXS_deffile("Math::MPFR::overload_dec", XS_Math__MPFR_overload_dec);
        newXS_deffile("Math::MPFR::_wrap_count", XS_Math__MPFR__wrap_count);
        newXS_deffile("Math::MPFR::Rmpfr_set_LD", XS_Math__MPFR_Rmpfr_set_LD);
        newXS_deffile("Math::MPFR::Rmpfr_set_DECIMAL64", XS_Math__MPFR_Rmpfr_set_DECIMAL64);
        newXS_deffile("Math::MPFR::Rmpfr_get_LD", XS_Math__MPFR_Rmpfr_get_LD);
        newXS_deffile("Math::MPFR::Rmpfr_get_DECIMAL64", XS_Math__MPFR_Rmpfr_get_DECIMAL64);
        newXS_deffile("Math::MPFR::_MPFR_WANT_DECIMAL_FLOATS", XS_Math__MPFR__MPFR_WANT_DECIMAL_FLOATS);
        newXS_deffile("Math::MPFR::_MPFR_WANT_FLOAT128", XS_Math__MPFR__MPFR_WANT_FLOAT128);
        newXS_deffile("Math::MPFR::_max_base", XS_Math__MPFR__max_base);
        newXS_deffile("Math::MPFR::_isobject", XS_Math__MPFR__isobject);
        newXS_deffile("Math::MPFR::_mp_sizes", XS_Math__MPFR__mp_sizes);
        newXS_deffile("Math::MPFR::_ivsize", XS_Math__MPFR__ivsize);
        newXS_deffile("Math::MPFR::_nvsize", XS_Math__MPFR__nvsize);
        newXS_deffile("Math::MPFR::_FLT128_DIG", XS_Math__MPFR__FLT128_DIG);
        newXS_deffile("Math::MPFR::_LDBL_DIG", XS_Math__MPFR__LDBL_DIG);
        newXS_deffile("Math::MPFR::_DBL_DIG", XS_Math__MPFR__DBL_DIG);
        newXS_deffile("Math::MPFR::_FLT128_MANT_DIG", XS_Math__MPFR__FLT128_MANT_DIG);
        newXS_deffile("Math::MPFR::_LDBL_MANT_DIG", XS_Math__MPFR__LDBL_MANT_DIG);
        newXS_deffile("Math::MPFR::_DBL_MANT_DIG", XS_Math__MPFR__DBL_MANT_DIG);
        newXS_deffile("Math::MPFR::Rmpfr_get_float128", XS_Math__MPFR_Rmpfr_get_float128);
        newXS_deffile("Math::MPFR::Rmpfr_get_FLOAT128", XS_Math__MPFR_Rmpfr_get_FLOAT128);
        newXS_deffile("Math::MPFR::Rmpfr_set_FLOAT128", XS_Math__MPFR_Rmpfr_set_FLOAT128);
        newXS_deffile("Math::MPFR::Rmpfr_set_float128", XS_Math__MPFR_Rmpfr_set_float128);
        newXS_deffile("Math::MPFR::_is_readonly", XS_Math__MPFR__is_readonly);
        newXS_deffile("Math::MPFR::_readonly_on", XS_Math__MPFR__readonly_on);
        newXS_deffile("Math::MPFR::_readonly_off", XS_Math__MPFR__readonly_off);
        newXS_deffile("Math::MPFR::_can_pass_float128", XS_Math__MPFR__can_pass_float128);
        newXS_deffile("Math::MPFR::_mpfr_want_float128", XS_Math__MPFR__mpfr_want_float128);
        newXS_deffile("Math::MPFR::nnumflag", XS_Math__MPFR_nnumflag);
        newXS_deffile("Math::MPFR::clear_nnum", XS_Math__MPFR_clear_nnum);
        newXS_deffile("Math::MPFR::set_nnum", XS_Math__MPFR_set_nnum);
        newXS_deffile("Math::MPFR::_d_bytes", XS_Math__MPFR__d_bytes);
        newXS_deffile("Math::MPFR::_d_bytes_fr", XS_Math__MPFR__d_bytes_fr);
        newXS_deffile("Math::MPFR::_dd_bytes", XS_Math__MPFR__dd_bytes);
        newXS_deffile("Math::MPFR::_dd_bytes_fr", XS_Math__MPFR__dd_bytes_fr);
        newXS_deffile("Math::MPFR::_ld_bytes", XS_Math__MPFR__ld_bytes);
        newXS_deffile("Math::MPFR::_ld_bytes_fr", XS_Math__MPFR__ld_bytes_fr);
        newXS_deffile("Math::MPFR::_f128_bytes", XS_Math__MPFR__f128_bytes);
        newXS_deffile("Math::MPFR::_f128_bytes_fr", XS_Math__MPFR__f128_bytes_fr);
        newXS_deffile("Math::MPFR::_required_ldbl_mant_dig", XS_Math__MPFR__required_ldbl_mant_dig);
        newXS_deffile("Math::MPFR::_GMP_LIMB_BITS", XS_Math__MPFR__GMP_LIMB_BITS);
        newXS_deffile("Math::MPFR::_GMP_NAIL_BITS", XS_Math__MPFR__GMP_NAIL_BITS);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

